import{S as ev,i as tv,s as ov,e as s,k as d,w as _,t as n,M as nv,c as a,d as t,m as c,a as i,x as b,h as r,b as l,G as e,g as h,y as v,q as y,o as D,B as w,v as rv,L as ad}from"../../chunks/vendor-hf-doc-builder.js";import{T as Ou}from"../../chunks/Tip-hf-doc-builder.js";import{D as k}from"../../chunks/Docstring-hf-doc-builder.js";import{C as sn}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as we}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as sd}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";import{P as sv}from"../../chunks/PipelineTag-hf-doc-builder.js";function av(I){let f,E,T,u,x;return u=new sn({props:{code:`from transformers import DetrConfig, DetrModel

# Initializing a DETR facebook/detr-resnet-50 style configuration
configuration = DetrConfig()

# Initializing a model (with random weights) from the facebook/detr-resnet-50 style configuration
model = DetrModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrConfig, DetrModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a DETR facebook/detr-resnet-50 style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = DetrConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the facebook/detr-resnet-50 style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){f=s("p"),E=n("Examples:"),T=d(),_(u.$$.fragment)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Examples:"),g.forEach(t),T=c(p),b(u.$$.fragment,p)},m(p,g){h(p,f,g),e(f,E),h(p,T,g),v(u,p,g),x=!0},p:ad,i(p){x||(y(u.$$.fragment,p),x=!0)},o(p){D(u.$$.fragment,p),x=!1},d(p){p&&t(f),p&&t(T),w(u,p)}}}function iv(I){let f,E,T,u,x;return{c(){f=s("p"),E=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),T=s("code"),u=n("Module"),x=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),T=a(g,"CODE",{});var H=i(T);u=r(H,"Module"),H.forEach(t),x=r(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(t)},m(p,g){h(p,f,g),e(f,E),e(f,T),e(T,u),e(f,x)},d(p){p&&t(f)}}}function dv(I){let f,E,T,u,x;return u=new sn({props:{code:`from transformers import AutoImageProcessor, DetrModel
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("facebook/detr-resnet-50")
model = DetrModel.from_pretrained("facebook/detr-resnet-50")

# prepare image for the model
inputs = image_processor(images=image, return_tensors="pt")

# forward pass
outputs = model(**inputs)

# the last hidden states are the final query embeddings of the Transformer decoder
# these are of shape (batch_size, num_queries, hidden_size)
last_hidden_states = outputs.last_hidden_state
list(last_hidden_states.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, DetrModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrModel.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># prepare image for the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># the last hidden states are the final query embeddings of the Transformer decoder</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># these are of shape (batch_size, num_queries, hidden_size)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(last_hidden_states.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">100</span>, <span class="hljs-number">256</span>]`}}),{c(){f=s("p"),E=n("Examples:"),T=d(),_(u.$$.fragment)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Examples:"),g.forEach(t),T=c(p),b(u.$$.fragment,p)},m(p,g){h(p,f,g),e(f,E),h(p,T,g),v(u,p,g),x=!0},p:ad,i(p){x||(y(u.$$.fragment,p),x=!0)},o(p){D(u.$$.fragment,p),x=!1},d(p){p&&t(f),p&&t(T),w(u,p)}}}function cv(I){let f,E,T,u,x;return{c(){f=s("p"),E=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),T=s("code"),u=n("Module"),x=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),T=a(g,"CODE",{});var H=i(T);u=r(H,"Module"),H.forEach(t),x=r(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(t)},m(p,g){h(p,f,g),e(f,E),e(f,T),e(T,u),e(f,x)},d(p){p&&t(f)}}}function lv(I){let f,E,T,u,x;return u=new sn({props:{code:`from transformers import AutoImageProcessor, DetrForObjectDetection
import torch
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("facebook/detr-resnet-50")
model = DetrForObjectDetection.from_pretrained("facebook/detr-resnet-50")

inputs = image_processor(images=image, return_tensors="pt")
outputs = model(**inputs)

# convert outputs (bounding boxes and class logits) to COCO API
target_sizes = torch.tensor([image.size[::-1]])
results = image_processor.post_process_object_detection(outputs, threshold=0.9, target_sizes=target_sizes)[
    0
]

for score, label, box in zip(results["scores"], results["labels"], results["boxes"]):
    box = [round(i, 2) for i in box.tolist()]
    print(
        f"Detected {model.config.id2label[label.item()]} with confidence "
        f"{round(score.item(), 3)} at location {box}"
    )`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, DetrForObjectDetection
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># convert outputs (bounding boxes and class logits) to COCO API</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_sizes = torch.tensor([image.size[::-<span class="hljs-number">1</span>]])
<span class="hljs-meta">&gt;&gt;&gt; </span>results = image_processor.post_process_object_detection(outputs, threshold=<span class="hljs-number">0.9</span>, target_sizes=target_sizes)[
<span class="hljs-meta">... </span>    <span class="hljs-number">0</span>
<span class="hljs-meta">... </span>]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> score, label, box <span class="hljs-keyword">in</span> <span class="hljs-built_in">zip</span>(results[<span class="hljs-string">&quot;scores&quot;</span>], results[<span class="hljs-string">&quot;labels&quot;</span>], results[<span class="hljs-string">&quot;boxes&quot;</span>]):
<span class="hljs-meta">... </span>    box = [<span class="hljs-built_in">round</span>(i, <span class="hljs-number">2</span>) <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> box.tolist()]
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(
<span class="hljs-meta">... </span>        <span class="hljs-string">f&quot;Detected <span class="hljs-subst">{model.config.id2label[label.item()]}</span> with confidence &quot;</span>
<span class="hljs-meta">... </span>        <span class="hljs-string">f&quot;<span class="hljs-subst">{<span class="hljs-built_in">round</span>(score.item(), <span class="hljs-number">3</span>)}</span> at location <span class="hljs-subst">{box}</span>&quot;</span>
<span class="hljs-meta">... </span>    )
Detected remote <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.998</span> at location [<span class="hljs-number">40.16</span>, <span class="hljs-number">70.81</span>, <span class="hljs-number">175.55</span>, <span class="hljs-number">117.98</span>]
Detected remote <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.996</span> at location [<span class="hljs-number">333.24</span>, <span class="hljs-number">72.55</span>, <span class="hljs-number">368.33</span>, <span class="hljs-number">187.66</span>]
Detected couch <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.995</span> at location [-<span class="hljs-number">0.02</span>, <span class="hljs-number">1.15</span>, <span class="hljs-number">639.73</span>, <span class="hljs-number">473.76</span>]
Detected cat <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.999</span> at location [<span class="hljs-number">13.24</span>, <span class="hljs-number">52.05</span>, <span class="hljs-number">314.02</span>, <span class="hljs-number">470.93</span>]
Detected cat <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.999</span> at location [<span class="hljs-number">345.4</span>, <span class="hljs-number">23.85</span>, <span class="hljs-number">640.37</span>, <span class="hljs-number">368.72</span>]`}}),{c(){f=s("p"),E=n("Examples:"),T=d(),_(u.$$.fragment)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Examples:"),g.forEach(t),T=c(p),b(u.$$.fragment,p)},m(p,g){h(p,f,g),e(f,E),h(p,T,g),v(u,p,g),x=!0},p:ad,i(p){x||(y(u.$$.fragment,p),x=!0)},o(p){D(u.$$.fragment,p),x=!1},d(p){p&&t(f),p&&t(T),w(u,p)}}}function mv(I){let f,E,T,u,x;return{c(){f=s("p"),E=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),T=s("code"),u=n("Module"),x=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),T=a(g,"CODE",{});var H=i(T);u=r(H,"Module"),H.forEach(t),x=r(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(t)},m(p,g){h(p,f,g),e(f,E),e(f,T),e(T,u),e(f,x)},d(p){p&&t(f)}}}function hv(I){let f,E,T,u,x;return u=new sn({props:{code:`import io
import requests
from PIL import Image
import torch
import numpy

from transformers import AutoImageProcessor, DetrForSegmentation
from transformers.image_transforms import rgb_to_id

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("facebook/detr-resnet-50-panoptic")
model = DetrForSegmentation.from_pretrained("facebook/detr-resnet-50-panoptic")

# prepare image for the model
inputs = image_processor(images=image, return_tensors="pt")

# forward pass
outputs = model(**inputs)

# Use the \`post_process_panoptic_segmentation\` method of the \`image_processor\` to retrieve post-processed panoptic segmentation maps
# Segmentation results are returned as a list of dictionaries
result = image_processor.post_process_panoptic_segmentation(outputs, target_sizes=[(300, 500)])

# A tensor of shape (height, width) where each value denotes a segment id, filled with -1 if no segment is found
panoptic_seg = result[0]["segmentation"]
# Get prediction score and segment_id to class_id mapping of each segment
panoptic_segments_info = result[0]["segments_info"]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> io
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, DetrForSegmentation
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers.image_transforms <span class="hljs-keyword">import</span> rgb_to_id

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50-panoptic&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForSegmentation.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50-panoptic&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># prepare image for the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Use the \`post_process_panoptic_segmentation\` method of the \`image_processor\` to retrieve post-processed panoptic segmentation maps</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Segmentation results are returned as a list of dictionaries</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>result = image_processor.post_process_panoptic_segmentation(outputs, target_sizes=[(<span class="hljs-number">300</span>, <span class="hljs-number">500</span>)])

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># A tensor of shape (height, width) where each value denotes a segment id, filled with -1 if no segment is found</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>panoptic_seg = result[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;segmentation&quot;</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Get prediction score and segment_id to class_id mapping of each segment</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>panoptic_segments_info = result[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;segments_info&quot;</span>]`}}),{c(){f=s("p"),E=n("Examples:"),T=d(),_(u.$$.fragment)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Examples:"),g.forEach(t),T=c(p),b(u.$$.fragment,p)},m(p,g){h(p,f,g),e(f,E),h(p,T,g),v(u,p,g),x=!0},p:ad,i(p){x||(y(u.$$.fragment,p),x=!0)},o(p){D(u.$$.fragment,p),x=!1},d(p){p&&t(f),p&&t(T),w(u,p)}}}function pv(I){let f,E,T,u,x,p,g,H,id,xa,Te,He,fr,Rt,dd,ur,cd,Ea,Ge,ld,Mt,md,hd,$a,an,pd,ka,dn,gr,fd,ja,_e,ud,Ut,gd,_d,Ht,bd,vd,Fa,We,yd,cn,Dd,wd,Oa,j,Td,_r,xd,Ed,br,$d,kd,vr,jd,Fd,yr,Od,zd,Dr,Cd,Pd,wr,qd,Id,Tr,Nd,Ad,xr,Sd,Ld,za,P,Rd,Er,Md,Ud,$r,Hd,Gd,kr,Wd,Vd,jr,Bd,Yd,Fr,Qd,Jd,Or,Kd,Xd,Ca,J,Zd,zr,ec,tc,Gt,oc,nc,Wt,rc,sc,Pa,K,ac,ln,ic,dc,mn,cc,lc,hn,mc,hc,qa,pn,pc,Ia,F,ne,fc,Cr,uc,gc,Pr,_c,bc,fn,vc,yc,Dc,qr,wc,Tc,re,xc,Ir,Ec,$c,un,kc,jc,Nr,Fc,Oc,zc,se,Cc,Ar,Pc,qc,gn,Ic,Nc,Sr,Ac,Sc,Lc,B,Rc,Lr,Mc,Uc,Rr,Hc,Gc,Mr,Wc,Vc,Vt,Bc,Yc,Qc,N,_n,Jc,Kc,bn,Xc,Zc,Bt,el,tl,Ur,ol,nl,vn,rl,sl,Hr,al,il,dl,ae,cl,yn,ll,ml,Gr,hl,pl,Dn,fl,ul,gl,xe,_l,Wr,bl,vl,Yt,yl,Dl,Na,wn,wl,Aa,Tn,Tl,Sa,Qt,La,xn,xl,Ra,Jt,Ma,En,El,Ua,Kt,Ha,$n,$l,Ga,Ve,Vr,ie,Br,kl,jl,Yr,Fl,Ol,Qr,zl,Cl,Jr,Pl,ql,S,de,Kr,Xr,Il,Nl,Zr,Al,Sl,es,Ll,Rl,ts,Ml,Ul,ce,os,ns,Hl,Gl,rs,kn,Wl,Vl,ss,jn,Bl,Yl,as,Fn,Ql,Jl,le,is,ds,Kl,Xl,cs,Zl,em,ls,tm,om,ms,nm,rm,me,Xt,hs,sm,am,On,im,dm,Ee,cm,ps,lm,mm,fs,hm,pm,fm,L,um,us,gm,_m,gs,bm,vm,_s,ym,Dm,bs,wm,Tm,vs,xm,Em,$m,he,km,ys,jm,Fm,Ds,Om,zm,ws,Cm,Pm,qm,pe,zn,Ts,Im,Nm,Am,xs,Es,Sm,Lm,$s,ks,Rm,Mm,Zt,js,Um,Hm,Fs,Gm,Wm,fe,Os,zs,Vm,Bm,eo,Cs,Ym,Qm,Ps,Jm,Km,$e,qs,Xm,Zm,Is,eh,th,Ns,oh,nh,ue,As,rh,sh,Ss,ah,ih,Ls,dh,ch,Rs,lh,Wa,$,mh,Cn,hh,ph,Ms,fh,uh,Us,gh,_h,Hs,bh,vh,Pn,yh,Dh,Gs,wh,Th,Ws,xh,Eh,to,$h,kh,oo,jh,Fh,Va,ke,Be,Vs,no,Oh,Bs,zh,Ba,qn,Ch,Ya,ro,Qa,Ye,ge,Ph,In,qh,Ih,Nn,Nh,Ah,so,Sh,Lh,Rh,An,Mh,Sn,Uh,Ja,Ln,Hh,Ka,je,Qe,Ys,ao,Gh,Qs,Wh,Xa,Fe,io,Vh,Js,Bh,Za,Oe,co,Yh,lo,Qh,Rn,Jh,Kh,ei,ze,mo,Xh,ho,Zh,Mn,ep,tp,ti,Ce,Je,Ks,po,op,Xs,np,oi,Y,fo,rp,Pe,sp,Un,ap,ip,uo,dp,cp,lp,qe,mp,Hn,hp,pp,Gn,fp,up,gp,Ke,ni,Ie,Xe,Zs,go,_p,ea,bp,ri,z,_o,vp,ta,yp,Dp,Ze,bo,wp,oa,Tp,xp,et,vo,Ep,yo,$p,Wn,kp,jp,Fp,tt,Do,Op,wo,zp,Vn,Cp,Pp,qp,ot,To,Ip,xo,Np,Bn,Ap,Sp,Lp,nt,Eo,Rp,$o,Mp,Yn,Up,Hp,si,Ne,rt,na,ko,Gp,ra,Wp,ai,C,jo,Vp,st,Fo,Bp,sa,Yp,Qp,at,Oo,Jp,aa,Kp,Xp,it,zo,Zp,Co,ef,Qn,tf,of,nf,dt,Po,rf,qo,sf,Jn,af,df,cf,ct,Io,lf,No,mf,Kn,hf,pf,ff,lt,Ao,uf,So,gf,Xn,_f,bf,ii,Ae,mt,ia,Lo,vf,da,yf,di,R,Ro,Df,ca,wf,Tf,Mo,xf,Zn,Ef,$f,kf,Uo,jf,Ho,Ff,Of,zf,X,Go,Cf,Se,Pf,er,qf,If,la,Nf,Af,Sf,ht,Lf,pt,ci,Le,ft,ma,Wo,Rf,ha,Mf,li,M,Vo,Uf,pa,Hf,Gf,Bo,Wf,tr,Vf,Bf,Yf,Yo,Qf,Qo,Jf,Kf,Xf,Z,Jo,Zf,Re,eu,or,tu,ou,fa,nu,ru,su,ut,au,gt,mi,Me,_t,ua,Ko,iu,ga,du,hi,U,Xo,cu,_a,lu,mu,Zo,hu,nr,pu,fu,uu,en,gu,tn,_u,bu,vu,ee,on,yu,Ue,Du,rr,wu,Tu,ba,xu,Eu,$u,bt,ku,vt,pi;return p=new we({}),Rt=new we({}),Qt=new sn({props:{code:`from transformers import DetrForObjectDetection

model = DetrForObjectDetection.from_pretrained("facebook/detr-resnet-50")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrForObjectDetection

<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)`}}),Jt=new sn({props:{code:`from transformers import DetrConfig, DetrForObjectDetection

config = DetrConfig()
model = DetrForObjectDetection(config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrConfig, DetrForObjectDetection

<span class="hljs-meta">&gt;&gt;&gt; </span>config = DetrConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection(config)`}}),Kt=new sn({props:{code:`config = DetrConfig(use_pretrained_backbone=False)
model = DetrForObjectDetection(config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>config = DetrConfig(use_pretrained_backbone=<span class="hljs-literal">False</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection(config)`}}),no=new we({}),ro=new sv({props:{pipeline:"object-detection"}}),ao=new we({}),io=new k({props:{name:"class transformers.models.detr.modeling_detr.DetrModelOutput",anchor:"transformers.models.detr.modeling_detr.DetrModelOutput",parameters:[{name:"last_hidden_state",val:": FloatTensor = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"intermediate_hidden_states",val:": typing.Optional[torch.FloatTensor] = None"}],parametersDescription:[{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) &#x2014;
Sequence of hidden-states at the output of the last layer of the decoder of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.`,name:"decoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"decoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder&#x2019;s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.`,name:"cross_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder of the model.`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.`,name:"encoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"encoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.intermediate_hidden_states",description:`<strong>intermediate_hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(config.decoder_layers, batch_size, sequence_length, hidden_size)</code>, <em>optional</em>, returned when <code>config.auxiliary_loss=True</code>) &#x2014;
Intermediate decoder activations, i.e. the output of each decoder layer, each of them gone through a
layernorm.`,name:"intermediate_hidden_states"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L96"}}),co=new k({props:{name:"class transformers.models.detr.modeling_detr.DetrObjectDetectionOutput",anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput",parameters:[{name:"loss",val:": typing.Optional[torch.FloatTensor] = None"},{name:"loss_dict",val:": typing.Optional[typing.Dict] = None"},{name:"logits",val:": FloatTensor = None"},{name:"pred_boxes",val:": FloatTensor = None"},{name:"auxiliary_outputs",val:": typing.Optional[typing.List[typing.Dict]] = None"},{name:"last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.loss",description:`<strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) &#x2014;
Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.`,name:"loss"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.loss_dict",description:`<strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
A dictionary containing the individual losses. Useful for logging.`,name:"loss_dict"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.logits",description:`<strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) &#x2014;
Classification logits (including no-object) for all queries.`,name:"logits"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.pred_boxes",description:`<strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) &#x2014;
Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection">post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.`,name:"pred_boxes"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.auxiliary_outputs",description:`<strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) &#x2014;
Optional, only returned when auxilary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.`,name:"auxiliary_outputs"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the decoder of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.`,name:"decoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"decoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder&#x2019;s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.`,name:"cross_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder of the model.`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.`,name:"encoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"encoder_attentions"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L136"}}),mo=new k({props:{name:"class transformers.models.detr.modeling_detr.DetrSegmentationOutput",anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput",parameters:[{name:"loss",val:": typing.Optional[torch.FloatTensor] = None"},{name:"loss_dict",val:": typing.Optional[typing.Dict] = None"},{name:"logits",val:": FloatTensor = None"},{name:"pred_boxes",val:": FloatTensor = None"},{name:"pred_masks",val:": FloatTensor = None"},{name:"auxiliary_outputs",val:": typing.Optional[typing.List[typing.Dict]] = None"},{name:"last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.loss",description:`<strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) &#x2014;
Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.`,name:"loss"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.loss_dict",description:`<strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
A dictionary containing the individual losses. Useful for logging.`,name:"loss_dict"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.logits",description:`<strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) &#x2014;
Classification logits (including no-object) for all queries.`,name:"logits"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.pred_boxes",description:`<strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) &#x2014;
Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection">post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.`,name:"pred_boxes"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.pred_masks",description:`<strong>pred_masks</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, height/4, width/4)</code>) &#x2014;
Segmentation masks logits for all queries. See also
<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_semantic_segmentation">post_process_semantic_segmentation()</a> or
<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_instance_segmentation">post_process_instance_segmentation()</a>
<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_panoptic_segmentation">post_process_panoptic_segmentation()</a> to evaluate semantic, instance and panoptic
segmentation masks respectively.`,name:"pred_masks"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.auxiliary_outputs",description:`<strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) &#x2014;
Optional, only returned when auxiliary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.`,name:"auxiliary_outputs"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the decoder of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.`,name:"decoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"decoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder&#x2019;s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.`,name:"cross_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder of the model.`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.`,name:"encoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"encoder_attentions"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L199"}}),po=new we({}),fo=new k({props:{name:"class transformers.DetrConfig",anchor:"transformers.DetrConfig",parameters:[{name:"use_timm_backbone",val:" = True"},{name:"backbone_config",val:" = None"},{name:"num_channels",val:" = 3"},{name:"num_queries",val:" = 100"},{name:"encoder_layers",val:" = 6"},{name:"encoder_ffn_dim",val:" = 2048"},{name:"encoder_attention_heads",val:" = 8"},{name:"decoder_layers",val:" = 6"},{name:"decoder_ffn_dim",val:" = 2048"},{name:"decoder_attention_heads",val:" = 8"},{name:"encoder_layerdrop",val:" = 0.0"},{name:"decoder_layerdrop",val:" = 0.0"},{name:"is_encoder_decoder",val:" = True"},{name:"activation_function",val:" = 'relu'"},{name:"d_model",val:" = 256"},{name:"dropout",val:" = 0.1"},{name:"attention_dropout",val:" = 0.0"},{name:"activation_dropout",val:" = 0.0"},{name:"init_std",val:" = 0.02"},{name:"init_xavier_std",val:" = 1.0"},{name:"auxiliary_loss",val:" = False"},{name:"position_embedding_type",val:" = 'sine'"},{name:"backbone",val:" = 'resnet50'"},{name:"use_pretrained_backbone",val:" = True"},{name:"dilation",val:" = False"},{name:"class_cost",val:" = 1"},{name:"bbox_cost",val:" = 5"},{name:"giou_cost",val:" = 2"},{name:"mask_loss_coefficient",val:" = 1"},{name:"dice_loss_coefficient",val:" = 1"},{name:"bbox_loss_coefficient",val:" = 5"},{name:"giou_loss_coefficient",val:" = 2"},{name:"eos_coefficient",val:" = 0.1"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetrConfig.use_timm_backbone",description:`<strong>use_timm_backbone</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to use the <code>timm</code> library for the backbone. If set to <code>False</code>, will use the <code>AutoBackbone</code>
API.`,name:"use_timm_backbone"},{anchor:"transformers.DetrConfig.backbone_config",description:`<strong>backbone_config</strong> (<code>PretrainedConfig</code> or <code>dict</code>, <em>optional</em>) &#x2014;
The configuration of the backbone model. Only used in case <code>use_timm_backbone</code> is set to <code>False</code> in which
case it will default to <code>ResNetConfig()</code>.`,name:"backbone_config"},{anchor:"transformers.DetrConfig.num_channels",description:`<strong>num_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of input channels.`,name:"num_channels"},{anchor:"transformers.DetrConfig.num_queries",description:`<strong>num_queries</strong> (<code>int</code>, <em>optional</em>, defaults to 100) &#x2014;
Number of object queries, i.e. detection slots. This is the maximal number of objects <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrModel">DetrModel</a> can
detect in a single image. For COCO, we recommend 100 queries.`,name:"num_queries"},{anchor:"transformers.DetrConfig.d_model",description:`<strong>d_model</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimension of the layers.`,name:"d_model"},{anchor:"transformers.DetrConfig.encoder_layers",description:`<strong>encoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 6) &#x2014;
Number of encoder layers.`,name:"encoder_layers"},{anchor:"transformers.DetrConfig.decoder_layers",description:`<strong>decoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 6) &#x2014;
Number of decoder layers.`,name:"decoder_layers"},{anchor:"transformers.DetrConfig.encoder_attention_heads",description:`<strong>encoder_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"encoder_attention_heads"},{anchor:"transformers.DetrConfig.decoder_attention_heads",description:`<strong>decoder_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer in the Transformer decoder.`,name:"decoder_attention_heads"},{anchor:"transformers.DetrConfig.decoder_ffn_dim",description:`<strong>decoder_ffn_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimension of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in decoder.`,name:"decoder_ffn_dim"},{anchor:"transformers.DetrConfig.encoder_ffn_dim",description:`<strong>encoder_ffn_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimension of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in decoder.`,name:"encoder_ffn_dim"},{anchor:"transformers.DetrConfig.activation_function",description:`<strong>activation_function</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;relu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;silu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"activation_function"},{anchor:"transformers.DetrConfig.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"dropout"},{anchor:"transformers.DetrConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.DetrConfig.activation_dropout",description:`<strong>activation_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for activations inside the fully connected layer.`,name:"activation_dropout"},{anchor:"transformers.DetrConfig.init_std",description:`<strong>init_std</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"init_std"},{anchor:"transformers.DetrConfig.init_xavier_std",description:`<strong>init_xavier_std</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
The scaling factor used for the Xavier initialization gain in the HM Attention map module.`,name:"init_xavier_std"},{anchor:"transformers.DetrConfig.encoder_layerdrop",description:`<strong>encoder_layerdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The LayerDrop probability for the encoder. See the [LayerDrop paper](see <a href="https://arxiv.org/abs/1909.11556" rel="nofollow">https://arxiv.org/abs/1909.11556</a>)
for more details.`,name:"encoder_layerdrop"},{anchor:"transformers.DetrConfig.decoder_layerdrop",description:`<strong>decoder_layerdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The LayerDrop probability for the decoder. See the [LayerDrop paper](see <a href="https://arxiv.org/abs/1909.11556" rel="nofollow">https://arxiv.org/abs/1909.11556</a>)
for more details.`,name:"decoder_layerdrop"},{anchor:"transformers.DetrConfig.auxiliary_loss",description:`<strong>auxiliary_loss</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether auxiliary decoding losses (loss at each decoder layer) are to be used.`,name:"auxiliary_loss"},{anchor:"transformers.DetrConfig.position_embedding_type",description:`<strong>position_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;sine&quot;</code>) &#x2014;
Type of position embeddings to be used on top of the image features. One of <code>&quot;sine&quot;</code> or <code>&quot;learned&quot;</code>.`,name:"position_embedding_type"},{anchor:"transformers.DetrConfig.backbone",description:`<strong>backbone</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;resnet50&quot;</code>) &#x2014;
Name of convolutional backbone to use in case <code>use_timm_backbone</code> = <code>True</code>. Supports any convolutional
backbone from the timm package. For a list of all available models, see <a href="https://rwightman.github.io/pytorch-image-models/#load-a-pretrained-model" rel="nofollow">this
page</a>.`,name:"backbone"},{anchor:"transformers.DetrConfig.use_pretrained_backbone",description:`<strong>use_pretrained_backbone</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to use pretrained weights for the backbone. Only supported when <code>use_timm_backbone</code> = <code>True</code>.`,name:"use_pretrained_backbone"},{anchor:"transformers.DetrConfig.dilation",description:`<strong>dilation</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to replace stride with dilation in the last convolutional block (DC5). Only supported when
<code>use_timm_backbone</code> = <code>True</code>.`,name:"dilation"},{anchor:"transformers.DetrConfig.class_cost",description:`<strong>class_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the classification error in the Hungarian matching cost.`,name:"class_cost"},{anchor:"transformers.DetrConfig.bbox_cost",description:`<strong>bbox_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 5) &#x2014;
Relative weight of the L1 error of the bounding box coordinates in the Hungarian matching cost.`,name:"bbox_cost"},{anchor:"transformers.DetrConfig.giou_cost",description:`<strong>giou_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 2) &#x2014;
Relative weight of the generalized IoU loss of the bounding box in the Hungarian matching cost.`,name:"giou_cost"},{anchor:"transformers.DetrConfig.mask_loss_coefficient",description:`<strong>mask_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the Focal loss in the panoptic segmentation loss.`,name:"mask_loss_coefficient"},{anchor:"transformers.DetrConfig.dice_loss_coefficient",description:`<strong>dice_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the DICE/F-1 loss in the panoptic segmentation loss.`,name:"dice_loss_coefficient"},{anchor:"transformers.DetrConfig.bbox_loss_coefficient",description:`<strong>bbox_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 5) &#x2014;
Relative weight of the L1 bounding box loss in the object detection loss.`,name:"bbox_loss_coefficient"},{anchor:"transformers.DetrConfig.giou_loss_coefficient",description:`<strong>giou_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 2) &#x2014;
Relative weight of the generalized IoU loss in the object detection loss.`,name:"giou_loss_coefficient"},{anchor:"transformers.DetrConfig.eos_coefficient",description:`<strong>eos_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
Relative classification weight of the &#x2018;no-object&#x2019; class in the object detection loss.`,name:"eos_coefficient"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/configuration_detr.py#L36"}}),Ke=new sd({props:{anchor:"transformers.DetrConfig.example",$$slots:{default:[av]},$$scope:{ctx:I}}}),go=new we({}),_o=new k({props:{name:"class transformers.DetrImageProcessor",anchor:"transformers.DetrImageProcessor",parameters:[{name:"format",val:": typing.Union[str, transformers.models.detr.image_processing_detr.AnnotionFormat] = <AnnotionFormat.COCO_DETECTION: 'coco_detection'>"},{name:"do_resize",val:": bool = True"},{name:"size",val:": typing.Dict[str, int] = None"},{name:"resample",val:": Resampling = <Resampling.BILINEAR: 2>"},{name:"do_rescale",val:": bool = True"},{name:"rescale_factor",val:": typing.Union[int, float] = 0.00392156862745098"},{name:"do_normalize",val:": bool = True"},{name:"image_mean",val:": typing.Union[float, typing.List[float]] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float]] = None"},{name:"do_pad",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.format",description:`<strong>format</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;coco_detection&quot;</code>) &#x2014;
Data format of the annotations. One of &#x201C;coco_detection&#x201D; or &#x201C;coco_panoptic&#x201D;.`,name:"format"},{anchor:"transformers.DetrImageProcessor.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Controls whether to resize the image&#x2019;s <code>(height, width)</code> dimensions to the specified <code>size</code>. Can be
overridden by the <code>do_resize</code> parameter in the <code>preprocess</code> method.`,name:"do_resize"},{anchor:"transformers.DetrImageProcessor.size",description:`<strong>size</strong> (<code>Dict[str, int]</code> <em>optional</em>, defaults to <code>{&quot;shortest_edge&quot; -- 800, &quot;longest_edge&quot;: 1333}</code>):
Size of the image&#x2019;s <code>(height, width)</code> dimensions after resizing. Can be overridden by the <code>size</code> parameter
in the <code>preprocess</code> method.`,name:"size"},{anchor:"transformers.DetrImageProcessor.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to <code>PILImageResampling.BILINEAR</code>) &#x2014;
Resampling filter to use if resizing the image.`,name:"resample"},{anchor:"transformers.DetrImageProcessor.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Controls whether to rescale the image by the specified scale <code>rescale_factor</code>. Can be overridden by the
<code>do_rescale</code> parameter in the <code>preprocess</code> method.`,name:"do_rescale"},{anchor:"transformers.DetrImageProcessor.rescale_factor",description:`<strong>rescale_factor</strong> (<code>int</code> or <code>float</code>, <em>optional</em>, defaults to <code>1/255</code>) &#x2014;
Scale factor to use if rescaling the image. Can be overridden by the <code>rescale_factor</code> parameter in the
<code>preprocess</code> method.
do_normalize &#x2014;
Controls whether to normalize the image. Can be overridden by the <code>do_normalize</code> parameter in the
<code>preprocess</code> method.`,name:"rescale_factor"},{anchor:"transformers.DetrImageProcessor.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_DEFAULT_MEAN</code>) &#x2014;
Mean values to use when normalizing the image. Can be a single value or a list of values, one for each
channel. Can be overridden by the <code>image_mean</code> parameter in the <code>preprocess</code> method.`,name:"image_mean"},{anchor:"transformers.DetrImageProcessor.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_DEFAULT_STD</code>) &#x2014;
Standard deviation values to use when normalizing the image. Can be a single value or a list of values, one
for each channel. Can be overridden by the <code>image_std</code> parameter in the <code>preprocess</code> method.`,name:"image_std"},{anchor:"transformers.DetrImageProcessor.do_pad",description:`<strong>do_pad</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Controls whether to pad the image to the largest image in a batch and create a pixel mask. Can be
overridden by the <code>do_pad</code> parameter in the <code>preprocess</code> method.`,name:"do_pad"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/image_processing_detr.py#L724"}}),bo=new k({props:{name:"preprocess",anchor:"transformers.DetrImageProcessor.preprocess",parameters:[{name:"images",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]"},{name:"annotations",val:": typing.Union[typing.Dict[str, typing.Union[int, str, typing.List[typing.Dict]]], typing.List[typing.Dict[str, typing.Union[int, str, typing.List[typing.Dict]]]], NoneType] = None"},{name:"return_segmentation_masks",val:": bool = None"},{name:"masks_path",val:": typing.Union[str, pathlib.Path, NoneType] = None"},{name:"do_resize",val:": typing.Optional[bool] = None"},{name:"size",val:": typing.Union[typing.Dict[str, int], NoneType] = None"},{name:"resample",val:" = None"},{name:"do_rescale",val:": typing.Optional[bool] = None"},{name:"rescale_factor",val:": typing.Union[int, float, NoneType] = None"},{name:"do_normalize",val:": typing.Optional[bool] = None"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"do_pad",val:": typing.Optional[bool] = None"},{name:"format",val:": typing.Union[str, transformers.models.detr.image_processing_detr.AnnotionFormat, NoneType] = None"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension] = <ChannelDimension.FIRST: 'channels_first'>"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.preprocess.images",description:`<strong>images</strong> (<code>ImageInput</code>) &#x2014;
Image or batch of images to preprocess.`,name:"images"},{anchor:"transformers.DetrImageProcessor.preprocess.annotations",description:`<strong>annotations</strong> (<code>AnnotationType</code> or <code>List[AnnotationType]</code>, <em>optional</em>) &#x2014;
List of annotations associated with the image or batch of images. If annotionation is for object
detection, the annotations should be a dictionary with the following keys:<ul>
<li>&#x201C;image_id&#x201D; (<code>int</code>): The image id.</li>
<li>&#x201C;annotations&#x201D; (<code>List[Dict]</code>): List of annotations for an image. Each annotation should be a
dictionary. An image can have no annotations, in which case the list should be empty.
If annotionation is for segmentation, the annotations should be a dictionary with the following keys:</li>
<li>&#x201C;image_id&#x201D; (<code>int</code>): The image id.</li>
<li>&#x201C;segments_info&#x201D; (<code>List[Dict]</code>): List of segments for an image. Each segment should be a dictionary.
An image can have no segments, in which case the list should be empty.</li>
<li>&#x201C;file_name&#x201D; (<code>str</code>): The file name of the image.</li>
</ul>`,name:"annotations"},{anchor:"transformers.DetrImageProcessor.preprocess.return_segmentation_masks",description:`<strong>return_segmentation_masks</strong> (<code>bool</code>, <em>optional</em>, defaults to self.return_segmentation_masks) &#x2014;
Whether to return segmentation masks.`,name:"return_segmentation_masks"},{anchor:"transformers.DetrImageProcessor.preprocess.masks_path",description:`<strong>masks_path</strong> (<code>str</code> or <code>pathlib.Path</code>, <em>optional</em>) &#x2014;
Path to the directory containing the segmentation masks.`,name:"masks_path"},{anchor:"transformers.DetrImageProcessor.preprocess.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_resize) &#x2014;
Whether to resize the image.`,name:"do_resize"},{anchor:"transformers.DetrImageProcessor.preprocess.size",description:`<strong>size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to self.size) &#x2014;
Size of the image after resizing.`,name:"size"},{anchor:"transformers.DetrImageProcessor.preprocess.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to self.resample) &#x2014;
Resampling filter to use when resizing the image.`,name:"resample"},{anchor:"transformers.DetrImageProcessor.preprocess.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_rescale) &#x2014;
Whether to rescale the image.`,name:"do_rescale"},{anchor:"transformers.DetrImageProcessor.preprocess.rescale_factor",description:`<strong>rescale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to self.rescale_factor) &#x2014;
Rescale factor to use when rescaling the image.`,name:"rescale_factor"},{anchor:"transformers.DetrImageProcessor.preprocess.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_normalize) &#x2014;
Whether to normalize the image.`,name:"do_normalize"},{anchor:"transformers.DetrImageProcessor.preprocess.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to self.image_mean) &#x2014;
Mean to use when normalizing the image.`,name:"image_mean"},{anchor:"transformers.DetrImageProcessor.preprocess.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to self.image_std) &#x2014;
Standard deviation to use when normalizing the image.`,name:"image_std"},{anchor:"transformers.DetrImageProcessor.preprocess.do_pad",description:`<strong>do_pad</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_pad) &#x2014;
Whether to pad the image.`,name:"do_pad"},{anchor:"transformers.DetrImageProcessor.preprocess.format",description:`<strong>format</strong> (<code>str</code> or <code>AnnotionFormat</code>, <em>optional</em>, defaults to self.format) &#x2014;
Format of the annotations.`,name:"format"},{anchor:"transformers.DetrImageProcessor.preprocess.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <code>TensorType</code>, <em>optional</em>, defaults to self.return_tensors) &#x2014;
Type of tensors to return. If <code>None</code>, will return the list of images.`,name:"return_tensors"},{anchor:"transformers.DetrImageProcessor.preprocess.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>, defaults to self.data_format) &#x2014;
The channel dimension format of the image. If not provided, it will be the same as the input image.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/image_processing_detr.py#L1040"}}),vo=new k({props:{name:"post_process_object_detection",anchor:"transformers.DetrImageProcessor.post_process_object_detection",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"target_sizes",val:": typing.Union[transformers.utils.generic.TensorType, typing.List[typing.Tuple]] = None"}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.post_process_object_detection.outputs",description:`<strong>outputs</strong> (<code>DetrObjectDetectionOutput</code>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrImageProcessor.post_process_object_detection.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Score threshold to keep object detection predictions.`,name:"threshold"},{anchor:"transformers.DetrImageProcessor.post_process_object_detection.target_sizes",description:`<strong>target_sizes</strong> (<code>torch.Tensor</code> or <code>List[Tuple[int, int]]</code>, <em>optional</em>) &#x2014;
Tensor of shape <code>(batch_size, 2)</code> or list of tuples (<code>Tuple[int, int]</code>) containing the target size
<code>(height, width)</code> of each image in the batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/image_processing_detr.py#L1524",returnDescription:`
<p>A list of dictionaries, each dictionary containing the scores, labels and boxes for an image
in the batch as predicted by the model.</p>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),Do=new k({props:{name:"post_process_semantic_segmentation",anchor:"transformers.DetrImageProcessor.post_process_semantic_segmentation",parameters:[{name:"outputs",val:""},{name:"target_sizes",val:": typing.List[typing.Tuple[int, int]] = None"}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.post_process_semantic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrImageProcessor.post_process_semantic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple[int, int]]</code>, <em>optional</em>) &#x2014;
A list of tuples (<code>Tuple[int, int]</code>) containing the target size (height, width) of each image in the
batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/image_processing_detr.py#L1577",returnDescription:`
<p>A list of length <code>batch_size</code>, where each item is a semantic segmentation map of shape (height, width)
corresponding to the target_sizes entry (if <code>target_sizes</code> is specified). Each entry of each
<code>torch.Tensor</code> correspond to a semantic class id.</p>
`,returnType:`
<p><code>List[torch.Tensor]</code></p>
`}}),To=new k({props:{name:"post_process_instance_segmentation",anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"},{name:"return_coco_annotation",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction. If unset, predictions will not be resized.`,name:"target_sizes"},{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.return_coco_annotation",description:`<strong>return_coco_annotation</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Defaults to <code>False</code>. If set to <code>True</code>, segmentation maps are returned in COCO run-length encoding (RLE)
format.`,name:"return_coco_annotation"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/image_processing_detr.py#L1625",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 A tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>List[List]</code> run-length encoding (RLE) of the segmentation map if return_coco_annotation is set to
<code>True</code>. Set to <code>None</code> if no mask if found above <code>threshold</code>.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 An integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),Eo=new k({props:{name:"post_process_panoptic_segmentation",anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"label_ids_to_fuse",val:": typing.Optional[typing.Set[int]] = None"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
The outputs from <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>.`,name:"outputs"},{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.label_ids_to_fuse",description:`<strong>label_ids_to_fuse</strong> (<code>Set[int]</code>, <em>optional</em>) &#x2014;
The labels in this state will have all their instances be fused together. For instance we could say
there can only be one sky in an image, but several persons, so the label ID for sky would be in that
set, but not the one for person.`,name:"label_ids_to_fuse"},{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction in batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/image_processing_detr.py#L1709",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 a tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>None</code> if no mask if found above <code>threshold</code>. If <code>target_sizes</code> is specified, segmentation is resized to
the corresponding <code>target_sizes</code> entry.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 an integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>was_fused</strong> \u2014 a boolean, <code>True</code> if <code>label_id</code> was in <code>label_ids_to_fuse</code>, <code>False</code> otherwise.
Multiple instances of the same class / label were fused and assigned a single <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),ko=new we({}),jo=new k({props:{name:"class transformers.DetrFeatureExtractor",anchor:"transformers.DetrFeatureExtractor",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/feature_extraction_detr.py#L26"}}),Fo=new k({props:{name:"__call__",anchor:"transformers.DetrFeatureExtractor.__call__",parameters:[{name:"images",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_processing_utils.py#L456"}}),Oo=new k({props:{name:"pad_and_create_pixel_mask",anchor:"transformers.DetrFeatureExtractor.pad_and_create_pixel_mask",parameters:[{name:"pixel_values_list",val:": typing.List[typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]]"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"data_format",val:": typing.Optional[transformers.image_utils.ChannelDimension] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.pad_and_create_pixel_mask.images",description:`<strong>images</strong> (<code>List[np.ndarray]</code>) &#x2014;
Batch of images to pad.`,name:"images"},{anchor:"transformers.DetrFeatureExtractor.pad_and_create_pixel_mask.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <code>TensorType</code>, <em>optional</em>) &#x2014;
The type of tensors to return. Can be one of:<ul>
<li>Unset: Return a list of <code>np.ndarray</code>.</li>
<li><code>TensorType.TENSORFLOW</code> or <code>&apos;tf&apos;</code>: Return a batch of type <code>tf.Tensor</code>.</li>
<li><code>TensorType.PYTORCH</code> or <code>&apos;pt&apos;</code>: Return a batch of type <code>torch.Tensor</code>.</li>
<li><code>TensorType.NUMPY</code> or <code>&apos;np&apos;</code>: Return a batch of type <code>np.ndarray</code>.</li>
<li><code>TensorType.JAX</code> or <code>&apos;jax&apos;</code>: Return a batch of type <code>jax.numpy.ndarray</code>.</li>
</ul>`,name:"return_tensors"},{anchor:"transformers.DetrFeatureExtractor.pad_and_create_pixel_mask.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format of the image. If not provided, it will be the same as the input image.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/image_processing_detr.py#L946"}}),zo=new k({props:{name:"post_process_object_detection",anchor:"transformers.DetrFeatureExtractor.post_process_object_detection",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"target_sizes",val:": typing.Union[transformers.utils.generic.TensorType, typing.List[typing.Tuple]] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_object_detection.outputs",description:`<strong>outputs</strong> (<code>DetrObjectDetectionOutput</code>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_object_detection.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Score threshold to keep object detection predictions.`,name:"threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_object_detection.target_sizes",description:`<strong>target_sizes</strong> (<code>torch.Tensor</code> or <code>List[Tuple[int, int]]</code>, <em>optional</em>) &#x2014;
Tensor of shape <code>(batch_size, 2)</code> or list of tuples (<code>Tuple[int, int]</code>) containing the target size
<code>(height, width)</code> of each image in the batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/image_processing_detr.py#L1524",returnDescription:`
<p>A list of dictionaries, each dictionary containing the scores, labels and boxes for an image
in the batch as predicted by the model.</p>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),Po=new k({props:{name:"post_process_semantic_segmentation",anchor:"transformers.DetrFeatureExtractor.post_process_semantic_segmentation",parameters:[{name:"outputs",val:""},{name:"target_sizes",val:": typing.List[typing.Tuple[int, int]] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_semantic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_semantic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple[int, int]]</code>, <em>optional</em>) &#x2014;
A list of tuples (<code>Tuple[int, int]</code>) containing the target size (height, width) of each image in the
batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/image_processing_detr.py#L1577",returnDescription:`
<p>A list of length <code>batch_size</code>, where each item is a semantic segmentation map of shape (height, width)
corresponding to the target_sizes entry (if <code>target_sizes</code> is specified). Each entry of each
<code>torch.Tensor</code> correspond to a semantic class id.</p>
`,returnType:`
<p><code>List[torch.Tensor]</code></p>
`}}),Io=new k({props:{name:"post_process_instance_segmentation",anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"},{name:"return_coco_annotation",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction. If unset, predictions will not be resized.`,name:"target_sizes"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.return_coco_annotation",description:`<strong>return_coco_annotation</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Defaults to <code>False</code>. If set to <code>True</code>, segmentation maps are returned in COCO run-length encoding (RLE)
format.`,name:"return_coco_annotation"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/image_processing_detr.py#L1625",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 A tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>List[List]</code> run-length encoding (RLE) of the segmentation map if return_coco_annotation is set to
<code>True</code>. Set to <code>None</code> if no mask if found above <code>threshold</code>.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 An integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),Ao=new k({props:{name:"post_process_panoptic_segmentation",anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"label_ids_to_fuse",val:": typing.Optional[typing.Set[int]] = None"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
The outputs from <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.label_ids_to_fuse",description:`<strong>label_ids_to_fuse</strong> (<code>Set[int]</code>, <em>optional</em>) &#x2014;
The labels in this state will have all their instances be fused together. For instance we could say
there can only be one sky in an image, but several persons, so the label ID for sky would be in that
set, but not the one for person.`,name:"label_ids_to_fuse"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction in batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/image_processing_detr.py#L1709",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 a tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>None</code> if no mask if found above <code>threshold</code>. If <code>target_sizes</code> is specified, segmentation is resized to
the corresponding <code>target_sizes</code> entry.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 an integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>was_fused</strong> \u2014 a boolean, <code>True</code> if <code>label_id</code> was in <code>label_ids_to_fuse</code>, <code>False</code> otherwise.
Multiple instances of the same class / label were fused and assigned a single <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),Lo=new we({}),Ro=new k({props:{name:"class transformers.DetrModel",anchor:"transformers.DetrModel",parameters:[{name:"config",val:": DetrConfig"}],parametersDescription:[{anchor:"transformers.DetrModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig">DetrConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1201"}}),Go=new k({props:{name:"forward",anchor:"transformers.DetrModel.forward",parameters:[{name:"pixel_values",val:""},{name:"pixel_mask",val:" = None"},{name:"decoder_attention_mask",val:" = None"},{name:"encoder_outputs",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"decoder_inputs_embeds",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.DetrModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it.</p>
<p>Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See <a href="/docs/transformers/main/en/model_doc/vit#transformers.ViTFeatureExtractor.__call__">DetrImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.DetrModel.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.DetrModel.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_queries)</code>, <em>optional</em>) &#x2014;
Not used by default. Can be used to mask object queries.`,name:"decoder_attention_mask"},{anchor:"transformers.DetrModel.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.DetrModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing the flattened feature map (output of the backbone + projection layer), you
can choose to directly pass a flattened representation of an image.`,name:"inputs_embeds"},{anchor:"transformers.DetrModel.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of initializing the queries with a tensor of zeros, you can choose to directly pass an
embedded representation.`,name:"decoder_inputs_embeds"},{anchor:"transformers.DetrModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DetrModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DetrModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1235",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrModelOutput"
>transformers.models.detr.modeling_detr.DetrModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"
>DetrConfig</a>) and inputs.</p>
<ul>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</li>
<li><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>intermediate_hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(config.decoder_layers, batch_size, sequence_length, hidden_size)</code>, <em>optional</em>, returned when <code>config.auxiliary_loss=True</code>) \u2014 Intermediate decoder activations, i.e. the output of each decoder layer, each of them gone through a
layernorm.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrModelOutput"
>transformers.models.detr.modeling_detr.DetrModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ht=new Ou({props:{$$slots:{default:[iv]},$$scope:{ctx:I}}}),pt=new sd({props:{anchor:"transformers.DetrModel.forward.example",$$slots:{default:[dv]},$$scope:{ctx:I}}}),Wo=new we({}),Vo=new k({props:{name:"class transformers.DetrForObjectDetection",anchor:"transformers.DetrForObjectDetection",parameters:[{name:"config",val:": DetrConfig"}],parametersDescription:[{anchor:"transformers.DetrForObjectDetection.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig">DetrConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1369"}}),Jo=new k({props:{name:"forward",anchor:"transformers.DetrForObjectDetection.forward",parameters:[{name:"pixel_values",val:""},{name:"pixel_mask",val:" = None"},{name:"decoder_attention_mask",val:" = None"},{name:"encoder_outputs",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"decoder_inputs_embeds",val:" = None"},{name:"labels",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.DetrForObjectDetection.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it.</p>
<p>Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See <a href="/docs/transformers/main/en/model_doc/vit#transformers.ViTFeatureExtractor.__call__">DetrImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.DetrForObjectDetection.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.DetrForObjectDetection.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_queries)</code>, <em>optional</em>) &#x2014;
Not used by default. Can be used to mask object queries.`,name:"decoder_attention_mask"},{anchor:"transformers.DetrForObjectDetection.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.DetrForObjectDetection.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing the flattened feature map (output of the backbone + projection layer), you
can choose to directly pass a flattened representation of an image.`,name:"inputs_embeds"},{anchor:"transformers.DetrForObjectDetection.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of initializing the queries with a tensor of zeros, you can choose to directly pass an
embedded representation.`,name:"decoder_inputs_embeds"},{anchor:"transformers.DetrForObjectDetection.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DetrForObjectDetection.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DetrForObjectDetection.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.DetrForObjectDetection.forward.labels",description:`<strong>labels</strong> (<code>List[Dict]</code> of len <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the bipartite matching loss. List of dicts, each dictionary containing at least the
following 2 keys: &#x2018;class_labels&#x2019; and &#x2018;boxes&#x2019; (the class labels and bounding boxes of an image in the batch
respectively). The class labels themselves should be a <code>torch.LongTensor</code> of len <code>(number of bounding boxes in the image,)</code> and the boxes a <code>torch.FloatTensor</code> of shape <code>(number of bounding boxes in the image, 4)</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1395",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrObjectDetectionOutput"
>transformers.models.detr.modeling_detr.DetrObjectDetectionOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"
>DetrConfig</a>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) \u2014 Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.</li>
<li><strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) \u2014 A dictionary containing the individual losses. Useful for logging.</li>
<li><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) \u2014 Classification logits (including no-object) for all queries.</li>
<li><strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) \u2014 Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection"
>post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.</li>
<li><strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) \u2014 Optional, only returned when auxilary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.</li>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</li>
<li><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrObjectDetectionOutput"
>transformers.models.detr.modeling_detr.DetrObjectDetectionOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ut=new Ou({props:{$$slots:{default:[cv]},$$scope:{ctx:I}}}),gt=new sd({props:{anchor:"transformers.DetrForObjectDetection.forward.example",$$slots:{default:[lv]},$$scope:{ctx:I}}}),Ko=new we({}),Xo=new k({props:{name:"class transformers.DetrForSegmentation",anchor:"transformers.DetrForSegmentation",parameters:[{name:"config",val:": DetrConfig"}],parametersDescription:[{anchor:"transformers.DetrForSegmentation.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig">DetrConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1543"}}),on=new k({props:{name:"forward",anchor:"transformers.DetrForSegmentation.forward",parameters:[{name:"pixel_values",val:""},{name:"pixel_mask",val:" = None"},{name:"decoder_attention_mask",val:" = None"},{name:"encoder_outputs",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"decoder_inputs_embeds",val:" = None"},{name:"labels",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.DetrForSegmentation.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it.</p>
<p>Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See <a href="/docs/transformers/main/en/model_doc/vit#transformers.ViTFeatureExtractor.__call__">DetrImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.DetrForSegmentation.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.DetrForSegmentation.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_queries)</code>, <em>optional</em>) &#x2014;
Not used by default. Can be used to mask object queries.`,name:"decoder_attention_mask"},{anchor:"transformers.DetrForSegmentation.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.DetrForSegmentation.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing the flattened feature map (output of the backbone + projection layer), you
can choose to directly pass a flattened representation of an image.`,name:"inputs_embeds"},{anchor:"transformers.DetrForSegmentation.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of initializing the queries with a tensor of zeros, you can choose to directly pass an
embedded representation.`,name:"decoder_inputs_embeds"},{anchor:"transformers.DetrForSegmentation.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DetrForSegmentation.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DetrForSegmentation.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.DetrForSegmentation.forward.labels",description:`<strong>labels</strong> (<code>List[Dict]</code> of len <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the bipartite matching loss, DICE/F-1 loss and Focal loss. List of dicts, each
dictionary containing at least the following 3 keys: &#x2018;class_labels&#x2019;, &#x2018;boxes&#x2019; and &#x2018;masks&#x2019; (the class labels,
bounding boxes and segmentation masks of an image in the batch respectively). The class labels themselves
should be a <code>torch.LongTensor</code> of len <code>(number of bounding boxes in the image,)</code>, the boxes a
<code>torch.FloatTensor</code> of shape <code>(number of bounding boxes in the image, 4)</code> and the masks a
<code>torch.FloatTensor</code> of shape <code>(number of bounding boxes in the image, height, width)</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1565",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrSegmentationOutput"
>transformers.models.detr.modeling_detr.DetrSegmentationOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"
>DetrConfig</a>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) \u2014 Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.</li>
<li><strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) \u2014 A dictionary containing the individual losses. Useful for logging.</li>
<li><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) \u2014 Classification logits (including no-object) for all queries.</li>
<li><strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) \u2014 Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection"
>post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.</li>
<li><strong>pred_masks</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, height/4, width/4)</code>) \u2014 Segmentation masks logits for all queries. See also
<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_semantic_segmentation"
>post_process_semantic_segmentation()</a> or
<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_instance_segmentation"
>post_process_instance_segmentation()</a>
<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_panoptic_segmentation"
>post_process_panoptic_segmentation()</a> to evaluate semantic, instance and panoptic
segmentation masks respectively.</li>
<li><strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) \u2014 Optional, only returned when auxiliary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.</li>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</li>
<li><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrSegmentationOutput"
>transformers.models.detr.modeling_detr.DetrSegmentationOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),bt=new Ou({props:{$$slots:{default:[mv]},$$scope:{ctx:I}}}),vt=new sd({props:{anchor:"transformers.DetrForSegmentation.forward.example",$$slots:{default:[hv]},$$scope:{ctx:I}}}),{c(){f=s("meta"),E=d(),T=s("h1"),u=s("a"),x=s("span"),_(p.$$.fragment),g=d(),H=s("span"),id=n("DETR"),xa=d(),Te=s("h2"),He=s("a"),fr=s("span"),_(Rt.$$.fragment),dd=d(),ur=s("span"),cd=n("Overview"),Ea=d(),Ge=s("p"),ld=n("The DETR model was proposed in "),Mt=s("a"),md=n("End-to-End Object Detection with Transformers"),hd=n(` by
Nicolas Carion, Francisco Massa, Gabriel Synnaeve, Nicolas Usunier, Alexander Kirillov and Sergey Zagoruyko. DETR
consists of a convolutional backbone followed by an encoder-decoder Transformer which can be trained end-to-end for
object detection. It greatly simplifies a lot of the complexity of models like Faster-R-CNN and Mask-R-CNN, which use
things like region proposals, non-maximum suppression procedure and anchor generation. Moreover, DETR can also be
naturally extended to perform panoptic segmentation, by simply adding a mask head on top of the decoder outputs.`),$a=d(),an=s("p"),pd=n("The abstract from the paper is the following:"),ka=d(),dn=s("p"),gr=s("em"),fd=n(`We present a new method that views object detection as a direct set prediction problem. Our approach streamlines the
detection pipeline, effectively removing the need for many hand-designed components like a non-maximum suppression
procedure or anchor generation that explicitly encode our prior knowledge about the task. The main ingredients of the
new framework, called DEtection TRansformer or DETR, are a set-based global loss that forces unique predictions via
bipartite matching, and a transformer encoder-decoder architecture. Given a fixed small set of learned object queries,
DETR reasons about the relations of the objects and the global image context to directly output the final set of
predictions in parallel. The new model is conceptually simple and does not require a specialized library, unlike many
other modern detectors. DETR demonstrates accuracy and run-time performance on par with the well-established and
highly-optimized Faster RCNN baseline on the challenging COCO object detection dataset. Moreover, DETR can be easily
generalized to produce panoptic segmentation in a unified manner. We show that it significantly outperforms competitive
baselines.`),ja=d(),_e=s("p"),ud=n("This model was contributed by "),Ut=s("a"),gd=n("nielsr"),_d=n(". The original code can be found "),Ht=s("a"),bd=n("here"),vd=n("."),Fa=d(),We=s("p"),yd=n("Here\u2019s a TLDR explaining how "),cn=s("a"),Dd=n("DetrForObjectDetection"),wd=n(" works:"),Oa=d(),j=s("p"),Td=n(`First, an image is sent through a pre-trained convolutional backbone (in the paper, the authors use
ResNet-50/ResNet-101). Let\u2019s assume we also add a batch dimension. This means that the input to the backbone is a
tensor of shape `),_r=s("code"),xd=n("(batch_size, 3, height, width)"),Ed=n(`, assuming the image has 3 color channels (RGB). The CNN backbone
outputs a new lower-resolution feature map, typically of shape `),br=s("code"),$d=n("(batch_size, 2048, height/32, width/32)"),kd=n(`. This is
then projected to match the hidden dimension of the Transformer of DETR, which is `),vr=s("code"),jd=n("256"),Fd=n(` by default, using a
`),yr=s("code"),Od=n("nn.Conv2D"),zd=n(" layer. So now, we have a tensor of shape "),Dr=s("code"),Cd=n("(batch_size, 256, height/32, width/32)."),Pd=n(` Next, the
feature map is flattened and transposed to obtain a tensor of shape `),wr=s("code"),qd=n("(batch_size, seq_len, d_model)"),Id=n(` =
`),Tr=s("code"),Nd=n("(batch_size, width/32*height/32, 256)"),Ad=n(`. So a difference with NLP models is that the sequence length is actually
longer than usual, but with a smaller `),xr=s("code"),Sd=n("d_model"),Ld=n(" (which in NLP is typically 768 or higher)."),za=d(),P=s("p"),Rd=n("Next, this is sent through the encoder, outputting "),Er=s("code"),Md=n("encoder_hidden_states"),Ud=n(` of the same shape (you can consider
these as image features). Next, so-called `),$r=s("strong"),Hd=n("object queries"),Gd=n(` are sent through the decoder. This is a tensor of shape
`),kr=s("code"),Wd=n("(batch_size, num_queries, d_model)"),Vd=n(", with "),jr=s("code"),Bd=n("num_queries"),Yd=n(` typically set to 100 and initialized with zeros.
These input embeddings are learnt positional encodings that the authors refer to as object queries, and similarly to
the encoder, they are added to the input of each attention layer. Each object query will look for a particular object
in the image. The decoder updates these embeddings through multiple self-attention and encoder-decoder attention layers
to output `),Fr=s("code"),Qd=n("decoder_hidden_states"),Jd=n(" of the same shape: "),Or=s("code"),Kd=n("(batch_size, num_queries, d_model)"),Xd=n(`. Next, two heads
are added on top for object detection: a linear layer for classifying each object query into one of the objects or \u201Cno
object\u201D, and a MLP to predict bounding boxes for each query.`),Ca=d(),J=s("p"),Zd=n("The model is trained using a "),zr=s("strong"),ec=n("bipartite matching loss"),tc=n(`: so what we actually do is compare the predicted classes +
bounding boxes of each of the N = 100 object queries to the ground truth annotations, padded up to the same length N
(so if an image only contains 4 objects, 96 annotations will just have a \u201Cno object\u201D as class and \u201Cno bounding box\u201D as
bounding box). The `),Gt=s("a"),oc=n("Hungarian matching algorithm"),nc=n(` is used to find
an optimal one-to-one mapping of each of the N queries to each of the N annotations. Next, standard cross-entropy (for
the classes) and a linear combination of the L1 and `),Wt=s("a"),rc=n("generalized IoU loss"),sc=n(` (for the
bounding boxes) are used to optimize the parameters of the model.`),Pa=d(),K=s("p"),ac=n(`DETR can be naturally extended to perform panoptic segmentation (which unifies semantic segmentation and instance
segmentation). `),ln=s("a"),ic=n("DetrForSegmentation"),dc=n(` adds a segmentation mask head on top of
`),mn=s("a"),cc=n("DetrForObjectDetection"),lc=n(`. The mask head can be trained either jointly, or in a two steps process,
where one first trains a `),hn=s("a"),mc=n("DetrForObjectDetection"),hc=n(` model to detect bounding boxes around both
\u201Cthings\u201D (instances) and \u201Cstuff\u201D (background things like trees, roads, sky), then freeze all the weights and train only
the mask head for 25 epochs. Experimentally, these two approaches give similar results. Note that predicting boxes is
required for the training to be possible, since the Hungarian matching is computed using distances between boxes.`),qa=d(),pn=s("p"),pc=n("Tips:"),Ia=d(),F=s("ul"),ne=s("li"),fc=n("DETR uses so-called "),Cr=s("strong"),uc=n("object queries"),gc=n(` to detect objects in an image. The number of queries determines the maximum
number of objects that can be detected in a single image, and is set to 100 by default (see parameter
`),Pr=s("code"),_c=n("num_queries"),bc=n(" of "),fn=s("a"),vc=n("DetrConfig"),yc=n(`). Note that it\u2019s good to have some slack (in COCO, the
authors used 100, while the maximum number of objects in a COCO image is ~70).`),Dc=d(),qr=s("li"),wc=n(`The decoder of DETR updates the query embeddings in parallel. This is different from language models like GPT-2,
which use autoregressive decoding instead of parallel. Hence, no causal attention mask is used.`),Tc=d(),re=s("li"),xc=n(`DETR adds position embeddings to the hidden states at each self-attention and cross-attention layer before projecting
to queries and keys. For the position embeddings of the image, one can choose between fixed sinusoidal or learned
absolute position embeddings. By default, the parameter `),Ir=s("code"),Ec=n("position_embedding_type"),$c=n(` of
`),un=s("a"),kc=n("DetrConfig"),jc=n(" is set to "),Nr=s("code"),Fc=n('"sine"'),Oc=n("."),zc=d(),se=s("li"),Cc=n(`During training, the authors of DETR did find it helpful to use auxiliary losses in the decoder, especially to help
the model output the correct number of objects of each class. If you set the parameter `),Ar=s("code"),Pc=n("auxiliary_loss"),qc=n(` of
`),gn=s("a"),Ic=n("DetrConfig"),Nc=n(" to "),Sr=s("code"),Ac=n("True"),Sc=n(`, then prediction feedforward neural networks and Hungarian losses
are added after each decoder layer (with the FFNs sharing parameters).`),Lc=d(),B=s("li"),Rc=n(`If you want to train the model in a distributed environment across multiple nodes, then one should update the
`),Lr=s("em"),Mc=n("num_boxes"),Uc=n(" variable in the "),Rr=s("em"),Hc=n("DetrLoss"),Gc=n(" class of "),Mr=s("em"),Wc=n("modeling_detr.py"),Vc=n(`. When training on multiple nodes, this should be
set to the average number of target boxes across all nodes, as can be seen in the original implementation `),Vt=s("a"),Bc=n("here"),Yc=n("."),Qc=d(),N=s("li"),_n=s("a"),Jc=n("DetrForObjectDetection"),Kc=n(" and "),bn=s("a"),Xc=n("DetrForSegmentation"),Zc=n(` can be initialized with
any convolutional backbone available in the `),Bt=s("a"),el=n("timm library"),tl=n(`.
Initializing with a MobileNet backbone for example can be done by setting the `),Ur=s("code"),ol=n("backbone"),nl=n(` attribute of
`),vn=s("a"),rl=n("DetrConfig"),sl=n(" to "),Hr=s("code"),al=n('"tf_mobilenetv3_small_075"'),il=n(`, and then initializing the model with that
config.`),dl=d(),ae=s("li"),cl=n(`DETR resizes the input images such that the shortest side is at least a certain amount of pixels while the longest is
at most 1333 pixels. At training time, scale augmentation is used such that the shortest side is randomly set to at
least 480 and at most 800 pixels. At inference time, the shortest side is set to 800. One can use
`),yn=s("a"),ll=n("DetrImageProcessor"),ml=n(` to prepare images (and optional annotations in COCO format) for the
model. Due to this resizing, images in a batch can have different sizes. DETR solves this by padding images up to the
largest size in a batch, and by creating a pixel mask that indicates which pixels are real/which are padding.
Alternatively, one can also define a custom `),Gr=s("code"),hl=n("collate_fn"),pl=n(` in order to batch images together, using
`),Dn=s("a"),fl=n("pad_and_create_pixel_mask()"),ul=n("."),gl=d(),xe=s("li"),_l=n("The size of the images will determine the amount of memory being used, and will thus determine the "),Wr=s("code"),bl=n("batch_size"),vl=n(`.
It is advised to use a batch size of 2 per GPU. See `),Yt=s("a"),yl=n("this Github thread"),Dl=n(" for more info."),Na=d(),wn=s("p"),wl=n("There are three ways to instantiate a DETR model (depending on what you prefer):"),Aa=d(),Tn=s("p"),Tl=n("Option 1: Instantiate DETR with pre-trained weights for entire model"),Sa=d(),_(Qt.$$.fragment),La=d(),xn=s("p"),xl=n("Option 2: Instantiate DETR with randomly initialized weights for Transformer, but pre-trained weights for backbone"),Ra=d(),_(Jt.$$.fragment),Ma=d(),En=s("p"),El=n("Option 3: Instantiate DETR with randomly initialized weights for backbone + Transformer"),Ua=d(),_(Kt.$$.fragment),Ha=d(),$n=s("p"),$l=n("As a summary, consider the following table:"),Ga=d(),Ve=s("table"),Vr=s("thead"),ie=s("tr"),Br=s("th"),kl=n("Task"),jl=d(),Yr=s("th"),Fl=n("Object detection"),Ol=d(),Qr=s("th"),zl=n("Instance segmentation"),Cl=d(),Jr=s("th"),Pl=n("Panoptic segmentation"),ql=d(),S=s("tbody"),de=s("tr"),Kr=s("td"),Xr=s("strong"),Il=n("Description"),Nl=d(),Zr=s("td"),Al=n("Predicting bounding boxes and class labels around objects in an image"),Sl=d(),es=s("td"),Ll=n("Predicting masks around objects (i.e. instances) in an image"),Rl=d(),ts=s("td"),Ml=n("Predicting masks around both objects (i.e. instances) as well as \u201Cstuff\u201D (i.e. background things like trees and roads) in an image"),Ul=d(),ce=s("tr"),os=s("td"),ns=s("strong"),Hl=n("Model"),Gl=d(),rs=s("td"),kn=s("a"),Wl=n("DetrForObjectDetection"),Vl=d(),ss=s("td"),jn=s("a"),Bl=n("DetrForSegmentation"),Yl=d(),as=s("td"),Fn=s("a"),Ql=n("DetrForSegmentation"),Jl=d(),le=s("tr"),is=s("td"),ds=s("strong"),Kl=n("Example dataset"),Xl=d(),cs=s("td"),Zl=n("COCO detection"),em=d(),ls=s("td"),tm=n("COCO detection, COCO panoptic"),om=d(),ms=s("td"),nm=n("COCO panoptic"),rm=d(),me=s("tr"),Xt=s("td"),hs=s("strong"),sm=n("Format of annotations to provide to"),am=d(),On=s("a"),im=n("DetrImageProcessor"),dm=d(),Ee=s("td"),cm=n("{\u2018image_id\u2019: "),ps=s("code"),lm=n("int"),mm=n(", \u2018annotations\u2019: "),fs=s("code"),hm=n("List[Dict]"),pm=n("} each Dict being a COCO object annotation"),fm=d(),L=s("td"),um=n("{\u2018image_id\u2019: "),us=s("code"),gm=n("int"),_m=n(", \u2018annotations\u2019: "),gs=s("code"),bm=n("List[Dict]"),vm=n("}  (in case of COCO detection) or {\u2018file_name\u2019: "),_s=s("code"),ym=n("str"),Dm=n(", \u2018image_id\u2019: "),bs=s("code"),wm=n("int"),Tm=n(", \u2018segments_info\u2019: "),vs=s("code"),xm=n("List[Dict]"),Em=n("} (in case of COCO panoptic)"),$m=d(),he=s("td"),km=n("{\u2018file_name\u2019: "),ys=s("code"),jm=n("str"),Fm=n(", \u2018image_id\u2019: "),Ds=s("code"),Om=n("int"),zm=n(", \u2018segments_info\u2019: "),ws=s("code"),Cm=n("List[Dict]"),Pm=n("} and masks_path (path to directory containing PNG files of the masks)"),qm=d(),pe=s("tr"),zn=s("td"),Ts=s("strong"),Im=n("Postprocessing"),Nm=n(" (i.e. converting the output of the model to COCO API)"),Am=d(),xs=s("td"),Es=s("code"),Sm=n("post_process()"),Lm=d(),$s=s("td"),ks=s("code"),Rm=n("post_process_segmentation()"),Mm=d(),Zt=s("td"),js=s("code"),Um=n("post_process_segmentation()"),Hm=n(", "),Fs=s("code"),Gm=n("post_process_panoptic()"),Wm=d(),fe=s("tr"),Os=s("td"),zs=s("strong"),Vm=n("evaluators"),Bm=d(),eo=s("td"),Cs=s("code"),Ym=n("CocoEvaluator"),Qm=n(" with "),Ps=s("code"),Jm=n('iou_types="bbox"'),Km=d(),$e=s("td"),qs=s("code"),Xm=n("CocoEvaluator"),Zm=n(" with "),Is=s("code"),eh=n('iou_types="bbox"'),th=n(" or "),Ns=s("code"),oh=n('"segm"'),nh=d(),ue=s("td"),As=s("code"),rh=n("CocoEvaluator"),sh=n(" with "),Ss=s("code"),ah=n('iou_tupes="bbox"'),ih=n(" or "),Ls=s("code"),dh=n('"segm"'),ch=n(", "),Rs=s("code"),lh=n("PanopticEvaluator"),Wa=d(),$=s("p"),mh=n(`In short, one should prepare the data either in COCO detection or COCO panoptic format, then use
`),Cn=s("a"),hh=n("DetrImageProcessor"),ph=n(" to create "),Ms=s("code"),fh=n("pixel_values"),uh=n(", "),Us=s("code"),gh=n("pixel_mask"),_h=n(` and optional
`),Hs=s("code"),bh=n("labels"),vh=n(`, which can then be used to train (or fine-tune) a model. For evaluation, one should first convert the
outputs of the model using one of the postprocessing methods of `),Pn=s("a"),yh=n("DetrImageProcessor"),Dh=n(`. These can
be be provided to either `),Gs=s("code"),wh=n("CocoEvaluator"),Th=n(" or "),Ws=s("code"),xh=n("PanopticEvaluator"),Eh=n(`, which allow you to calculate metrics like
mean Average Precision (mAP) and Panoptic Quality (PQ). The latter objects are implemented in the `),to=s("a"),$h=n("original repository"),kh=n(". See the "),oo=s("a"),jh=n("example notebooks"),Fh=n(" for more info regarding evaluation."),Va=d(),ke=s("h2"),Be=s("a"),Vs=s("span"),_(no.$$.fragment),Oh=d(),Bs=s("span"),zh=n("Resources"),Ba=d(),qn=s("p"),Ch=n("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with DETR."),Ya=d(),_(ro.$$.fragment),Qa=d(),Ye=s("ul"),ge=s("li"),Ph=n("All example notebooks illustrating fine-tuning "),In=s("a"),qh=n("DetrForObjectDetection"),Ih=n(" and "),Nn=s("a"),Nh=n("DetrForSegmentation"),Ah=n(" on a custom dataset an be found "),so=s("a"),Sh=n("here"),Lh=n("."),Rh=d(),An=s("li"),Mh=n("See also: "),Sn=s("a"),Uh=n("Object detection task guide"),Ja=d(),Ln=s("p"),Hh=n("If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Ka=d(),je=s("h2"),Qe=s("a"),Ys=s("span"),_(ao.$$.fragment),Gh=d(),Qs=s("span"),Wh=n("DETR specific outputs"),Xa=d(),Fe=s("div"),_(io.$$.fragment),Vh=d(),Js=s("p"),Bh=n(`Base class for outputs of the DETR encoder-decoder model. This class adds one attribute to Seq2SeqModelOutput,
namely an optional stack of intermediate decoder activations, i.e. the output of each decoder layer, each of them
gone through a layernorm. This is useful when training the model with auxiliary decoding losses.`),Za=d(),Oe=s("div"),_(co.$$.fragment),Yh=d(),lo=s("p"),Qh=n("Output type of "),Rn=s("a"),Jh=n("DetrForObjectDetection"),Kh=n("."),ei=d(),ze=s("div"),_(mo.$$.fragment),Xh=d(),ho=s("p"),Zh=n("Output type of "),Mn=s("a"),ep=n("DetrForSegmentation"),tp=n("."),ti=d(),Ce=s("h2"),Je=s("a"),Ks=s("span"),_(po.$$.fragment),op=d(),Xs=s("span"),np=n("DetrConfig"),oi=d(),Y=s("div"),_(fo.$$.fragment),rp=d(),Pe=s("p"),sp=n("This is the configuration class to store the configuration of a "),Un=s("a"),ap=n("DetrModel"),ip=n(`. It is used to instantiate a DETR
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the DETR
`),uo=s("a"),dp=n("facebook/detr-resnet-50"),cp=n(" architecture."),lp=d(),qe=s("p"),mp=n("Configuration objects inherit from "),Hn=s("a"),hp=n("PretrainedConfig"),pp=n(` and can be used to control the model outputs. Read the
documentation from `),Gn=s("a"),fp=n("PretrainedConfig"),up=n(" for more information."),gp=d(),_(Ke.$$.fragment),ni=d(),Ie=s("h2"),Xe=s("a"),Zs=s("span"),_(go.$$.fragment),_p=d(),ea=s("span"),bp=n("DetrImageProcessor"),ri=d(),z=s("div"),_(_o.$$.fragment),vp=d(),ta=s("p"),yp=n("Constructs a Detr image processor."),Dp=d(),Ze=s("div"),_(bo.$$.fragment),wp=d(),oa=s("p"),Tp=n("Preprocess an image or a batch of images so that it can be used by the model."),xp=d(),et=s("div"),_(vo.$$.fragment),Ep=d(),yo=s("p"),$p=n("Converts the raw output of "),Wn=s("a"),kp=n("DetrForObjectDetection"),jp=n(` into final bounding boxes in (top_left_x, top_left_y,
bottom_right_x, bottom_right_y) format. Only supports PyTorch.`),Fp=d(),tt=s("div"),_(Do.$$.fragment),Op=d(),wo=s("p"),zp=n("Converts the output of "),Vn=s("a"),Cp=n("DetrForSegmentation"),Pp=n(" into semantic segmentation maps. Only supports PyTorch."),qp=d(),ot=s("div"),_(To.$$.fragment),Ip=d(),xo=s("p"),Np=n("Converts the output of "),Bn=s("a"),Ap=n("DetrForSegmentation"),Sp=n(" into instance segmentation predictions. Only supports PyTorch."),Lp=d(),nt=s("div"),_(Eo.$$.fragment),Rp=d(),$o=s("p"),Mp=n("Converts the output of "),Yn=s("a"),Up=n("DetrForSegmentation"),Hp=n(` into image panoptic segmentation predictions. Only supports
PyTorch.`),si=d(),Ne=s("h2"),rt=s("a"),na=s("span"),_(ko.$$.fragment),Gp=d(),ra=s("span"),Wp=n("DetrFeatureExtractor"),ai=d(),C=s("div"),_(jo.$$.fragment),Vp=d(),st=s("div"),_(Fo.$$.fragment),Bp=d(),sa=s("p"),Yp=n("Preprocess an image or a batch of images."),Qp=d(),at=s("div"),_(Oo.$$.fragment),Jp=d(),aa=s("p"),Kp=n(`Pads a batch of images with zeros to the size of largest height and width in the batch and returns their
corresponding pixel mask.`),Xp=d(),it=s("div"),_(zo.$$.fragment),Zp=d(),Co=s("p"),ef=n("Converts the raw output of "),Qn=s("a"),tf=n("DetrForObjectDetection"),of=n(` into final bounding boxes in (top_left_x, top_left_y,
bottom_right_x, bottom_right_y) format. Only supports PyTorch.`),nf=d(),dt=s("div"),_(Po.$$.fragment),rf=d(),qo=s("p"),sf=n("Converts the output of "),Jn=s("a"),af=n("DetrForSegmentation"),df=n(" into semantic segmentation maps. Only supports PyTorch."),cf=d(),ct=s("div"),_(Io.$$.fragment),lf=d(),No=s("p"),mf=n("Converts the output of "),Kn=s("a"),hf=n("DetrForSegmentation"),pf=n(" into instance segmentation predictions. Only supports PyTorch."),ff=d(),lt=s("div"),_(Ao.$$.fragment),uf=d(),So=s("p"),gf=n("Converts the output of "),Xn=s("a"),_f=n("DetrForSegmentation"),bf=n(` into image panoptic segmentation predictions. Only supports
PyTorch.`),ii=d(),Ae=s("h2"),mt=s("a"),ia=s("span"),_(Lo.$$.fragment),vf=d(),da=s("span"),yf=n("DetrModel"),di=d(),R=s("div"),_(Ro.$$.fragment),Df=d(),ca=s("p"),wf=n(`The bare DETR Model (consisting of a backbone and encoder-decoder Transformer) outputting raw hidden-states without
any specific head on top.`),Tf=d(),Mo=s("p"),xf=n("This model inherits from "),Zn=s("a"),Ef=n("PreTrainedModel"),$f=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),kf=d(),Uo=s("p"),jf=n("This model is also a PyTorch "),Ho=s("a"),Ff=n("torch.nn.Module"),Of=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),zf=d(),X=s("div"),_(Go.$$.fragment),Cf=d(),Se=s("p"),Pf=n("The "),er=s("a"),qf=n("DetrModel"),If=n(" forward method, overrides the "),la=s("code"),Nf=n("__call__"),Af=n(" special method."),Sf=d(),_(ht.$$.fragment),Lf=d(),_(pt.$$.fragment),ci=d(),Le=s("h2"),ft=s("a"),ma=s("span"),_(Wo.$$.fragment),Rf=d(),ha=s("span"),Mf=n("DetrForObjectDetection"),li=d(),M=s("div"),_(Vo.$$.fragment),Uf=d(),pa=s("p"),Hf=n(`DETR Model (consisting of a backbone and encoder-decoder Transformer) with object detection heads on top, for tasks
such as COCO detection.`),Gf=d(),Bo=s("p"),Wf=n("This model inherits from "),tr=s("a"),Vf=n("PreTrainedModel"),Bf=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Yf=d(),Yo=s("p"),Qf=n("This model is also a PyTorch "),Qo=s("a"),Jf=n("torch.nn.Module"),Kf=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Xf=d(),Z=s("div"),_(Jo.$$.fragment),Zf=d(),Re=s("p"),eu=n("The "),or=s("a"),tu=n("DetrForObjectDetection"),ou=n(" forward method, overrides the "),fa=s("code"),nu=n("__call__"),ru=n(" special method."),su=d(),_(ut.$$.fragment),au=d(),_(gt.$$.fragment),mi=d(),Me=s("h2"),_t=s("a"),ua=s("span"),_(Ko.$$.fragment),iu=d(),ga=s("span"),du=n("DetrForSegmentation"),hi=d(),U=s("div"),_(Xo.$$.fragment),cu=d(),_a=s("p"),lu=n(`DETR Model (consisting of a backbone and encoder-decoder Transformer) with a segmentation head on top, for tasks
such as COCO panoptic.`),mu=d(),Zo=s("p"),hu=n("This model inherits from "),nr=s("a"),pu=n("PreTrainedModel"),fu=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),uu=d(),en=s("p"),gu=n("This model is also a PyTorch "),tn=s("a"),_u=n("torch.nn.Module"),bu=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),vu=d(),ee=s("div"),_(on.$$.fragment),yu=d(),Ue=s("p"),Du=n("The "),rr=s("a"),wu=n("DetrForSegmentation"),Tu=n(" forward method, overrides the "),ba=s("code"),xu=n("__call__"),Eu=n(" special method."),$u=d(),_(bt.$$.fragment),ku=d(),_(vt.$$.fragment),this.h()},l(o){const m=nv('[data-svelte="svelte-1phssyn"]',document.head);f=a(m,"META",{name:!0,content:!0}),m.forEach(t),E=c(o),T=a(o,"H1",{class:!0});var nn=i(T);u=a(nn,"A",{id:!0,class:!0,href:!0});var va=i(u);x=a(va,"SPAN",{});var ya=i(x);b(p.$$.fragment,ya),ya.forEach(t),va.forEach(t),g=c(nn),H=a(nn,"SPAN",{});var Da=i(H);id=r(Da,"DETR"),Da.forEach(t),nn.forEach(t),xa=c(o),Te=a(o,"H2",{class:!0});var rn=i(Te);He=a(rn,"A",{id:!0,class:!0,href:!0});var wa=i(He);fr=a(wa,"SPAN",{});var Ta=i(fr);b(Rt.$$.fragment,Ta),Ta.forEach(t),wa.forEach(t),dd=c(rn),ur=a(rn,"SPAN",{});var zu=i(ur);cd=r(zu,"Overview"),zu.forEach(t),rn.forEach(t),Ea=c(o),Ge=a(o,"P",{});var fi=i(Ge);ld=r(fi,"The DETR model was proposed in "),Mt=a(fi,"A",{href:!0,rel:!0});var Cu=i(Mt);md=r(Cu,"End-to-End Object Detection with Transformers"),Cu.forEach(t),hd=r(fi,` by
Nicolas Carion, Francisco Massa, Gabriel Synnaeve, Nicolas Usunier, Alexander Kirillov and Sergey Zagoruyko. DETR
consists of a convolutional backbone followed by an encoder-decoder Transformer which can be trained end-to-end for
object detection. It greatly simplifies a lot of the complexity of models like Faster-R-CNN and Mask-R-CNN, which use
things like region proposals, non-maximum suppression procedure and anchor generation. Moreover, DETR can also be
naturally extended to perform panoptic segmentation, by simply adding a mask head on top of the decoder outputs.`),fi.forEach(t),$a=c(o),an=a(o,"P",{});var Pu=i(an);pd=r(Pu,"The abstract from the paper is the following:"),Pu.forEach(t),ka=c(o),dn=a(o,"P",{});var qu=i(dn);gr=a(qu,"EM",{});var Iu=i(gr);fd=r(Iu,`We present a new method that views object detection as a direct set prediction problem. Our approach streamlines the
detection pipeline, effectively removing the need for many hand-designed components like a non-maximum suppression
procedure or anchor generation that explicitly encode our prior knowledge about the task. The main ingredients of the
new framework, called DEtection TRansformer or DETR, are a set-based global loss that forces unique predictions via
bipartite matching, and a transformer encoder-decoder architecture. Given a fixed small set of learned object queries,
DETR reasons about the relations of the objects and the global image context to directly output the final set of
predictions in parallel. The new model is conceptually simple and does not require a specialized library, unlike many
other modern detectors. DETR demonstrates accuracy and run-time performance on par with the well-established and
highly-optimized Faster RCNN baseline on the challenging COCO object detection dataset. Moreover, DETR can be easily
generalized to produce panoptic segmentation in a unified manner. We show that it significantly outperforms competitive
baselines.`),Iu.forEach(t),qu.forEach(t),ja=c(o),_e=a(o,"P",{});var sr=i(_e);ud=r(sr,"This model was contributed by "),Ut=a(sr,"A",{href:!0,rel:!0});var Nu=i(Ut);gd=r(Nu,"nielsr"),Nu.forEach(t),_d=r(sr,". The original code can be found "),Ht=a(sr,"A",{href:!0,rel:!0});var Au=i(Ht);bd=r(Au,"here"),Au.forEach(t),vd=r(sr,"."),sr.forEach(t),Fa=c(o),We=a(o,"P",{});var ui=i(We);yd=r(ui,"Here\u2019s a TLDR explaining how "),cn=a(ui,"A",{href:!0});var Su=i(cn);Dd=r(Su,"DetrForObjectDetection"),Su.forEach(t),wd=r(ui," works:"),ui.forEach(t),Oa=c(o),j=a(o,"P",{});var q=i(j);Td=r(q,`First, an image is sent through a pre-trained convolutional backbone (in the paper, the authors use
ResNet-50/ResNet-101). Let\u2019s assume we also add a batch dimension. This means that the input to the backbone is a
tensor of shape `),_r=a(q,"CODE",{});var Lu=i(_r);xd=r(Lu,"(batch_size, 3, height, width)"),Lu.forEach(t),Ed=r(q,`, assuming the image has 3 color channels (RGB). The CNN backbone
outputs a new lower-resolution feature map, typically of shape `),br=a(q,"CODE",{});var Ru=i(br);$d=r(Ru,"(batch_size, 2048, height/32, width/32)"),Ru.forEach(t),kd=r(q,`. This is
then projected to match the hidden dimension of the Transformer of DETR, which is `),vr=a(q,"CODE",{});var Mu=i(vr);jd=r(Mu,"256"),Mu.forEach(t),Fd=r(q,` by default, using a
`),yr=a(q,"CODE",{});var Uu=i(yr);Od=r(Uu,"nn.Conv2D"),Uu.forEach(t),zd=r(q," layer. So now, we have a tensor of shape "),Dr=a(q,"CODE",{});var Hu=i(Dr);Cd=r(Hu,"(batch_size, 256, height/32, width/32)."),Hu.forEach(t),Pd=r(q,` Next, the
feature map is flattened and transposed to obtain a tensor of shape `),wr=a(q,"CODE",{});var Gu=i(wr);qd=r(Gu,"(batch_size, seq_len, d_model)"),Gu.forEach(t),Id=r(q,` =
`),Tr=a(q,"CODE",{});var Wu=i(Tr);Nd=r(Wu,"(batch_size, width/32*height/32, 256)"),Wu.forEach(t),Ad=r(q,`. So a difference with NLP models is that the sequence length is actually
longer than usual, but with a smaller `),xr=a(q,"CODE",{});var Vu=i(xr);Sd=r(Vu,"d_model"),Vu.forEach(t),Ld=r(q," (which in NLP is typically 768 or higher)."),q.forEach(t),za=c(o),P=a(o,"P",{});var G=i(P);Rd=r(G,"Next, this is sent through the encoder, outputting "),Er=a(G,"CODE",{});var Bu=i(Er);Md=r(Bu,"encoder_hidden_states"),Bu.forEach(t),Ud=r(G,` of the same shape (you can consider
these as image features). Next, so-called `),$r=a(G,"STRONG",{});var Yu=i($r);Hd=r(Yu,"object queries"),Yu.forEach(t),Gd=r(G,` are sent through the decoder. This is a tensor of shape
`),kr=a(G,"CODE",{});var Qu=i(kr);Wd=r(Qu,"(batch_size, num_queries, d_model)"),Qu.forEach(t),Vd=r(G,", with "),jr=a(G,"CODE",{});var Ju=i(jr);Bd=r(Ju,"num_queries"),Ju.forEach(t),Yd=r(G,` typically set to 100 and initialized with zeros.
These input embeddings are learnt positional encodings that the authors refer to as object queries, and similarly to
the encoder, they are added to the input of each attention layer. Each object query will look for a particular object
in the image. The decoder updates these embeddings through multiple self-attention and encoder-decoder attention layers
to output `),Fr=a(G,"CODE",{});var Ku=i(Fr);Qd=r(Ku,"decoder_hidden_states"),Ku.forEach(t),Jd=r(G," of the same shape: "),Or=a(G,"CODE",{});var Xu=i(Or);Kd=r(Xu,"(batch_size, num_queries, d_model)"),Xu.forEach(t),Xd=r(G,`. Next, two heads
are added on top for object detection: a linear layer for classifying each object query into one of the objects or \u201Cno
object\u201D, and a MLP to predict bounding boxes for each query.`),G.forEach(t),Ca=c(o),J=a(o,"P",{});var yt=i(J);Zd=r(yt,"The model is trained using a "),zr=a(yt,"STRONG",{});var Zu=i(zr);ec=r(Zu,"bipartite matching loss"),Zu.forEach(t),tc=r(yt,`: so what we actually do is compare the predicted classes +
bounding boxes of each of the N = 100 object queries to the ground truth annotations, padded up to the same length N
(so if an image only contains 4 objects, 96 annotations will just have a \u201Cno object\u201D as class and \u201Cno bounding box\u201D as
bounding box). The `),Gt=a(yt,"A",{href:!0,rel:!0});var eg=i(Gt);oc=r(eg,"Hungarian matching algorithm"),eg.forEach(t),nc=r(yt,` is used to find
an optimal one-to-one mapping of each of the N queries to each of the N annotations. Next, standard cross-entropy (for
the classes) and a linear combination of the L1 and `),Wt=a(yt,"A",{href:!0,rel:!0});var tg=i(Wt);rc=r(tg,"generalized IoU loss"),tg.forEach(t),sc=r(yt,` (for the
bounding boxes) are used to optimize the parameters of the model.`),yt.forEach(t),Pa=c(o),K=a(o,"P",{});var Dt=i(K);ac=r(Dt,`DETR can be naturally extended to perform panoptic segmentation (which unifies semantic segmentation and instance
segmentation). `),ln=a(Dt,"A",{href:!0});var og=i(ln);ic=r(og,"DetrForSegmentation"),og.forEach(t),dc=r(Dt,` adds a segmentation mask head on top of
`),mn=a(Dt,"A",{href:!0});var ng=i(mn);cc=r(ng,"DetrForObjectDetection"),ng.forEach(t),lc=r(Dt,`. The mask head can be trained either jointly, or in a two steps process,
where one first trains a `),hn=a(Dt,"A",{href:!0});var rg=i(hn);mc=r(rg,"DetrForObjectDetection"),rg.forEach(t),hc=r(Dt,` model to detect bounding boxes around both
\u201Cthings\u201D (instances) and \u201Cstuff\u201D (background things like trees, roads, sky), then freeze all the weights and train only
the mask head for 25 epochs. Experimentally, these two approaches give similar results. Note that predicting boxes is
required for the training to be possible, since the Hungarian matching is computed using distances between boxes.`),Dt.forEach(t),qa=c(o),pn=a(o,"P",{});var sg=i(pn);pc=r(sg,"Tips:"),sg.forEach(t),Ia=c(o),F=a(o,"UL",{});var A=i(F);ne=a(A,"LI",{});var wt=i(ne);fc=r(wt,"DETR uses so-called "),Cr=a(wt,"STRONG",{});var ag=i(Cr);uc=r(ag,"object queries"),ag.forEach(t),gc=r(wt,` to detect objects in an image. The number of queries determines the maximum
number of objects that can be detected in a single image, and is set to 100 by default (see parameter
`),Pr=a(wt,"CODE",{});var ig=i(Pr);_c=r(ig,"num_queries"),ig.forEach(t),bc=r(wt," of "),fn=a(wt,"A",{href:!0});var dg=i(fn);vc=r(dg,"DetrConfig"),dg.forEach(t),yc=r(wt,`). Note that it\u2019s good to have some slack (in COCO, the
authors used 100, while the maximum number of objects in a COCO image is ~70).`),wt.forEach(t),Dc=c(A),qr=a(A,"LI",{});var cg=i(qr);wc=r(cg,`The decoder of DETR updates the query embeddings in parallel. This is different from language models like GPT-2,
which use autoregressive decoding instead of parallel. Hence, no causal attention mask is used.`),cg.forEach(t),Tc=c(A),re=a(A,"LI",{});var Tt=i(re);xc=r(Tt,`DETR adds position embeddings to the hidden states at each self-attention and cross-attention layer before projecting
to queries and keys. For the position embeddings of the image, one can choose between fixed sinusoidal or learned
absolute position embeddings. By default, the parameter `),Ir=a(Tt,"CODE",{});var lg=i(Ir);Ec=r(lg,"position_embedding_type"),lg.forEach(t),$c=r(Tt,` of
`),un=a(Tt,"A",{href:!0});var mg=i(un);kc=r(mg,"DetrConfig"),mg.forEach(t),jc=r(Tt," is set to "),Nr=a(Tt,"CODE",{});var hg=i(Nr);Fc=r(hg,'"sine"'),hg.forEach(t),Oc=r(Tt,"."),Tt.forEach(t),zc=c(A),se=a(A,"LI",{});var xt=i(se);Cc=r(xt,`During training, the authors of DETR did find it helpful to use auxiliary losses in the decoder, especially to help
the model output the correct number of objects of each class. If you set the parameter `),Ar=a(xt,"CODE",{});var pg=i(Ar);Pc=r(pg,"auxiliary_loss"),pg.forEach(t),qc=r(xt,` of
`),gn=a(xt,"A",{href:!0});var fg=i(gn);Ic=r(fg,"DetrConfig"),fg.forEach(t),Nc=r(xt," to "),Sr=a(xt,"CODE",{});var ug=i(Sr);Ac=r(ug,"True"),ug.forEach(t),Sc=r(xt,`, then prediction feedforward neural networks and Hungarian losses
are added after each decoder layer (with the FFNs sharing parameters).`),xt.forEach(t),Lc=c(A),B=a(A,"LI",{});var be=i(B);Rc=r(be,`If you want to train the model in a distributed environment across multiple nodes, then one should update the
`),Lr=a(be,"EM",{});var gg=i(Lr);Mc=r(gg,"num_boxes"),gg.forEach(t),Uc=r(be," variable in the "),Rr=a(be,"EM",{});var _g=i(Rr);Hc=r(_g,"DetrLoss"),_g.forEach(t),Gc=r(be," class of "),Mr=a(be,"EM",{});var bg=i(Mr);Wc=r(bg,"modeling_detr.py"),bg.forEach(t),Vc=r(be,`. When training on multiple nodes, this should be
set to the average number of target boxes across all nodes, as can be seen in the original implementation `),Vt=a(be,"A",{href:!0,rel:!0});var vg=i(Vt);Bc=r(vg,"here"),vg.forEach(t),Yc=r(be,"."),be.forEach(t),Qc=c(A),N=a(A,"LI",{});var Q=i(N);_n=a(Q,"A",{href:!0});var yg=i(_n);Jc=r(yg,"DetrForObjectDetection"),yg.forEach(t),Kc=r(Q," and "),bn=a(Q,"A",{href:!0});var Dg=i(bn);Xc=r(Dg,"DetrForSegmentation"),Dg.forEach(t),Zc=r(Q,` can be initialized with
any convolutional backbone available in the `),Bt=a(Q,"A",{href:!0,rel:!0});var wg=i(Bt);el=r(wg,"timm library"),wg.forEach(t),tl=r(Q,`.
Initializing with a MobileNet backbone for example can be done by setting the `),Ur=a(Q,"CODE",{});var Tg=i(Ur);ol=r(Tg,"backbone"),Tg.forEach(t),nl=r(Q,` attribute of
`),vn=a(Q,"A",{href:!0});var xg=i(vn);rl=r(xg,"DetrConfig"),xg.forEach(t),sl=r(Q," to "),Hr=a(Q,"CODE",{});var Eg=i(Hr);al=r(Eg,'"tf_mobilenetv3_small_075"'),Eg.forEach(t),il=r(Q,`, and then initializing the model with that
config.`),Q.forEach(t),dl=c(A),ae=a(A,"LI",{});var Et=i(ae);cl=r(Et,`DETR resizes the input images such that the shortest side is at least a certain amount of pixels while the longest is
at most 1333 pixels. At training time, scale augmentation is used such that the shortest side is randomly set to at
least 480 and at most 800 pixels. At inference time, the shortest side is set to 800. One can use
`),yn=a(Et,"A",{href:!0});var $g=i(yn);ll=r($g,"DetrImageProcessor"),$g.forEach(t),ml=r(Et,` to prepare images (and optional annotations in COCO format) for the
model. Due to this resizing, images in a batch can have different sizes. DETR solves this by padding images up to the
largest size in a batch, and by creating a pixel mask that indicates which pixels are real/which are padding.
Alternatively, one can also define a custom `),Gr=a(Et,"CODE",{});var kg=i(Gr);hl=r(kg,"collate_fn"),kg.forEach(t),pl=r(Et,` in order to batch images together, using
`),Dn=a(Et,"A",{href:!0});var jg=i(Dn);fl=r(jg,"pad_and_create_pixel_mask()"),jg.forEach(t),ul=r(Et,"."),Et.forEach(t),gl=c(A),xe=a(A,"LI",{});var ar=i(xe);_l=r(ar,"The size of the images will determine the amount of memory being used, and will thus determine the "),Wr=a(ar,"CODE",{});var Fg=i(Wr);bl=r(Fg,"batch_size"),Fg.forEach(t),vl=r(ar,`.
It is advised to use a batch size of 2 per GPU. See `),Yt=a(ar,"A",{href:!0,rel:!0});var Og=i(Yt);yl=r(Og,"this Github thread"),Og.forEach(t),Dl=r(ar," for more info."),ar.forEach(t),A.forEach(t),Na=c(o),wn=a(o,"P",{});var zg=i(wn);wl=r(zg,"There are three ways to instantiate a DETR model (depending on what you prefer):"),zg.forEach(t),Aa=c(o),Tn=a(o,"P",{});var Cg=i(Tn);Tl=r(Cg,"Option 1: Instantiate DETR with pre-trained weights for entire model"),Cg.forEach(t),Sa=c(o),b(Qt.$$.fragment,o),La=c(o),xn=a(o,"P",{});var Pg=i(xn);xl=r(Pg,"Option 2: Instantiate DETR with randomly initialized weights for Transformer, but pre-trained weights for backbone"),Pg.forEach(t),Ra=c(o),b(Jt.$$.fragment,o),Ma=c(o),En=a(o,"P",{});var qg=i(En);El=r(qg,"Option 3: Instantiate DETR with randomly initialized weights for backbone + Transformer"),qg.forEach(t),Ua=c(o),b(Kt.$$.fragment,o),Ha=c(o),$n=a(o,"P",{});var Ig=i($n);$l=r(Ig,"As a summary, consider the following table:"),Ig.forEach(t),Ga=c(o),Ve=a(o,"TABLE",{});var gi=i(Ve);Vr=a(gi,"THEAD",{});var Ng=i(Vr);ie=a(Ng,"TR",{});var $t=i(ie);Br=a($t,"TH",{});var Ag=i(Br);kl=r(Ag,"Task"),Ag.forEach(t),jl=c($t),Yr=a($t,"TH",{});var Sg=i(Yr);Fl=r(Sg,"Object detection"),Sg.forEach(t),Ol=c($t),Qr=a($t,"TH",{});var Lg=i(Qr);zl=r(Lg,"Instance segmentation"),Lg.forEach(t),Cl=c($t),Jr=a($t,"TH",{});var Rg=i(Jr);Pl=r(Rg,"Panoptic segmentation"),Rg.forEach(t),$t.forEach(t),Ng.forEach(t),ql=c(gi),S=a(gi,"TBODY",{});var te=i(S);de=a(te,"TR",{});var kt=i(de);Kr=a(kt,"TD",{});var Mg=i(Kr);Xr=a(Mg,"STRONG",{});var Ug=i(Xr);Il=r(Ug,"Description"),Ug.forEach(t),Mg.forEach(t),Nl=c(kt),Zr=a(kt,"TD",{});var Hg=i(Zr);Al=r(Hg,"Predicting bounding boxes and class labels around objects in an image"),Hg.forEach(t),Sl=c(kt),es=a(kt,"TD",{});var Gg=i(es);Ll=r(Gg,"Predicting masks around objects (i.e. instances) in an image"),Gg.forEach(t),Rl=c(kt),ts=a(kt,"TD",{});var Wg=i(ts);Ml=r(Wg,"Predicting masks around both objects (i.e. instances) as well as \u201Cstuff\u201D (i.e. background things like trees and roads) in an image"),Wg.forEach(t),kt.forEach(t),Ul=c(te),ce=a(te,"TR",{});var jt=i(ce);os=a(jt,"TD",{});var Vg=i(os);ns=a(Vg,"STRONG",{});var Bg=i(ns);Hl=r(Bg,"Model"),Bg.forEach(t),Vg.forEach(t),Gl=c(jt),rs=a(jt,"TD",{});var Yg=i(rs);kn=a(Yg,"A",{href:!0});var Qg=i(kn);Wl=r(Qg,"DetrForObjectDetection"),Qg.forEach(t),Yg.forEach(t),Vl=c(jt),ss=a(jt,"TD",{});var Jg=i(ss);jn=a(Jg,"A",{href:!0});var Kg=i(jn);Bl=r(Kg,"DetrForSegmentation"),Kg.forEach(t),Jg.forEach(t),Yl=c(jt),as=a(jt,"TD",{});var Xg=i(as);Fn=a(Xg,"A",{href:!0});var Zg=i(Fn);Ql=r(Zg,"DetrForSegmentation"),Zg.forEach(t),Xg.forEach(t),jt.forEach(t),Jl=c(te),le=a(te,"TR",{});var Ft=i(le);is=a(Ft,"TD",{});var e_=i(is);ds=a(e_,"STRONG",{});var t_=i(ds);Kl=r(t_,"Example dataset"),t_.forEach(t),e_.forEach(t),Xl=c(Ft),cs=a(Ft,"TD",{});var o_=i(cs);Zl=r(o_,"COCO detection"),o_.forEach(t),em=c(Ft),ls=a(Ft,"TD",{});var n_=i(ls);tm=r(n_,"COCO detection, COCO panoptic"),n_.forEach(t),om=c(Ft),ms=a(Ft,"TD",{});var r_=i(ms);nm=r(r_,"COCO panoptic"),r_.forEach(t),Ft.forEach(t),rm=c(te),me=a(te,"TR",{});var Ot=i(me);Xt=a(Ot,"TD",{});var _i=i(Xt);hs=a(_i,"STRONG",{});var s_=i(hs);sm=r(s_,"Format of annotations to provide to"),s_.forEach(t),am=c(_i),On=a(_i,"A",{href:!0});var a_=i(On);im=r(a_,"DetrImageProcessor"),a_.forEach(t),_i.forEach(t),dm=c(Ot),Ee=a(Ot,"TD",{});var ir=i(Ee);cm=r(ir,"{\u2018image_id\u2019: "),ps=a(ir,"CODE",{});var i_=i(ps);lm=r(i_,"int"),i_.forEach(t),mm=r(ir,", \u2018annotations\u2019: "),fs=a(ir,"CODE",{});var d_=i(fs);hm=r(d_,"List[Dict]"),d_.forEach(t),pm=r(ir,"} each Dict being a COCO object annotation"),ir.forEach(t),fm=c(Ot),L=a(Ot,"TD",{});var oe=i(L);um=r(oe,"{\u2018image_id\u2019: "),us=a(oe,"CODE",{});var c_=i(us);gm=r(c_,"int"),c_.forEach(t),_m=r(oe,", \u2018annotations\u2019: "),gs=a(oe,"CODE",{});var l_=i(gs);bm=r(l_,"List[Dict]"),l_.forEach(t),vm=r(oe,"}  (in case of COCO detection) or {\u2018file_name\u2019: "),_s=a(oe,"CODE",{});var m_=i(_s);ym=r(m_,"str"),m_.forEach(t),Dm=r(oe,", \u2018image_id\u2019: "),bs=a(oe,"CODE",{});var h_=i(bs);wm=r(h_,"int"),h_.forEach(t),Tm=r(oe,", \u2018segments_info\u2019: "),vs=a(oe,"CODE",{});var p_=i(vs);xm=r(p_,"List[Dict]"),p_.forEach(t),Em=r(oe,"} (in case of COCO panoptic)"),oe.forEach(t),$m=c(Ot),he=a(Ot,"TD",{});var zt=i(he);km=r(zt,"{\u2018file_name\u2019: "),ys=a(zt,"CODE",{});var f_=i(ys);jm=r(f_,"str"),f_.forEach(t),Fm=r(zt,", \u2018image_id\u2019: "),Ds=a(zt,"CODE",{});var u_=i(Ds);Om=r(u_,"int"),u_.forEach(t),zm=r(zt,", \u2018segments_info\u2019: "),ws=a(zt,"CODE",{});var g_=i(ws);Cm=r(g_,"List[Dict]"),g_.forEach(t),Pm=r(zt,"} and masks_path (path to directory containing PNG files of the masks)"),zt.forEach(t),Ot.forEach(t),qm=c(te),pe=a(te,"TR",{});var Ct=i(pe);zn=a(Ct,"TD",{});var ju=i(zn);Ts=a(ju,"STRONG",{});var __=i(Ts);Im=r(__,"Postprocessing"),__.forEach(t),Nm=r(ju," (i.e. converting the output of the model to COCO API)"),ju.forEach(t),Am=c(Ct),xs=a(Ct,"TD",{});var b_=i(xs);Es=a(b_,"CODE",{});var v_=i(Es);Sm=r(v_,"post_process()"),v_.forEach(t),b_.forEach(t),Lm=c(Ct),$s=a(Ct,"TD",{});var y_=i($s);ks=a(y_,"CODE",{});var D_=i(ks);Rm=r(D_,"post_process_segmentation()"),D_.forEach(t),y_.forEach(t),Mm=c(Ct),Zt=a(Ct,"TD",{});var bi=i(Zt);js=a(bi,"CODE",{});var w_=i(js);Um=r(w_,"post_process_segmentation()"),w_.forEach(t),Hm=r(bi,", "),Fs=a(bi,"CODE",{});var T_=i(Fs);Gm=r(T_,"post_process_panoptic()"),T_.forEach(t),bi.forEach(t),Ct.forEach(t),Wm=c(te),fe=a(te,"TR",{});var Pt=i(fe);Os=a(Pt,"TD",{});var x_=i(Os);zs=a(x_,"STRONG",{});var E_=i(zs);Vm=r(E_,"evaluators"),E_.forEach(t),x_.forEach(t),Bm=c(Pt),eo=a(Pt,"TD",{});var vi=i(eo);Cs=a(vi,"CODE",{});var $_=i(Cs);Ym=r($_,"CocoEvaluator"),$_.forEach(t),Qm=r(vi," with "),Ps=a(vi,"CODE",{});var k_=i(Ps);Jm=r(k_,'iou_types="bbox"'),k_.forEach(t),vi.forEach(t),Km=c(Pt),$e=a(Pt,"TD",{});var dr=i($e);qs=a(dr,"CODE",{});var j_=i(qs);Xm=r(j_,"CocoEvaluator"),j_.forEach(t),Zm=r(dr," with "),Is=a(dr,"CODE",{});var F_=i(Is);eh=r(F_,'iou_types="bbox"'),F_.forEach(t),th=r(dr," or "),Ns=a(dr,"CODE",{});var O_=i(Ns);oh=r(O_,'"segm"'),O_.forEach(t),dr.forEach(t),nh=c(Pt),ue=a(Pt,"TD",{});var qt=i(ue);As=a(qt,"CODE",{});var z_=i(As);rh=r(z_,"CocoEvaluator"),z_.forEach(t),sh=r(qt," with "),Ss=a(qt,"CODE",{});var C_=i(Ss);ah=r(C_,'iou_tupes="bbox"'),C_.forEach(t),ih=r(qt," or "),Ls=a(qt,"CODE",{});var P_=i(Ls);dh=r(P_,'"segm"'),P_.forEach(t),ch=r(qt,", "),Rs=a(qt,"CODE",{});var q_=i(Rs);lh=r(q_,"PanopticEvaluator"),q_.forEach(t),qt.forEach(t),Pt.forEach(t),te.forEach(t),gi.forEach(t),Wa=c(o),$=a(o,"P",{});var O=i($);mh=r(O,`In short, one should prepare the data either in COCO detection or COCO panoptic format, then use
`),Cn=a(O,"A",{href:!0});var I_=i(Cn);hh=r(I_,"DetrImageProcessor"),I_.forEach(t),ph=r(O," to create "),Ms=a(O,"CODE",{});var N_=i(Ms);fh=r(N_,"pixel_values"),N_.forEach(t),uh=r(O,", "),Us=a(O,"CODE",{});var A_=i(Us);gh=r(A_,"pixel_mask"),A_.forEach(t),_h=r(O,` and optional
`),Hs=a(O,"CODE",{});var S_=i(Hs);bh=r(S_,"labels"),S_.forEach(t),vh=r(O,`, which can then be used to train (or fine-tune) a model. For evaluation, one should first convert the
outputs of the model using one of the postprocessing methods of `),Pn=a(O,"A",{href:!0});var L_=i(Pn);yh=r(L_,"DetrImageProcessor"),L_.forEach(t),Dh=r(O,`. These can
be be provided to either `),Gs=a(O,"CODE",{});var R_=i(Gs);wh=r(R_,"CocoEvaluator"),R_.forEach(t),Th=r(O," or "),Ws=a(O,"CODE",{});var M_=i(Ws);xh=r(M_,"PanopticEvaluator"),M_.forEach(t),Eh=r(O,`, which allow you to calculate metrics like
mean Average Precision (mAP) and Panoptic Quality (PQ). The latter objects are implemented in the `),to=a(O,"A",{href:!0,rel:!0});var U_=i(to);$h=r(U_,"original repository"),U_.forEach(t),kh=r(O,". See the "),oo=a(O,"A",{href:!0,rel:!0});var H_=i(oo);jh=r(H_,"example notebooks"),H_.forEach(t),Fh=r(O," for more info regarding evaluation."),O.forEach(t),Va=c(o),ke=a(o,"H2",{class:!0});var yi=i(ke);Be=a(yi,"A",{id:!0,class:!0,href:!0});var G_=i(Be);Vs=a(G_,"SPAN",{});var W_=i(Vs);b(no.$$.fragment,W_),W_.forEach(t),G_.forEach(t),Oh=c(yi),Bs=a(yi,"SPAN",{});var V_=i(Bs);zh=r(V_,"Resources"),V_.forEach(t),yi.forEach(t),Ba=c(o),qn=a(o,"P",{});var B_=i(qn);Ch=r(B_,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with DETR."),B_.forEach(t),Ya=c(o),b(ro.$$.fragment,o),Qa=c(o),Ye=a(o,"UL",{});var Di=i(Ye);ge=a(Di,"LI",{});var It=i(ge);Ph=r(It,"All example notebooks illustrating fine-tuning "),In=a(It,"A",{href:!0});var Y_=i(In);qh=r(Y_,"DetrForObjectDetection"),Y_.forEach(t),Ih=r(It," and "),Nn=a(It,"A",{href:!0});var Q_=i(Nn);Nh=r(Q_,"DetrForSegmentation"),Q_.forEach(t),Ah=r(It," on a custom dataset an be found "),so=a(It,"A",{href:!0,rel:!0});var J_=i(so);Sh=r(J_,"here"),J_.forEach(t),Lh=r(It,"."),It.forEach(t),Rh=c(Di),An=a(Di,"LI",{});var Fu=i(An);Mh=r(Fu,"See also: "),Sn=a(Fu,"A",{href:!0});var K_=i(Sn);Uh=r(K_,"Object detection task guide"),K_.forEach(t),Fu.forEach(t),Di.forEach(t),Ja=c(o),Ln=a(o,"P",{});var X_=i(Ln);Hh=r(X_,"If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),X_.forEach(t),Ka=c(o),je=a(o,"H2",{class:!0});var wi=i(je);Qe=a(wi,"A",{id:!0,class:!0,href:!0});var Z_=i(Qe);Ys=a(Z_,"SPAN",{});var eb=i(Ys);b(ao.$$.fragment,eb),eb.forEach(t),Z_.forEach(t),Gh=c(wi),Qs=a(wi,"SPAN",{});var tb=i(Qs);Wh=r(tb,"DETR specific outputs"),tb.forEach(t),wi.forEach(t),Xa=c(o),Fe=a(o,"DIV",{class:!0});var Ti=i(Fe);b(io.$$.fragment,Ti),Vh=c(Ti),Js=a(Ti,"P",{});var ob=i(Js);Bh=r(ob,`Base class for outputs of the DETR encoder-decoder model. This class adds one attribute to Seq2SeqModelOutput,
namely an optional stack of intermediate decoder activations, i.e. the output of each decoder layer, each of them
gone through a layernorm. This is useful when training the model with auxiliary decoding losses.`),ob.forEach(t),Ti.forEach(t),Za=c(o),Oe=a(o,"DIV",{class:!0});var xi=i(Oe);b(co.$$.fragment,xi),Yh=c(xi),lo=a(xi,"P",{});var Ei=i(lo);Qh=r(Ei,"Output type of "),Rn=a(Ei,"A",{href:!0});var nb=i(Rn);Jh=r(nb,"DetrForObjectDetection"),nb.forEach(t),Kh=r(Ei,"."),Ei.forEach(t),xi.forEach(t),ei=c(o),ze=a(o,"DIV",{class:!0});var $i=i(ze);b(mo.$$.fragment,$i),Xh=c($i),ho=a($i,"P",{});var ki=i(ho);Zh=r(ki,"Output type of "),Mn=a(ki,"A",{href:!0});var rb=i(Mn);ep=r(rb,"DetrForSegmentation"),rb.forEach(t),tp=r(ki,"."),ki.forEach(t),$i.forEach(t),ti=c(o),Ce=a(o,"H2",{class:!0});var ji=i(Ce);Je=a(ji,"A",{id:!0,class:!0,href:!0});var sb=i(Je);Ks=a(sb,"SPAN",{});var ab=i(Ks);b(po.$$.fragment,ab),ab.forEach(t),sb.forEach(t),op=c(ji),Xs=a(ji,"SPAN",{});var ib=i(Xs);np=r(ib,"DetrConfig"),ib.forEach(t),ji.forEach(t),oi=c(o),Y=a(o,"DIV",{class:!0});var Nt=i(Y);b(fo.$$.fragment,Nt),rp=c(Nt),Pe=a(Nt,"P",{});var cr=i(Pe);sp=r(cr,"This is the configuration class to store the configuration of a "),Un=a(cr,"A",{href:!0});var db=i(Un);ap=r(db,"DetrModel"),db.forEach(t),ip=r(cr,`. It is used to instantiate a DETR
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the DETR
`),uo=a(cr,"A",{href:!0,rel:!0});var cb=i(uo);dp=r(cb,"facebook/detr-resnet-50"),cb.forEach(t),cp=r(cr," architecture."),cr.forEach(t),lp=c(Nt),qe=a(Nt,"P",{});var lr=i(qe);mp=r(lr,"Configuration objects inherit from "),Hn=a(lr,"A",{href:!0});var lb=i(Hn);hp=r(lb,"PretrainedConfig"),lb.forEach(t),pp=r(lr,` and can be used to control the model outputs. Read the
documentation from `),Gn=a(lr,"A",{href:!0});var mb=i(Gn);fp=r(mb,"PretrainedConfig"),mb.forEach(t),up=r(lr," for more information."),lr.forEach(t),gp=c(Nt),b(Ke.$$.fragment,Nt),Nt.forEach(t),ni=c(o),Ie=a(o,"H2",{class:!0});var Fi=i(Ie);Xe=a(Fi,"A",{id:!0,class:!0,href:!0});var hb=i(Xe);Zs=a(hb,"SPAN",{});var pb=i(Zs);b(go.$$.fragment,pb),pb.forEach(t),hb.forEach(t),_p=c(Fi),ea=a(Fi,"SPAN",{});var fb=i(ea);bp=r(fb,"DetrImageProcessor"),fb.forEach(t),Fi.forEach(t),ri=c(o),z=a(o,"DIV",{class:!0});var W=i(z);b(_o.$$.fragment,W),vp=c(W),ta=a(W,"P",{});var ub=i(ta);yp=r(ub,"Constructs a Detr image processor."),ub.forEach(t),Dp=c(W),Ze=a(W,"DIV",{class:!0});var Oi=i(Ze);b(bo.$$.fragment,Oi),wp=c(Oi),oa=a(Oi,"P",{});var gb=i(oa);Tp=r(gb,"Preprocess an image or a batch of images so that it can be used by the model."),gb.forEach(t),Oi.forEach(t),xp=c(W),et=a(W,"DIV",{class:!0});var zi=i(et);b(vo.$$.fragment,zi),Ep=c(zi),yo=a(zi,"P",{});var Ci=i(yo);$p=r(Ci,"Converts the raw output of "),Wn=a(Ci,"A",{href:!0});var _b=i(Wn);kp=r(_b,"DetrForObjectDetection"),_b.forEach(t),jp=r(Ci,` into final bounding boxes in (top_left_x, top_left_y,
bottom_right_x, bottom_right_y) format. Only supports PyTorch.`),Ci.forEach(t),zi.forEach(t),Fp=c(W),tt=a(W,"DIV",{class:!0});var Pi=i(tt);b(Do.$$.fragment,Pi),Op=c(Pi),wo=a(Pi,"P",{});var qi=i(wo);zp=r(qi,"Converts the output of "),Vn=a(qi,"A",{href:!0});var bb=i(Vn);Cp=r(bb,"DetrForSegmentation"),bb.forEach(t),Pp=r(qi," into semantic segmentation maps. Only supports PyTorch."),qi.forEach(t),Pi.forEach(t),qp=c(W),ot=a(W,"DIV",{class:!0});var Ii=i(ot);b(To.$$.fragment,Ii),Ip=c(Ii),xo=a(Ii,"P",{});var Ni=i(xo);Np=r(Ni,"Converts the output of "),Bn=a(Ni,"A",{href:!0});var vb=i(Bn);Ap=r(vb,"DetrForSegmentation"),vb.forEach(t),Sp=r(Ni," into instance segmentation predictions. Only supports PyTorch."),Ni.forEach(t),Ii.forEach(t),Lp=c(W),nt=a(W,"DIV",{class:!0});var Ai=i(nt);b(Eo.$$.fragment,Ai),Rp=c(Ai),$o=a(Ai,"P",{});var Si=i($o);Mp=r(Si,"Converts the output of "),Yn=a(Si,"A",{href:!0});var yb=i(Yn);Up=r(yb,"DetrForSegmentation"),yb.forEach(t),Hp=r(Si,` into image panoptic segmentation predictions. Only supports
PyTorch.`),Si.forEach(t),Ai.forEach(t),W.forEach(t),si=c(o),Ne=a(o,"H2",{class:!0});var Li=i(Ne);rt=a(Li,"A",{id:!0,class:!0,href:!0});var Db=i(rt);na=a(Db,"SPAN",{});var wb=i(na);b(ko.$$.fragment,wb),wb.forEach(t),Db.forEach(t),Gp=c(Li),ra=a(Li,"SPAN",{});var Tb=i(ra);Wp=r(Tb,"DetrFeatureExtractor"),Tb.forEach(t),Li.forEach(t),ai=c(o),C=a(o,"DIV",{class:!0});var V=i(C);b(jo.$$.fragment,V),Vp=c(V),st=a(V,"DIV",{class:!0});var Ri=i(st);b(Fo.$$.fragment,Ri),Bp=c(Ri),sa=a(Ri,"P",{});var xb=i(sa);Yp=r(xb,"Preprocess an image or a batch of images."),xb.forEach(t),Ri.forEach(t),Qp=c(V),at=a(V,"DIV",{class:!0});var Mi=i(at);b(Oo.$$.fragment,Mi),Jp=c(Mi),aa=a(Mi,"P",{});var Eb=i(aa);Kp=r(Eb,`Pads a batch of images with zeros to the size of largest height and width in the batch and returns their
corresponding pixel mask.`),Eb.forEach(t),Mi.forEach(t),Xp=c(V),it=a(V,"DIV",{class:!0});var Ui=i(it);b(zo.$$.fragment,Ui),Zp=c(Ui),Co=a(Ui,"P",{});var Hi=i(Co);ef=r(Hi,"Converts the raw output of "),Qn=a(Hi,"A",{href:!0});var $b=i(Qn);tf=r($b,"DetrForObjectDetection"),$b.forEach(t),of=r(Hi,` into final bounding boxes in (top_left_x, top_left_y,
bottom_right_x, bottom_right_y) format. Only supports PyTorch.`),Hi.forEach(t),Ui.forEach(t),nf=c(V),dt=a(V,"DIV",{class:!0});var Gi=i(dt);b(Po.$$.fragment,Gi),rf=c(Gi),qo=a(Gi,"P",{});var Wi=i(qo);sf=r(Wi,"Converts the output of "),Jn=a(Wi,"A",{href:!0});var kb=i(Jn);af=r(kb,"DetrForSegmentation"),kb.forEach(t),df=r(Wi," into semantic segmentation maps. Only supports PyTorch."),Wi.forEach(t),Gi.forEach(t),cf=c(V),ct=a(V,"DIV",{class:!0});var Vi=i(ct);b(Io.$$.fragment,Vi),lf=c(Vi),No=a(Vi,"P",{});var Bi=i(No);mf=r(Bi,"Converts the output of "),Kn=a(Bi,"A",{href:!0});var jb=i(Kn);hf=r(jb,"DetrForSegmentation"),jb.forEach(t),pf=r(Bi," into instance segmentation predictions. Only supports PyTorch."),Bi.forEach(t),Vi.forEach(t),ff=c(V),lt=a(V,"DIV",{class:!0});var Yi=i(lt);b(Ao.$$.fragment,Yi),uf=c(Yi),So=a(Yi,"P",{});var Qi=i(So);gf=r(Qi,"Converts the output of "),Xn=a(Qi,"A",{href:!0});var Fb=i(Xn);_f=r(Fb,"DetrForSegmentation"),Fb.forEach(t),bf=r(Qi,` into image panoptic segmentation predictions. Only supports
PyTorch.`),Qi.forEach(t),Yi.forEach(t),V.forEach(t),ii=c(o),Ae=a(o,"H2",{class:!0});var Ji=i(Ae);mt=a(Ji,"A",{id:!0,class:!0,href:!0});var Ob=i(mt);ia=a(Ob,"SPAN",{});var zb=i(ia);b(Lo.$$.fragment,zb),zb.forEach(t),Ob.forEach(t),vf=c(Ji),da=a(Ji,"SPAN",{});var Cb=i(da);yf=r(Cb,"DetrModel"),Cb.forEach(t),Ji.forEach(t),di=c(o),R=a(o,"DIV",{class:!0});var ve=i(R);b(Ro.$$.fragment,ve),Df=c(ve),ca=a(ve,"P",{});var Pb=i(ca);wf=r(Pb,`The bare DETR Model (consisting of a backbone and encoder-decoder Transformer) outputting raw hidden-states without
any specific head on top.`),Pb.forEach(t),Tf=c(ve),Mo=a(ve,"P",{});var Ki=i(Mo);xf=r(Ki,"This model inherits from "),Zn=a(Ki,"A",{href:!0});var qb=i(Zn);Ef=r(qb,"PreTrainedModel"),qb.forEach(t),$f=r(Ki,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ki.forEach(t),kf=c(ve),Uo=a(ve,"P",{});var Xi=i(Uo);jf=r(Xi,"This model is also a PyTorch "),Ho=a(Xi,"A",{href:!0,rel:!0});var Ib=i(Ho);Ff=r(Ib,"torch.nn.Module"),Ib.forEach(t),Of=r(Xi,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Xi.forEach(t),zf=c(ve),X=a(ve,"DIV",{class:!0});var At=i(X);b(Go.$$.fragment,At),Cf=c(At),Se=a(At,"P",{});var mr=i(Se);Pf=r(mr,"The "),er=a(mr,"A",{href:!0});var Nb=i(er);qf=r(Nb,"DetrModel"),Nb.forEach(t),If=r(mr," forward method, overrides the "),la=a(mr,"CODE",{});var Ab=i(la);Nf=r(Ab,"__call__"),Ab.forEach(t),Af=r(mr," special method."),mr.forEach(t),Sf=c(At),b(ht.$$.fragment,At),Lf=c(At),b(pt.$$.fragment,At),At.forEach(t),ve.forEach(t),ci=c(o),Le=a(o,"H2",{class:!0});var Zi=i(Le);ft=a(Zi,"A",{id:!0,class:!0,href:!0});var Sb=i(ft);ma=a(Sb,"SPAN",{});var Lb=i(ma);b(Wo.$$.fragment,Lb),Lb.forEach(t),Sb.forEach(t),Rf=c(Zi),ha=a(Zi,"SPAN",{});var Rb=i(ha);Mf=r(Rb,"DetrForObjectDetection"),Rb.forEach(t),Zi.forEach(t),li=c(o),M=a(o,"DIV",{class:!0});var ye=i(M);b(Vo.$$.fragment,ye),Uf=c(ye),pa=a(ye,"P",{});var Mb=i(pa);Hf=r(Mb,`DETR Model (consisting of a backbone and encoder-decoder Transformer) with object detection heads on top, for tasks
such as COCO detection.`),Mb.forEach(t),Gf=c(ye),Bo=a(ye,"P",{});var ed=i(Bo);Wf=r(ed,"This model inherits from "),tr=a(ed,"A",{href:!0});var Ub=i(tr);Vf=r(Ub,"PreTrainedModel"),Ub.forEach(t),Bf=r(ed,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ed.forEach(t),Yf=c(ye),Yo=a(ye,"P",{});var td=i(Yo);Qf=r(td,"This model is also a PyTorch "),Qo=a(td,"A",{href:!0,rel:!0});var Hb=i(Qo);Jf=r(Hb,"torch.nn.Module"),Hb.forEach(t),Kf=r(td,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),td.forEach(t),Xf=c(ye),Z=a(ye,"DIV",{class:!0});var St=i(Z);b(Jo.$$.fragment,St),Zf=c(St),Re=a(St,"P",{});var hr=i(Re);eu=r(hr,"The "),or=a(hr,"A",{href:!0});var Gb=i(or);tu=r(Gb,"DetrForObjectDetection"),Gb.forEach(t),ou=r(hr," forward method, overrides the "),fa=a(hr,"CODE",{});var Wb=i(fa);nu=r(Wb,"__call__"),Wb.forEach(t),ru=r(hr," special method."),hr.forEach(t),su=c(St),b(ut.$$.fragment,St),au=c(St),b(gt.$$.fragment,St),St.forEach(t),ye.forEach(t),mi=c(o),Me=a(o,"H2",{class:!0});var od=i(Me);_t=a(od,"A",{id:!0,class:!0,href:!0});var Vb=i(_t);ua=a(Vb,"SPAN",{});var Bb=i(ua);b(Ko.$$.fragment,Bb),Bb.forEach(t),Vb.forEach(t),iu=c(od),ga=a(od,"SPAN",{});var Yb=i(ga);du=r(Yb,"DetrForSegmentation"),Yb.forEach(t),od.forEach(t),hi=c(o),U=a(o,"DIV",{class:!0});var De=i(U);b(Xo.$$.fragment,De),cu=c(De),_a=a(De,"P",{});var Qb=i(_a);lu=r(Qb,`DETR Model (consisting of a backbone and encoder-decoder Transformer) with a segmentation head on top, for tasks
such as COCO panoptic.`),Qb.forEach(t),mu=c(De),Zo=a(De,"P",{});var nd=i(Zo);hu=r(nd,"This model inherits from "),nr=a(nd,"A",{href:!0});var Jb=i(nr);pu=r(Jb,"PreTrainedModel"),Jb.forEach(t),fu=r(nd,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),nd.forEach(t),uu=c(De),en=a(De,"P",{});var rd=i(en);gu=r(rd,"This model is also a PyTorch "),tn=a(rd,"A",{href:!0,rel:!0});var Kb=i(tn);_u=r(Kb,"torch.nn.Module"),Kb.forEach(t),bu=r(rd,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),rd.forEach(t),vu=c(De),ee=a(De,"DIV",{class:!0});var Lt=i(ee);b(on.$$.fragment,Lt),yu=c(Lt),Ue=a(Lt,"P",{});var pr=i(Ue);Du=r(pr,"The "),rr=a(pr,"A",{href:!0});var Xb=i(rr);wu=r(Xb,"DetrForSegmentation"),Xb.forEach(t),Tu=r(pr," forward method, overrides the "),ba=a(pr,"CODE",{});var Zb=i(ba);xu=r(Zb,"__call__"),Zb.forEach(t),Eu=r(pr," special method."),pr.forEach(t),$u=c(Lt),b(bt.$$.fragment,Lt),ku=c(Lt),b(vt.$$.fragment,Lt),Lt.forEach(t),De.forEach(t),this.h()},h(){l(f,"name","hf:doc:metadata"),l(f,"content",JSON.stringify(fv)),l(u,"id","detr"),l(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(u,"href","#detr"),l(T,"class","relative group"),l(He,"id","overview"),l(He,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(He,"href","#overview"),l(Te,"class","relative group"),l(Mt,"href","https://arxiv.org/abs/2005.12872"),l(Mt,"rel","nofollow"),l(Ut,"href","https://huggingface.co/nielsr"),l(Ut,"rel","nofollow"),l(Ht,"href","https://github.com/facebookresearch/detr"),l(Ht,"rel","nofollow"),l(cn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Gt,"href","https://en.wikipedia.org/wiki/Hungarian_algorithm"),l(Gt,"rel","nofollow"),l(Wt,"href","https://giou.stanford.edu/"),l(Wt,"rel","nofollow"),l(ln,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(mn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(hn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(fn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"),l(un,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"),l(gn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"),l(Vt,"href","https://github.com/facebookresearch/detr/blob/a54b77800eb8e64e3ad0d8237789fcbf2f8350c5/models/detr.py#L227-L232"),l(Vt,"rel","nofollow"),l(_n,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(bn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(Bt,"href","https://github.com/rwightman/pytorch-image-models"),l(Bt,"rel","nofollow"),l(vn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"),l(yn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrImageProcessor"),l(Dn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.pad_and_create_pixel_mask"),l(Yt,"href","https://github.com/facebookresearch/detr/issues/150"),l(Yt,"rel","nofollow"),l(kn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(jn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(Fn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(On,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrImageProcessor"),l(Cn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrImageProcessor"),l(Pn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrImageProcessor"),l(to,"href","https://github.com/facebookresearch/detr"),l(to,"rel","nofollow"),l(oo,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/DETR"),l(oo,"rel","nofollow"),l(Be,"id","resources"),l(Be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Be,"href","#resources"),l(ke,"class","relative group"),l(In,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Nn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(so,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/DETR"),l(so,"rel","nofollow"),l(Sn,"href","./tasks/object_detection"),l(Qe,"id","transformers.models.detr.modeling_detr.DetrModelOutput"),l(Qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Qe,"href","#transformers.models.detr.modeling_detr.DetrModelOutput"),l(je,"class","relative group"),l(Fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Rn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Mn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Je,"id","transformers.DetrConfig"),l(Je,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Je,"href","#transformers.DetrConfig"),l(Ce,"class","relative group"),l(Un,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrModel"),l(uo,"href","https://huggingface.co/facebook/detr-resnet-50"),l(uo,"rel","nofollow"),l(Hn,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(Gn,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Xe,"id","transformers.DetrImageProcessor"),l(Xe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Xe,"href","#transformers.DetrImageProcessor"),l(Ie,"class","relative group"),l(Ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Wn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(et,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Vn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(tt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Bn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(ot,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Yn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(nt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(rt,"id","transformers.DetrFeatureExtractor"),l(rt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(rt,"href","#transformers.DetrFeatureExtractor"),l(Ne,"class","relative group"),l(st,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(at,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Qn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(it,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Jn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Kn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Xn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(lt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(mt,"id","transformers.DetrModel"),l(mt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(mt,"href","#transformers.DetrModel"),l(Ae,"class","relative group"),l(Zn,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(Ho,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Ho,"rel","nofollow"),l(er,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrModel"),l(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ft,"id","transformers.DetrForObjectDetection"),l(ft,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ft,"href","#transformers.DetrForObjectDetection"),l(Le,"class","relative group"),l(tr,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(Qo,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Qo,"rel","nofollow"),l(or,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(_t,"id","transformers.DetrForSegmentation"),l(_t,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(_t,"href","#transformers.DetrForSegmentation"),l(Me,"class","relative group"),l(nr,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(tn,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(tn,"rel","nofollow"),l(rr,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,m){e(document.head,f),h(o,E,m),h(o,T,m),e(T,u),e(u,x),v(p,x,null),e(T,g),e(T,H),e(H,id),h(o,xa,m),h(o,Te,m),e(Te,He),e(He,fr),v(Rt,fr,null),e(Te,dd),e(Te,ur),e(ur,cd),h(o,Ea,m),h(o,Ge,m),e(Ge,ld),e(Ge,Mt),e(Mt,md),e(Ge,hd),h(o,$a,m),h(o,an,m),e(an,pd),h(o,ka,m),h(o,dn,m),e(dn,gr),e(gr,fd),h(o,ja,m),h(o,_e,m),e(_e,ud),e(_e,Ut),e(Ut,gd),e(_e,_d),e(_e,Ht),e(Ht,bd),e(_e,vd),h(o,Fa,m),h(o,We,m),e(We,yd),e(We,cn),e(cn,Dd),e(We,wd),h(o,Oa,m),h(o,j,m),e(j,Td),e(j,_r),e(_r,xd),e(j,Ed),e(j,br),e(br,$d),e(j,kd),e(j,vr),e(vr,jd),e(j,Fd),e(j,yr),e(yr,Od),e(j,zd),e(j,Dr),e(Dr,Cd),e(j,Pd),e(j,wr),e(wr,qd),e(j,Id),e(j,Tr),e(Tr,Nd),e(j,Ad),e(j,xr),e(xr,Sd),e(j,Ld),h(o,za,m),h(o,P,m),e(P,Rd),e(P,Er),e(Er,Md),e(P,Ud),e(P,$r),e($r,Hd),e(P,Gd),e(P,kr),e(kr,Wd),e(P,Vd),e(P,jr),e(jr,Bd),e(P,Yd),e(P,Fr),e(Fr,Qd),e(P,Jd),e(P,Or),e(Or,Kd),e(P,Xd),h(o,Ca,m),h(o,J,m),e(J,Zd),e(J,zr),e(zr,ec),e(J,tc),e(J,Gt),e(Gt,oc),e(J,nc),e(J,Wt),e(Wt,rc),e(J,sc),h(o,Pa,m),h(o,K,m),e(K,ac),e(K,ln),e(ln,ic),e(K,dc),e(K,mn),e(mn,cc),e(K,lc),e(K,hn),e(hn,mc),e(K,hc),h(o,qa,m),h(o,pn,m),e(pn,pc),h(o,Ia,m),h(o,F,m),e(F,ne),e(ne,fc),e(ne,Cr),e(Cr,uc),e(ne,gc),e(ne,Pr),e(Pr,_c),e(ne,bc),e(ne,fn),e(fn,vc),e(ne,yc),e(F,Dc),e(F,qr),e(qr,wc),e(F,Tc),e(F,re),e(re,xc),e(re,Ir),e(Ir,Ec),e(re,$c),e(re,un),e(un,kc),e(re,jc),e(re,Nr),e(Nr,Fc),e(re,Oc),e(F,zc),e(F,se),e(se,Cc),e(se,Ar),e(Ar,Pc),e(se,qc),e(se,gn),e(gn,Ic),e(se,Nc),e(se,Sr),e(Sr,Ac),e(se,Sc),e(F,Lc),e(F,B),e(B,Rc),e(B,Lr),e(Lr,Mc),e(B,Uc),e(B,Rr),e(Rr,Hc),e(B,Gc),e(B,Mr),e(Mr,Wc),e(B,Vc),e(B,Vt),e(Vt,Bc),e(B,Yc),e(F,Qc),e(F,N),e(N,_n),e(_n,Jc),e(N,Kc),e(N,bn),e(bn,Xc),e(N,Zc),e(N,Bt),e(Bt,el),e(N,tl),e(N,Ur),e(Ur,ol),e(N,nl),e(N,vn),e(vn,rl),e(N,sl),e(N,Hr),e(Hr,al),e(N,il),e(F,dl),e(F,ae),e(ae,cl),e(ae,yn),e(yn,ll),e(ae,ml),e(ae,Gr),e(Gr,hl),e(ae,pl),e(ae,Dn),e(Dn,fl),e(ae,ul),e(F,gl),e(F,xe),e(xe,_l),e(xe,Wr),e(Wr,bl),e(xe,vl),e(xe,Yt),e(Yt,yl),e(xe,Dl),h(o,Na,m),h(o,wn,m),e(wn,wl),h(o,Aa,m),h(o,Tn,m),e(Tn,Tl),h(o,Sa,m),v(Qt,o,m),h(o,La,m),h(o,xn,m),e(xn,xl),h(o,Ra,m),v(Jt,o,m),h(o,Ma,m),h(o,En,m),e(En,El),h(o,Ua,m),v(Kt,o,m),h(o,Ha,m),h(o,$n,m),e($n,$l),h(o,Ga,m),h(o,Ve,m),e(Ve,Vr),e(Vr,ie),e(ie,Br),e(Br,kl),e(ie,jl),e(ie,Yr),e(Yr,Fl),e(ie,Ol),e(ie,Qr),e(Qr,zl),e(ie,Cl),e(ie,Jr),e(Jr,Pl),e(Ve,ql),e(Ve,S),e(S,de),e(de,Kr),e(Kr,Xr),e(Xr,Il),e(de,Nl),e(de,Zr),e(Zr,Al),e(de,Sl),e(de,es),e(es,Ll),e(de,Rl),e(de,ts),e(ts,Ml),e(S,Ul),e(S,ce),e(ce,os),e(os,ns),e(ns,Hl),e(ce,Gl),e(ce,rs),e(rs,kn),e(kn,Wl),e(ce,Vl),e(ce,ss),e(ss,jn),e(jn,Bl),e(ce,Yl),e(ce,as),e(as,Fn),e(Fn,Ql),e(S,Jl),e(S,le),e(le,is),e(is,ds),e(ds,Kl),e(le,Xl),e(le,cs),e(cs,Zl),e(le,em),e(le,ls),e(ls,tm),e(le,om),e(le,ms),e(ms,nm),e(S,rm),e(S,me),e(me,Xt),e(Xt,hs),e(hs,sm),e(Xt,am),e(Xt,On),e(On,im),e(me,dm),e(me,Ee),e(Ee,cm),e(Ee,ps),e(ps,lm),e(Ee,mm),e(Ee,fs),e(fs,hm),e(Ee,pm),e(me,fm),e(me,L),e(L,um),e(L,us),e(us,gm),e(L,_m),e(L,gs),e(gs,bm),e(L,vm),e(L,_s),e(_s,ym),e(L,Dm),e(L,bs),e(bs,wm),e(L,Tm),e(L,vs),e(vs,xm),e(L,Em),e(me,$m),e(me,he),e(he,km),e(he,ys),e(ys,jm),e(he,Fm),e(he,Ds),e(Ds,Om),e(he,zm),e(he,ws),e(ws,Cm),e(he,Pm),e(S,qm),e(S,pe),e(pe,zn),e(zn,Ts),e(Ts,Im),e(zn,Nm),e(pe,Am),e(pe,xs),e(xs,Es),e(Es,Sm),e(pe,Lm),e(pe,$s),e($s,ks),e(ks,Rm),e(pe,Mm),e(pe,Zt),e(Zt,js),e(js,Um),e(Zt,Hm),e(Zt,Fs),e(Fs,Gm),e(S,Wm),e(S,fe),e(fe,Os),e(Os,zs),e(zs,Vm),e(fe,Bm),e(fe,eo),e(eo,Cs),e(Cs,Ym),e(eo,Qm),e(eo,Ps),e(Ps,Jm),e(fe,Km),e(fe,$e),e($e,qs),e(qs,Xm),e($e,Zm),e($e,Is),e(Is,eh),e($e,th),e($e,Ns),e(Ns,oh),e(fe,nh),e(fe,ue),e(ue,As),e(As,rh),e(ue,sh),e(ue,Ss),e(Ss,ah),e(ue,ih),e(ue,Ls),e(Ls,dh),e(ue,ch),e(ue,Rs),e(Rs,lh),h(o,Wa,m),h(o,$,m),e($,mh),e($,Cn),e(Cn,hh),e($,ph),e($,Ms),e(Ms,fh),e($,uh),e($,Us),e(Us,gh),e($,_h),e($,Hs),e(Hs,bh),e($,vh),e($,Pn),e(Pn,yh),e($,Dh),e($,Gs),e(Gs,wh),e($,Th),e($,Ws),e(Ws,xh),e($,Eh),e($,to),e(to,$h),e($,kh),e($,oo),e(oo,jh),e($,Fh),h(o,Va,m),h(o,ke,m),e(ke,Be),e(Be,Vs),v(no,Vs,null),e(ke,Oh),e(ke,Bs),e(Bs,zh),h(o,Ba,m),h(o,qn,m),e(qn,Ch),h(o,Ya,m),v(ro,o,m),h(o,Qa,m),h(o,Ye,m),e(Ye,ge),e(ge,Ph),e(ge,In),e(In,qh),e(ge,Ih),e(ge,Nn),e(Nn,Nh),e(ge,Ah),e(ge,so),e(so,Sh),e(ge,Lh),e(Ye,Rh),e(Ye,An),e(An,Mh),e(An,Sn),e(Sn,Uh),h(o,Ja,m),h(o,Ln,m),e(Ln,Hh),h(o,Ka,m),h(o,je,m),e(je,Qe),e(Qe,Ys),v(ao,Ys,null),e(je,Gh),e(je,Qs),e(Qs,Wh),h(o,Xa,m),h(o,Fe,m),v(io,Fe,null),e(Fe,Vh),e(Fe,Js),e(Js,Bh),h(o,Za,m),h(o,Oe,m),v(co,Oe,null),e(Oe,Yh),e(Oe,lo),e(lo,Qh),e(lo,Rn),e(Rn,Jh),e(lo,Kh),h(o,ei,m),h(o,ze,m),v(mo,ze,null),e(ze,Xh),e(ze,ho),e(ho,Zh),e(ho,Mn),e(Mn,ep),e(ho,tp),h(o,ti,m),h(o,Ce,m),e(Ce,Je),e(Je,Ks),v(po,Ks,null),e(Ce,op),e(Ce,Xs),e(Xs,np),h(o,oi,m),h(o,Y,m),v(fo,Y,null),e(Y,rp),e(Y,Pe),e(Pe,sp),e(Pe,Un),e(Un,ap),e(Pe,ip),e(Pe,uo),e(uo,dp),e(Pe,cp),e(Y,lp),e(Y,qe),e(qe,mp),e(qe,Hn),e(Hn,hp),e(qe,pp),e(qe,Gn),e(Gn,fp),e(qe,up),e(Y,gp),v(Ke,Y,null),h(o,ni,m),h(o,Ie,m),e(Ie,Xe),e(Xe,Zs),v(go,Zs,null),e(Ie,_p),e(Ie,ea),e(ea,bp),h(o,ri,m),h(o,z,m),v(_o,z,null),e(z,vp),e(z,ta),e(ta,yp),e(z,Dp),e(z,Ze),v(bo,Ze,null),e(Ze,wp),e(Ze,oa),e(oa,Tp),e(z,xp),e(z,et),v(vo,et,null),e(et,Ep),e(et,yo),e(yo,$p),e(yo,Wn),e(Wn,kp),e(yo,jp),e(z,Fp),e(z,tt),v(Do,tt,null),e(tt,Op),e(tt,wo),e(wo,zp),e(wo,Vn),e(Vn,Cp),e(wo,Pp),e(z,qp),e(z,ot),v(To,ot,null),e(ot,Ip),e(ot,xo),e(xo,Np),e(xo,Bn),e(Bn,Ap),e(xo,Sp),e(z,Lp),e(z,nt),v(Eo,nt,null),e(nt,Rp),e(nt,$o),e($o,Mp),e($o,Yn),e(Yn,Up),e($o,Hp),h(o,si,m),h(o,Ne,m),e(Ne,rt),e(rt,na),v(ko,na,null),e(Ne,Gp),e(Ne,ra),e(ra,Wp),h(o,ai,m),h(o,C,m),v(jo,C,null),e(C,Vp),e(C,st),v(Fo,st,null),e(st,Bp),e(st,sa),e(sa,Yp),e(C,Qp),e(C,at),v(Oo,at,null),e(at,Jp),e(at,aa),e(aa,Kp),e(C,Xp),e(C,it),v(zo,it,null),e(it,Zp),e(it,Co),e(Co,ef),e(Co,Qn),e(Qn,tf),e(Co,of),e(C,nf),e(C,dt),v(Po,dt,null),e(dt,rf),e(dt,qo),e(qo,sf),e(qo,Jn),e(Jn,af),e(qo,df),e(C,cf),e(C,ct),v(Io,ct,null),e(ct,lf),e(ct,No),e(No,mf),e(No,Kn),e(Kn,hf),e(No,pf),e(C,ff),e(C,lt),v(Ao,lt,null),e(lt,uf),e(lt,So),e(So,gf),e(So,Xn),e(Xn,_f),e(So,bf),h(o,ii,m),h(o,Ae,m),e(Ae,mt),e(mt,ia),v(Lo,ia,null),e(Ae,vf),e(Ae,da),e(da,yf),h(o,di,m),h(o,R,m),v(Ro,R,null),e(R,Df),e(R,ca),e(ca,wf),e(R,Tf),e(R,Mo),e(Mo,xf),e(Mo,Zn),e(Zn,Ef),e(Mo,$f),e(R,kf),e(R,Uo),e(Uo,jf),e(Uo,Ho),e(Ho,Ff),e(Uo,Of),e(R,zf),e(R,X),v(Go,X,null),e(X,Cf),e(X,Se),e(Se,Pf),e(Se,er),e(er,qf),e(Se,If),e(Se,la),e(la,Nf),e(Se,Af),e(X,Sf),v(ht,X,null),e(X,Lf),v(pt,X,null),h(o,ci,m),h(o,Le,m),e(Le,ft),e(ft,ma),v(Wo,ma,null),e(Le,Rf),e(Le,ha),e(ha,Mf),h(o,li,m),h(o,M,m),v(Vo,M,null),e(M,Uf),e(M,pa),e(pa,Hf),e(M,Gf),e(M,Bo),e(Bo,Wf),e(Bo,tr),e(tr,Vf),e(Bo,Bf),e(M,Yf),e(M,Yo),e(Yo,Qf),e(Yo,Qo),e(Qo,Jf),e(Yo,Kf),e(M,Xf),e(M,Z),v(Jo,Z,null),e(Z,Zf),e(Z,Re),e(Re,eu),e(Re,or),e(or,tu),e(Re,ou),e(Re,fa),e(fa,nu),e(Re,ru),e(Z,su),v(ut,Z,null),e(Z,au),v(gt,Z,null),h(o,mi,m),h(o,Me,m),e(Me,_t),e(_t,ua),v(Ko,ua,null),e(Me,iu),e(Me,ga),e(ga,du),h(o,hi,m),h(o,U,m),v(Xo,U,null),e(U,cu),e(U,_a),e(_a,lu),e(U,mu),e(U,Zo),e(Zo,hu),e(Zo,nr),e(nr,pu),e(Zo,fu),e(U,uu),e(U,en),e(en,gu),e(en,tn),e(tn,_u),e(en,bu),e(U,vu),e(U,ee),v(on,ee,null),e(ee,yu),e(ee,Ue),e(Ue,Du),e(Ue,rr),e(rr,wu),e(Ue,Tu),e(Ue,ba),e(ba,xu),e(Ue,Eu),e(ee,$u),v(bt,ee,null),e(ee,ku),v(vt,ee,null),pi=!0},p(o,[m]){const nn={};m&2&&(nn.$$scope={dirty:m,ctx:o}),Ke.$set(nn);const va={};m&2&&(va.$$scope={dirty:m,ctx:o}),ht.$set(va);const ya={};m&2&&(ya.$$scope={dirty:m,ctx:o}),pt.$set(ya);const Da={};m&2&&(Da.$$scope={dirty:m,ctx:o}),ut.$set(Da);const rn={};m&2&&(rn.$$scope={dirty:m,ctx:o}),gt.$set(rn);const wa={};m&2&&(wa.$$scope={dirty:m,ctx:o}),bt.$set(wa);const Ta={};m&2&&(Ta.$$scope={dirty:m,ctx:o}),vt.$set(Ta)},i(o){pi||(y(p.$$.fragment,o),y(Rt.$$.fragment,o),y(Qt.$$.fragment,o),y(Jt.$$.fragment,o),y(Kt.$$.fragment,o),y(no.$$.fragment,o),y(ro.$$.fragment,o),y(ao.$$.fragment,o),y(io.$$.fragment,o),y(co.$$.fragment,o),y(mo.$$.fragment,o),y(po.$$.fragment,o),y(fo.$$.fragment,o),y(Ke.$$.fragment,o),y(go.$$.fragment,o),y(_o.$$.fragment,o),y(bo.$$.fragment,o),y(vo.$$.fragment,o),y(Do.$$.fragment,o),y(To.$$.fragment,o),y(Eo.$$.fragment,o),y(ko.$$.fragment,o),y(jo.$$.fragment,o),y(Fo.$$.fragment,o),y(Oo.$$.fragment,o),y(zo.$$.fragment,o),y(Po.$$.fragment,o),y(Io.$$.fragment,o),y(Ao.$$.fragment,o),y(Lo.$$.fragment,o),y(Ro.$$.fragment,o),y(Go.$$.fragment,o),y(ht.$$.fragment,o),y(pt.$$.fragment,o),y(Wo.$$.fragment,o),y(Vo.$$.fragment,o),y(Jo.$$.fragment,o),y(ut.$$.fragment,o),y(gt.$$.fragment,o),y(Ko.$$.fragment,o),y(Xo.$$.fragment,o),y(on.$$.fragment,o),y(bt.$$.fragment,o),y(vt.$$.fragment,o),pi=!0)},o(o){D(p.$$.fragment,o),D(Rt.$$.fragment,o),D(Qt.$$.fragment,o),D(Jt.$$.fragment,o),D(Kt.$$.fragment,o),D(no.$$.fragment,o),D(ro.$$.fragment,o),D(ao.$$.fragment,o),D(io.$$.fragment,o),D(co.$$.fragment,o),D(mo.$$.fragment,o),D(po.$$.fragment,o),D(fo.$$.fragment,o),D(Ke.$$.fragment,o),D(go.$$.fragment,o),D(_o.$$.fragment,o),D(bo.$$.fragment,o),D(vo.$$.fragment,o),D(Do.$$.fragment,o),D(To.$$.fragment,o),D(Eo.$$.fragment,o),D(ko.$$.fragment,o),D(jo.$$.fragment,o),D(Fo.$$.fragment,o),D(Oo.$$.fragment,o),D(zo.$$.fragment,o),D(Po.$$.fragment,o),D(Io.$$.fragment,o),D(Ao.$$.fragment,o),D(Lo.$$.fragment,o),D(Ro.$$.fragment,o),D(Go.$$.fragment,o),D(ht.$$.fragment,o),D(pt.$$.fragment,o),D(Wo.$$.fragment,o),D(Vo.$$.fragment,o),D(Jo.$$.fragment,o),D(ut.$$.fragment,o),D(gt.$$.fragment,o),D(Ko.$$.fragment,o),D(Xo.$$.fragment,o),D(on.$$.fragment,o),D(bt.$$.fragment,o),D(vt.$$.fragment,o),pi=!1},d(o){t(f),o&&t(E),o&&t(T),w(p),o&&t(xa),o&&t(Te),w(Rt),o&&t(Ea),o&&t(Ge),o&&t($a),o&&t(an),o&&t(ka),o&&t(dn),o&&t(ja),o&&t(_e),o&&t(Fa),o&&t(We),o&&t(Oa),o&&t(j),o&&t(za),o&&t(P),o&&t(Ca),o&&t(J),o&&t(Pa),o&&t(K),o&&t(qa),o&&t(pn),o&&t(Ia),o&&t(F),o&&t(Na),o&&t(wn),o&&t(Aa),o&&t(Tn),o&&t(Sa),w(Qt,o),o&&t(La),o&&t(xn),o&&t(Ra),w(Jt,o),o&&t(Ma),o&&t(En),o&&t(Ua),w(Kt,o),o&&t(Ha),o&&t($n),o&&t(Ga),o&&t(Ve),o&&t(Wa),o&&t($),o&&t(Va),o&&t(ke),w(no),o&&t(Ba),o&&t(qn),o&&t(Ya),w(ro,o),o&&t(Qa),o&&t(Ye),o&&t(Ja),o&&t(Ln),o&&t(Ka),o&&t(je),w(ao),o&&t(Xa),o&&t(Fe),w(io),o&&t(Za),o&&t(Oe),w(co),o&&t(ei),o&&t(ze),w(mo),o&&t(ti),o&&t(Ce),w(po),o&&t(oi),o&&t(Y),w(fo),w(Ke),o&&t(ni),o&&t(Ie),w(go),o&&t(ri),o&&t(z),w(_o),w(bo),w(vo),w(Do),w(To),w(Eo),o&&t(si),o&&t(Ne),w(ko),o&&t(ai),o&&t(C),w(jo),w(Fo),w(Oo),w(zo),w(Po),w(Io),w(Ao),o&&t(ii),o&&t(Ae),w(Lo),o&&t(di),o&&t(R),w(Ro),w(Go),w(ht),w(pt),o&&t(ci),o&&t(Le),w(Wo),o&&t(li),o&&t(M),w(Vo),w(Jo),w(ut),w(gt),o&&t(mi),o&&t(Me),w(Ko),o&&t(hi),o&&t(U),w(Xo),w(on),w(bt),w(vt)}}}const fv={local:"detr",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources"},{local:"transformers.models.detr.modeling_detr.DetrModelOutput",title:"DETR specific outputs"},{local:"transformers.DetrConfig",title:"DetrConfig"},{local:"transformers.DetrImageProcessor",title:"DetrImageProcessor"},{local:"transformers.DetrFeatureExtractor",title:"DetrFeatureExtractor"},{local:"transformers.DetrModel",title:"DetrModel"},{local:"transformers.DetrForObjectDetection",title:"DetrForObjectDetection"},{local:"transformers.DetrForSegmentation",title:"DetrForSegmentation"}],title:"DETR"};function uv(I){return rv(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Tv extends ev{constructor(f){super();tv(this,f,uv,pv,ov,{})}}export{Tv as default,fv as metadata};
