import{S as a$,i as r$,s as i$,e as a,k as c,w as b,t as n,M as d$,c as r,d as o,m as p,a as i,x as v,h as s,b as l,N as s$,G as e,g as u,y,q as w,o as $,B as x,v as l$,L as It}from"../../chunks/vendor-hf-doc-builder.js";import{T as Lt}from"../../chunks/Tip-hf-doc-builder.js";import{D as O}from"../../chunks/Docstring-hf-doc-builder.js";import{C as we}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as ye}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Nt}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";import{P as Vr}from"../../chunks/PipelineTag-hf-doc-builder.js";function c$(q){let m,k,g,_,T;return{c(){m=a("p"),k=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),_=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(f,"CODE",{});var F=i(g);_=s(F,"Module"),F.forEach(o),T=s(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(o)},m(d,f){u(d,m,f),e(m,k),e(m,g),e(g,_),e(m,T)},d(d){d&&o(m)}}}function p$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, T5Model

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = T5Model.from_pretrained("t5-small")

input_ids = tokenizer(
    "Studies have been shown that owning a dog is good for you", return_tensors="pt"
).input_ids  # Batch size 1
decoder_input_ids = tokenizer("Studies show that", return_tensors="pt").input_ids  # Batch size 1

# preprocess: Prepend decoder_input_ids with start token which is pad token for T5Model.
# This is not needed for torch's T5ForConditionalGeneration as it does this internally using labels arg.
decoder_input_ids = model._shift_right(decoder_input_ids)

# forward pass
outputs = model(input_ids=input_ids, decoder_input_ids=decoder_input_ids)
last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, T5Model

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = T5Model.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;Studies have been shown that owning a dog is good for you&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>
<span class="hljs-meta">... </span>).input_ids  <span class="hljs-comment"># Batch size 1</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_input_ids = tokenizer(<span class="hljs-string">&quot;Studies show that&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids  <span class="hljs-comment"># Batch size 1</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># preprocess: Prepend decoder_input_ids with start token which is pad token for T5Model.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># This is not needed for torch&#x27;s T5ForConditionalGeneration as it does this internally using labels arg.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_input_ids = model._shift_right(decoder_input_ids)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_ids=input_ids, decoder_input_ids=decoder_input_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){m=a("p"),k=n("Example:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Example:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function h$(q){let m,k,g,_,T;return{c(){m=a("p"),k=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),_=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(f,"CODE",{});var F=i(g);_=s(F,"Module"),F.forEach(o),T=s(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(o)},m(d,f){u(d,m,f),e(m,k),e(m,g),e(g,_),e(m,T)},d(d){d&&o(m)}}}function u$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, T5ForConditionalGeneration

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = T5ForConditionalGeneration.from_pretrained("t5-small")

# training
input_ids = tokenizer("The <extra_id_0> walks in <extra_id_1> park", return_tensors="pt").input_ids
labels = tokenizer("<extra_id_0> cute dog <extra_id_1> the <extra_id_2>", return_tensors="pt").input_ids
outputs = model(input_ids=input_ids, labels=labels)
loss = outputs.loss
logits = outputs.logits

# inference
input_ids = tokenizer(
    "summarize: studies have shown that owning a dog is good for you", return_tensors="pt"
).input_ids  # Batch size 1
outputs = model.generate(input_ids)
print(tokenizer.decode(outputs[0], skip_special_tokens=True))
# studies have shown that owning a dog is good for you.`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, T5ForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = T5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># training</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(<span class="hljs-string">&quot;The &lt;extra_id_0&gt; walks in &lt;extra_id_1&gt; park&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>labels = tokenizer(<span class="hljs-string">&quot;&lt;extra_id_0&gt; cute dog &lt;extra_id_1&gt; the &lt;extra_id_2&gt;&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_ids=input_ids, labels=labels)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># inference</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;summarize: studies have shown that owning a dog is good for you&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>
<span class="hljs-meta">... </span>).input_ids  <span class="hljs-comment"># Batch size 1</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.generate(input_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(tokenizer.decode(outputs[<span class="hljs-number">0</span>], skip_special_tokens=<span class="hljs-literal">True</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># studies have shown that owning a dog is good for you.</span>`}}),{c(){m=a("p"),k=n("Examples:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Examples:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function m$(q){let m,k,g,_,T;return{c(){m=a("p"),k=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),_=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(f,"CODE",{});var F=i(g);_=s(F,"Module"),F.forEach(o),T=s(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(o)},m(d,f){u(d,m,f),e(m,k),e(m,g),e(g,_),e(m,T)},d(d){d&&o(m)}}}function f$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, T5EncoderModel

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = T5EncoderModel.from_pretrained("t5-small")
input_ids = tokenizer(
    "Studies have been shown that owning a dog is good for you", return_tensors="pt"
).input_ids  # Batch size 1
outputs = model(input_ids=input_ids)
last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, T5EncoderModel

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = T5EncoderModel.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;Studies have been shown that owning a dog is good for you&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>
<span class="hljs-meta">... </span>).input_ids  <span class="hljs-comment"># Batch size 1</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_ids=input_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){m=a("p"),k=n("Example:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Example:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function _$(q){let m,k,g,_,T,d,f,F,Le,je,I,ue,J,E,Ne,B,me,Qe,Y,X,ne,R,ie,Ie,H,De,Me,S,Se,de,fe,C,P,_e,Q,Ce,ge,K,Ge,Ae,A,Be,Z,G,$e,D,Ue,xe,U,We,V,Re,Te,L,ze,N,He,Ke;return{c(){m=a("p"),k=n("TensorFlow models and layers in "),g=a("code"),_=n("transformers"),T=n(" accept two formats as input:"),d=c(),f=a("ul"),F=a("li"),Le=n("having all inputs as keyword arguments (like PyTorch models), or"),je=c(),I=a("li"),ue=n("having all inputs as a list, tuple or dict in the first positional argument."),J=c(),E=a("p"),Ne=n(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),B=a("code"),me=n("model.fit()"),Qe=n(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),Y=a("code"),X=n("model.fit()"),ne=n(` supports! If, however, you want to use the second
format outside of Keras methods like `),R=a("code"),ie=n("fit()"),Ie=n(" and "),H=a("code"),De=n("predict()"),Me=n(`, such as when creating your own layers or models with
the Keras `),S=a("code"),Se=n("Functional"),de=n(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),fe=c(),C=a("ul"),P=a("li"),_e=n("a single Tensor with "),Q=a("code"),Ce=n("input_ids"),ge=n(" only and nothing else: "),K=a("code"),Ge=n("model(input_ids)"),Ae=c(),A=a("li"),Be=n(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),Z=a("code"),G=n("model([input_ids, attention_mask])"),$e=n(" or "),D=a("code"),Ue=n("model([input_ids, attention_mask, token_type_ids])"),xe=c(),U=a("li"),We=n(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),V=a("code"),Re=n('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),Te=c(),L=a("p"),ze=n(`Note that when creating models and layers with
`),N=a("a"),He=n("subclassing"),Ke=n(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(z){m=r(z,"P",{});var j=i(m);k=s(j,"TensorFlow models and layers in "),g=r(j,"CODE",{});var ft=i(g);_=s(ft,"transformers"),ft.forEach(o),T=s(j," accept two formats as input:"),j.forEach(o),d=p(z),f=r(z,"UL",{});var ke=i(f);F=r(ke,"LI",{});var et=i(F);Le=s(et,"having all inputs as keyword arguments (like PyTorch models), or"),et.forEach(o),je=p(ke),I=r(ke,"LI",{});var tt=i(I);ue=s(tt,"having all inputs as a list, tuple or dict in the first positional argument."),tt.forEach(o),ke.forEach(o),J=p(z),E=r(z,"P",{});var M=i(E);Ne=s(M,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),B=r(M,"CODE",{});var _t=i(B);me=s(_t,"model.fit()"),_t.forEach(o),Qe=s(M,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),Y=r(M,"CODE",{});var ot=i(Y);X=s(ot,"model.fit()"),ot.forEach(o),ne=s(M,` supports! If, however, you want to use the second
format outside of Keras methods like `),R=r(M,"CODE",{});var se=i(R);ie=s(se,"fit()"),se.forEach(o),Ie=s(M," and "),H=r(M,"CODE",{});var gt=i(H);De=s(gt,"predict()"),gt.forEach(o),Me=s(M,`, such as when creating your own layers or models with
the Keras `),S=r(M,"CODE",{});var Ve=i(S);Se=s(Ve,"Functional"),Ve.forEach(o),de=s(M,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),M.forEach(o),fe=p(z),C=r(z,"UL",{});var W=i(C);P=r(W,"LI",{});var ee=i(P);_e=s(ee,"a single Tensor with "),Q=r(ee,"CODE",{});var Ye=i(Q);Ce=s(Ye,"input_ids"),Ye.forEach(o),ge=s(ee," only and nothing else: "),K=r(ee,"CODE",{});var Tt=i(K);Ge=s(Tt,"model(input_ids)"),Tt.forEach(o),ee.forEach(o),Ae=p(W),A=r(W,"LI",{});var te=i(A);Be=s(te,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),Z=r(te,"CODE",{});var Ze=i(Z);G=s(Ze,"model([input_ids, attention_mask])"),Ze.forEach(o),$e=s(te," or "),D=r(te,"CODE",{});var kt=i(D);Ue=s(kt,"model([input_ids, attention_mask, token_type_ids])"),kt.forEach(o),te.forEach(o),xe=p(W),U=r(W,"LI",{});var Je=i(U);We=s(Je,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),V=r(Je,"CODE",{});var pt=i(V);Re=s(pt,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),pt.forEach(o),Je.forEach(o),W.forEach(o),Te=p(z),L=r(z,"P",{});var oe=i(L);ze=s(oe,`Note that when creating models and layers with
`),N=r(oe,"A",{href:!0,rel:!0});var bt=i(N);He=s(bt,"subclassing"),bt.forEach(o),Ke=s(oe,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),oe.forEach(o),this.h()},h(){l(N,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),l(N,"rel","nofollow")},m(z,j){u(z,m,j),e(m,k),e(m,g),e(g,_),e(m,T),u(z,d,j),u(z,f,j),e(f,F),e(F,Le),e(f,je),e(f,I),e(I,ue),u(z,J,j),u(z,E,j),e(E,Ne),e(E,B),e(B,me),e(E,Qe),e(E,Y),e(Y,X),e(E,ne),e(E,R),e(R,ie),e(E,Ie),e(E,H),e(H,De),e(E,Me),e(E,S),e(S,Se),e(E,de),u(z,fe,j),u(z,C,j),e(C,P),e(P,_e),e(P,Q),e(Q,Ce),e(P,ge),e(P,K),e(K,Ge),e(C,Ae),e(C,A),e(A,Be),e(A,Z),e(Z,G),e(A,$e),e(A,D),e(D,Ue),e(C,xe),e(C,U),e(U,We),e(U,V),e(V,Re),u(z,Te,j),u(z,L,j),e(L,ze),e(L,N),e(N,He),e(L,Ke)},d(z){z&&o(m),z&&o(d),z&&o(f),z&&o(J),z&&o(E),z&&o(fe),z&&o(C),z&&o(Te),z&&o(L)}}}function g$(q){let m,k,g,_,T;return{c(){m=a("p"),k=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),_=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(f,"CODE",{});var F=i(g);_=s(F,"Module"),F.forEach(o),T=s(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(o)},m(d,f){u(d,m,f),e(m,k),e(m,g),e(g,_),e(m,T)},d(d){d&&o(m)}}}function T$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, TFT5Model

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = TFT5Model.from_pretrained("t5-small")

input_ids = tokenizer(
    "Studies have been shown that owning a dog is good for you", return_tensors="tf"
).input_ids  # Batch size 1
decoder_input_ids = tokenizer("Studies show that", return_tensors="tf").input_ids  # Batch size 1

# preprocess: Prepend decoder_input_ids with start token which is pad token for T5Model.
# This is not needed for torch's T5ForConditionalGeneration as it does this internally using labels arg.
decoder_input_ids = model._shift_right(decoder_input_ids)

# forward pass
outputs = model(input_ids, decoder_input_ids=decoder_input_ids)
last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFT5Model

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFT5Model.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;Studies have been shown that owning a dog is good for you&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>
<span class="hljs-meta">... </span>).input_ids  <span class="hljs-comment"># Batch size 1</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_input_ids = tokenizer(<span class="hljs-string">&quot;Studies show that&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>).input_ids  <span class="hljs-comment"># Batch size 1</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># preprocess: Prepend decoder_input_ids with start token which is pad token for T5Model.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># This is not needed for torch&#x27;s T5ForConditionalGeneration as it does this internally using labels arg.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_input_ids = model._shift_right(decoder_input_ids)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_ids, decoder_input_ids=decoder_input_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){m=a("p"),k=n("Examples:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Examples:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function k$(q){let m,k,g,_,T,d,f,F,Le,je,I,ue,J,E,Ne,B,me,Qe,Y,X,ne,R,ie,Ie,H,De,Me,S,Se,de,fe,C,P,_e,Q,Ce,ge,K,Ge,Ae,A,Be,Z,G,$e,D,Ue,xe,U,We,V,Re,Te,L,ze,N,He,Ke;return{c(){m=a("p"),k=n("TensorFlow models and layers in "),g=a("code"),_=n("transformers"),T=n(" accept two formats as input:"),d=c(),f=a("ul"),F=a("li"),Le=n("having all inputs as keyword arguments (like PyTorch models), or"),je=c(),I=a("li"),ue=n("having all inputs as a list, tuple or dict in the first positional argument."),J=c(),E=a("p"),Ne=n(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),B=a("code"),me=n("model.fit()"),Qe=n(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),Y=a("code"),X=n("model.fit()"),ne=n(` supports! If, however, you want to use the second
format outside of Keras methods like `),R=a("code"),ie=n("fit()"),Ie=n(" and "),H=a("code"),De=n("predict()"),Me=n(`, such as when creating your own layers or models with
the Keras `),S=a("code"),Se=n("Functional"),de=n(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),fe=c(),C=a("ul"),P=a("li"),_e=n("a single Tensor with "),Q=a("code"),Ce=n("input_ids"),ge=n(" only and nothing else: "),K=a("code"),Ge=n("model(input_ids)"),Ae=c(),A=a("li"),Be=n(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),Z=a("code"),G=n("model([input_ids, attention_mask])"),$e=n(" or "),D=a("code"),Ue=n("model([input_ids, attention_mask, token_type_ids])"),xe=c(),U=a("li"),We=n(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),V=a("code"),Re=n('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),Te=c(),L=a("p"),ze=n(`Note that when creating models and layers with
`),N=a("a"),He=n("subclassing"),Ke=n(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(z){m=r(z,"P",{});var j=i(m);k=s(j,"TensorFlow models and layers in "),g=r(j,"CODE",{});var ft=i(g);_=s(ft,"transformers"),ft.forEach(o),T=s(j," accept two formats as input:"),j.forEach(o),d=p(z),f=r(z,"UL",{});var ke=i(f);F=r(ke,"LI",{});var et=i(F);Le=s(et,"having all inputs as keyword arguments (like PyTorch models), or"),et.forEach(o),je=p(ke),I=r(ke,"LI",{});var tt=i(I);ue=s(tt,"having all inputs as a list, tuple or dict in the first positional argument."),tt.forEach(o),ke.forEach(o),J=p(z),E=r(z,"P",{});var M=i(E);Ne=s(M,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),B=r(M,"CODE",{});var _t=i(B);me=s(_t,"model.fit()"),_t.forEach(o),Qe=s(M,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),Y=r(M,"CODE",{});var ot=i(Y);X=s(ot,"model.fit()"),ot.forEach(o),ne=s(M,` supports! If, however, you want to use the second
format outside of Keras methods like `),R=r(M,"CODE",{});var se=i(R);ie=s(se,"fit()"),se.forEach(o),Ie=s(M," and "),H=r(M,"CODE",{});var gt=i(H);De=s(gt,"predict()"),gt.forEach(o),Me=s(M,`, such as when creating your own layers or models with
the Keras `),S=r(M,"CODE",{});var Ve=i(S);Se=s(Ve,"Functional"),Ve.forEach(o),de=s(M,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),M.forEach(o),fe=p(z),C=r(z,"UL",{});var W=i(C);P=r(W,"LI",{});var ee=i(P);_e=s(ee,"a single Tensor with "),Q=r(ee,"CODE",{});var Ye=i(Q);Ce=s(Ye,"input_ids"),Ye.forEach(o),ge=s(ee," only and nothing else: "),K=r(ee,"CODE",{});var Tt=i(K);Ge=s(Tt,"model(input_ids)"),Tt.forEach(o),ee.forEach(o),Ae=p(W),A=r(W,"LI",{});var te=i(A);Be=s(te,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),Z=r(te,"CODE",{});var Ze=i(Z);G=s(Ze,"model([input_ids, attention_mask])"),Ze.forEach(o),$e=s(te," or "),D=r(te,"CODE",{});var kt=i(D);Ue=s(kt,"model([input_ids, attention_mask, token_type_ids])"),kt.forEach(o),te.forEach(o),xe=p(W),U=r(W,"LI",{});var Je=i(U);We=s(Je,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),V=r(Je,"CODE",{});var pt=i(V);Re=s(pt,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),pt.forEach(o),Je.forEach(o),W.forEach(o),Te=p(z),L=r(z,"P",{});var oe=i(L);ze=s(oe,`Note that when creating models and layers with
`),N=r(oe,"A",{href:!0,rel:!0});var bt=i(N);He=s(bt,"subclassing"),bt.forEach(o),Ke=s(oe,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),oe.forEach(o),this.h()},h(){l(N,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),l(N,"rel","nofollow")},m(z,j){u(z,m,j),e(m,k),e(m,g),e(g,_),e(m,T),u(z,d,j),u(z,f,j),e(f,F),e(F,Le),e(f,je),e(f,I),e(I,ue),u(z,J,j),u(z,E,j),e(E,Ne),e(E,B),e(B,me),e(E,Qe),e(E,Y),e(Y,X),e(E,ne),e(E,R),e(R,ie),e(E,Ie),e(E,H),e(H,De),e(E,Me),e(E,S),e(S,Se),e(E,de),u(z,fe,j),u(z,C,j),e(C,P),e(P,_e),e(P,Q),e(Q,Ce),e(P,ge),e(P,K),e(K,Ge),e(C,Ae),e(C,A),e(A,Be),e(A,Z),e(Z,G),e(A,$e),e(A,D),e(D,Ue),e(C,xe),e(C,U),e(U,We),e(U,V),e(V,Re),u(z,Te,j),u(z,L,j),e(L,ze),e(L,N),e(N,He),e(L,Ke)},d(z){z&&o(m),z&&o(d),z&&o(f),z&&o(J),z&&o(E),z&&o(fe),z&&o(C),z&&o(Te),z&&o(L)}}}function b$(q){let m,k,g,_,T;return{c(){m=a("p"),k=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),_=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(f,"CODE",{});var F=i(g);_=s(F,"Module"),F.forEach(o),T=s(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(o)},m(d,f){u(d,m,f),e(m,k),e(m,g),e(g,_),e(m,T)},d(d){d&&o(m)}}}function v$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, TFT5ForConditionalGeneration

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = TFT5ForConditionalGeneration.from_pretrained("t5-small")

# training
inputs = tokenizer("The <extra_id_0> walks in <extra_id_1> park", return_tensors="tf").input_ids
labels = tokenizer("<extra_id_0> cute dog <extra_id_1> the <extra_id_2>", return_tensors="tf").input_ids
outputs = model(inputs, labels=labels)
loss = outputs.loss
logits = outputs.logits

# inference
inputs = tokenizer(
    "summarize: studies have shown that owning a dog is good for you", return_tensors="tf"
).input_ids  # Batch size 1
outputs = model.generate(inputs)
print(tokenizer.decode(outputs[0], skip_special_tokens=True))
# studies have shown that owning a dog is good for you`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFT5ForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFT5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># training</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;The &lt;extra_id_0&gt; walks in &lt;extra_id_1&gt; park&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>).input_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>labels = tokenizer(<span class="hljs-string">&quot;&lt;extra_id_0&gt; cute dog &lt;extra_id_1&gt; the &lt;extra_id_2&gt;&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>).input_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs, labels=labels)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># inference</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;summarize: studies have shown that owning a dog is good for you&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>
<span class="hljs-meta">... </span>).input_ids  <span class="hljs-comment"># Batch size 1</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.generate(inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(tokenizer.decode(outputs[<span class="hljs-number">0</span>], skip_special_tokens=<span class="hljs-literal">True</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># studies have shown that owning a dog is good for you</span>`}}),{c(){m=a("p"),k=n("Examples:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Examples:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function y$(q){let m,k,g,_,T,d,f,F,Le,je,I,ue,J,E,Ne,B,me,Qe,Y,X,ne,R,ie,Ie,H,De,Me,S,Se,de,fe,C,P,_e,Q,Ce,ge,K,Ge,Ae,A,Be,Z,G,$e,D,Ue,xe,U,We,V,Re,Te,L,ze,N,He,Ke;return{c(){m=a("p"),k=n("TensorFlow models and layers in "),g=a("code"),_=n("transformers"),T=n(" accept two formats as input:"),d=c(),f=a("ul"),F=a("li"),Le=n("having all inputs as keyword arguments (like PyTorch models), or"),je=c(),I=a("li"),ue=n("having all inputs as a list, tuple or dict in the first positional argument."),J=c(),E=a("p"),Ne=n(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),B=a("code"),me=n("model.fit()"),Qe=n(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),Y=a("code"),X=n("model.fit()"),ne=n(` supports! If, however, you want to use the second
format outside of Keras methods like `),R=a("code"),ie=n("fit()"),Ie=n(" and "),H=a("code"),De=n("predict()"),Me=n(`, such as when creating your own layers or models with
the Keras `),S=a("code"),Se=n("Functional"),de=n(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),fe=c(),C=a("ul"),P=a("li"),_e=n("a single Tensor with "),Q=a("code"),Ce=n("input_ids"),ge=n(" only and nothing else: "),K=a("code"),Ge=n("model(input_ids)"),Ae=c(),A=a("li"),Be=n(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),Z=a("code"),G=n("model([input_ids, attention_mask])"),$e=n(" or "),D=a("code"),Ue=n("model([input_ids, attention_mask, token_type_ids])"),xe=c(),U=a("li"),We=n(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),V=a("code"),Re=n('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),Te=c(),L=a("p"),ze=n(`Note that when creating models and layers with
`),N=a("a"),He=n("subclassing"),Ke=n(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(z){m=r(z,"P",{});var j=i(m);k=s(j,"TensorFlow models and layers in "),g=r(j,"CODE",{});var ft=i(g);_=s(ft,"transformers"),ft.forEach(o),T=s(j," accept two formats as input:"),j.forEach(o),d=p(z),f=r(z,"UL",{});var ke=i(f);F=r(ke,"LI",{});var et=i(F);Le=s(et,"having all inputs as keyword arguments (like PyTorch models), or"),et.forEach(o),je=p(ke),I=r(ke,"LI",{});var tt=i(I);ue=s(tt,"having all inputs as a list, tuple or dict in the first positional argument."),tt.forEach(o),ke.forEach(o),J=p(z),E=r(z,"P",{});var M=i(E);Ne=s(M,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),B=r(M,"CODE",{});var _t=i(B);me=s(_t,"model.fit()"),_t.forEach(o),Qe=s(M,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),Y=r(M,"CODE",{});var ot=i(Y);X=s(ot,"model.fit()"),ot.forEach(o),ne=s(M,` supports! If, however, you want to use the second
format outside of Keras methods like `),R=r(M,"CODE",{});var se=i(R);ie=s(se,"fit()"),se.forEach(o),Ie=s(M," and "),H=r(M,"CODE",{});var gt=i(H);De=s(gt,"predict()"),gt.forEach(o),Me=s(M,`, such as when creating your own layers or models with
the Keras `),S=r(M,"CODE",{});var Ve=i(S);Se=s(Ve,"Functional"),Ve.forEach(o),de=s(M,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),M.forEach(o),fe=p(z),C=r(z,"UL",{});var W=i(C);P=r(W,"LI",{});var ee=i(P);_e=s(ee,"a single Tensor with "),Q=r(ee,"CODE",{});var Ye=i(Q);Ce=s(Ye,"input_ids"),Ye.forEach(o),ge=s(ee," only and nothing else: "),K=r(ee,"CODE",{});var Tt=i(K);Ge=s(Tt,"model(input_ids)"),Tt.forEach(o),ee.forEach(o),Ae=p(W),A=r(W,"LI",{});var te=i(A);Be=s(te,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),Z=r(te,"CODE",{});var Ze=i(Z);G=s(Ze,"model([input_ids, attention_mask])"),Ze.forEach(o),$e=s(te," or "),D=r(te,"CODE",{});var kt=i(D);Ue=s(kt,"model([input_ids, attention_mask, token_type_ids])"),kt.forEach(o),te.forEach(o),xe=p(W),U=r(W,"LI",{});var Je=i(U);We=s(Je,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),V=r(Je,"CODE",{});var pt=i(V);Re=s(pt,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),pt.forEach(o),Je.forEach(o),W.forEach(o),Te=p(z),L=r(z,"P",{});var oe=i(L);ze=s(oe,`Note that when creating models and layers with
`),N=r(oe,"A",{href:!0,rel:!0});var bt=i(N);He=s(bt,"subclassing"),bt.forEach(o),Ke=s(oe,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),oe.forEach(o),this.h()},h(){l(N,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),l(N,"rel","nofollow")},m(z,j){u(z,m,j),e(m,k),e(m,g),e(g,_),e(m,T),u(z,d,j),u(z,f,j),e(f,F),e(F,Le),e(f,je),e(f,I),e(I,ue),u(z,J,j),u(z,E,j),e(E,Ne),e(E,B),e(B,me),e(E,Qe),e(E,Y),e(Y,X),e(E,ne),e(E,R),e(R,ie),e(E,Ie),e(E,H),e(H,De),e(E,Me),e(E,S),e(S,Se),e(E,de),u(z,fe,j),u(z,C,j),e(C,P),e(P,_e),e(P,Q),e(Q,Ce),e(P,ge),e(P,K),e(K,Ge),e(C,Ae),e(C,A),e(A,Be),e(A,Z),e(Z,G),e(A,$e),e(A,D),e(D,Ue),e(C,xe),e(C,U),e(U,We),e(U,V),e(V,Re),u(z,Te,j),u(z,L,j),e(L,ze),e(L,N),e(N,He),e(L,Ke)},d(z){z&&o(m),z&&o(d),z&&o(f),z&&o(J),z&&o(E),z&&o(fe),z&&o(C),z&&o(Te),z&&o(L)}}}function w$(q){let m,k,g,_,T;return{c(){m=a("p"),k=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),_=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(f,"CODE",{});var F=i(g);_=s(F,"Module"),F.forEach(o),T=s(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(o)},m(d,f){u(d,m,f),e(m,k),e(m,g),e(g,_),e(m,T)},d(d){d&&o(m)}}}function $$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, TFT5EncoderModel

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = TFT5EncoderModel.from_pretrained("t5-small")

input_ids = tokenizer(
    "Studies have been shown that owning a dog is good for you", return_tensors="tf"
).input_ids  # Batch size 1
outputs = model(input_ids)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFT5EncoderModel

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFT5EncoderModel.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;Studies have been shown that owning a dog is good for you&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>
<span class="hljs-meta">... </span>).input_ids  <span class="hljs-comment"># Batch size 1</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_ids)`}}),{c(){m=a("p"),k=n("Examples:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Examples:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function x$(q){let m,k,g,_,T;return{c(){m=a("p"),k=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),_=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(f,"CODE",{});var F=i(g);_=s(F,"Module"),F.forEach(o),T=s(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(o)},m(d,f){u(d,m,f),e(m,k),e(m,g),e(g,_),e(m,T)},d(d){d&&o(m)}}}function z$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, FlaxT5Model

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = FlaxT5Model.from_pretrained("t5-small")

input_ids = tokenizer(
    "Studies have been shown that owning a dog is good for you", return_tensors="np"
).input_ids
decoder_input_ids = tokenizer("Studies show that", return_tensors="np").input_ids

# preprocess: Prepend decoder_input_ids with start token which is pad token for T5Model.
# This is not needed for torch's T5ForConditionalGeneration as it does this internally using labels arg.
decoder_input_ids = model._shift_right(decoder_input_ids)

# forward pass
outputs = model(input_ids=input_ids, decoder_input_ids=decoder_input_ids)
last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxT5Model

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxT5Model.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;Studies have been shown that owning a dog is good for you&quot;</span>, return_tensors=<span class="hljs-string">&quot;np&quot;</span>
<span class="hljs-meta">... </span>).input_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_input_ids = tokenizer(<span class="hljs-string">&quot;Studies show that&quot;</span>, return_tensors=<span class="hljs-string">&quot;np&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># preprocess: Prepend decoder_input_ids with start token which is pad token for T5Model.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># This is not needed for torch&#x27;s T5ForConditionalGeneration as it does this internally using labels arg.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_input_ids = model._shift_right(decoder_input_ids)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_ids=input_ids, decoder_input_ids=decoder_input_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){m=a("p"),k=n("Example:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Example:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function E$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, FlaxT5ForConditionalGeneration

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = FlaxT5ForConditionalGeneration.from_pretrained("t5-small")

text = "My friends are cool but they eat too many carbs."
inputs = tokenizer(text, return_tensors="np")
encoder_outputs = model.encode(**inputs)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxT5ForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxT5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>text = <span class="hljs-string">&quot;My friends are cool but they eat too many carbs.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(text, return_tensors=<span class="hljs-string">&quot;np&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>encoder_outputs = model.encode(**inputs)`}}),{c(){m=a("p"),k=n("Example:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Example:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function q$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, FlaxT5ForConditionalGeneration
import jax.numpy as jnp

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = FlaxT5ForConditionalGeneration.from_pretrained("t5-small")

text = "My friends are cool but they eat too many carbs."
inputs = tokenizer(text, return_tensors="np")
encoder_outputs = model.encode(**inputs)

decoder_start_token_id = model.config.decoder_start_token_id
decoder_input_ids = jnp.ones((inputs.input_ids.shape[0], 1), dtype="i4") * decoder_start_token_id

outputs = model.decode(decoder_input_ids, encoder_outputs)
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxT5ForConditionalGeneration
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax.numpy <span class="hljs-keyword">as</span> jnp

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxT5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>text = <span class="hljs-string">&quot;My friends are cool but they eat too many carbs.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(text, return_tensors=<span class="hljs-string">&quot;np&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>encoder_outputs = model.encode(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_start_token_id = model.config.decoder_start_token_id
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_input_ids = jnp.ones((inputs.input_ids.shape[<span class="hljs-number">0</span>], <span class="hljs-number">1</span>), dtype=<span class="hljs-string">&quot;i4&quot;</span>) * decoder_start_token_id

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.decode(decoder_input_ids, encoder_outputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){m=a("p"),k=n("Example:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Example:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function F$(q){let m,k,g,_,T;return{c(){m=a("p"),k=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),_=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(f,"CODE",{});var F=i(g);_=s(F,"Module"),F.forEach(o),T=s(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(o)},m(d,f){u(d,m,f),e(m,k),e(m,g),e(g,_),e(m,T)},d(d){d&&o(m)}}}function j$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, FlaxT5ForConditionalGeneration

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = FlaxT5ForConditionalGeneration.from_pretrained("t5-small")

ARTICLE_TO_SUMMARIZE = "summarize: My friends are cool but they eat too many carbs."
inputs = tokenizer([ARTICLE_TO_SUMMARIZE], return_tensors="np")

# Generate Summary
summary_ids = model.generate(inputs["input_ids"]).sequences
print(tokenizer.decode(summary_ids[0], skip_special_tokens=True, clean_up_tokenization_spaces=False))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxT5ForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxT5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>ARTICLE_TO_SUMMARIZE = <span class="hljs-string">&quot;summarize: My friends are cool but they eat too many carbs.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer([ARTICLE_TO_SUMMARIZE], return_tensors=<span class="hljs-string">&quot;np&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Generate Summary</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>summary_ids = model.generate(inputs[<span class="hljs-string">&quot;input_ids&quot;</span>]).sequences
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(tokenizer.decode(summary_ids[<span class="hljs-number">0</span>], skip_special_tokens=<span class="hljs-literal">True</span>, clean_up_tokenization_spaces=<span class="hljs-literal">False</span>))`}}),{c(){m=a("p"),k=n("Example:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Example:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function M$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, FlaxT5ForConditionalGeneration

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = FlaxT5ForConditionalGeneration.from_pretrained("t5-small")

text = "My friends are cool but they eat too many carbs."
inputs = tokenizer(text, return_tensors="np")
encoder_outputs = model.encode(**inputs)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxT5ForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxT5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>text = <span class="hljs-string">&quot;My friends are cool but they eat too many carbs.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(text, return_tensors=<span class="hljs-string">&quot;np&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>encoder_outputs = model.encode(**inputs)`}}),{c(){m=a("p"),k=n("Example:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Example:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function C$(q){let m,k,g,_,T;return _=new we({props:{code:`from transformers import AutoTokenizer, FlaxT5ForConditionalGeneration
import jax.numpy as jnp

tokenizer = AutoTokenizer.from_pretrained("t5-small")
model = FlaxT5ForConditionalGeneration.from_pretrained("t5-small")

text = "summarize: My friends are cool but they eat too many carbs."
inputs = tokenizer(text, return_tensors="np")
encoder_outputs = model.encode(**inputs)

decoder_start_token_id = model.config.decoder_start_token_id
decoder_input_ids = jnp.ones((inputs.input_ids.shape[0], 1), dtype="i4") * decoder_start_token_id

outputs = model.decode(decoder_input_ids, encoder_outputs)
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxT5ForConditionalGeneration
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax.numpy <span class="hljs-keyword">as</span> jnp

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxT5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>text = <span class="hljs-string">&quot;summarize: My friends are cool but they eat too many carbs.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(text, return_tensors=<span class="hljs-string">&quot;np&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>encoder_outputs = model.encode(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_start_token_id = model.config.decoder_start_token_id
<span class="hljs-meta">&gt;&gt;&gt; </span>decoder_input_ids = jnp.ones((inputs.input_ids.shape[<span class="hljs-number">0</span>], <span class="hljs-number">1</span>), dtype=<span class="hljs-string">&quot;i4&quot;</span>) * decoder_start_token_id

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.decode(decoder_input_ids, encoder_outputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){m=a("p"),k=n("Example:"),g=c(),b(_.$$.fragment)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Example:"),f.forEach(o),g=p(d),v(_.$$.fragment,d)},m(d,f){u(d,m,f),e(m,k),u(d,g,f),y(_,d,f),T=!0},p:It,i(d){T||(w(_.$$.fragment,d),T=!0)},o(d){$(_.$$.fragment,d),T=!1},d(d){d&&o(m),d&&o(g),x(_,d)}}}function A$(q){let m,k,g,_,T;return{c(){m=a("p"),k=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),_=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){m=r(d,"P",{});var f=i(m);k=s(f,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(f,"CODE",{});var F=i(g);_=s(F,"Module"),F.forEach(o),T=s(f,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),f.forEach(o)},m(d,f){u(d,m,f),e(m,k),e(m,g),e(g,_),e(m,T)},d(d){d&&o(m)}}}function P$(q){let m,k,g,_,T,d,f,F,Le,je,I,ue,J,E,Ne,B,me,Qe,Y,X,ne,R,ie,Ie,H,De,Me,S,Se,de,fe,C,P,_e,Q,Ce,ge,K,Ge,Ae,A,Be,Z,G,$e,D,Ue,xe,U,We,V,Re,Te,L,ze,N,He,Ke,z,j,ft,ke,et,tt,M,_t,ot,se,gt,Ve,W,ee,Ye,Tt,te,Ze,kt,Je,pt,oe,bt,Bc,nt,bd,vd,Xn,Eu,qu,yd,wd,Qn,Fu,ju,$d,xd,es,Mu,Cu,zd,Ed,ts,Au,Pu,qd,Yr,os,Ou,Lu,Uc,Zr,Nu,Wc,Gt,Fd,Ao,jd,Iu,Du,Jr,Su,Gu,Bu,Md,Po,Cd,Uu,Wu,Xr,Ru,Hu,Ku,Ad,Oo,Pd,Vu,Yu,Qr,Zu,Ju,Rc,Lo,Xu,ns,Qu,em,Hc,Bt,tm,ss,om,nm,as,sm,am,Kc,ei,Vc,oo,No,Od,rs,rm,Ld,im,Yc,vt,dm,Nd,lm,cm,Id,pm,hm,Dd,um,mm,Zc,Io,fm,ti,_m,gm,Jc,oi,Sd,Tm,Xc,be,km,Gd,bm,vm,Bd,ym,wm,Ud,$m,xm,Wd,zm,Em,Rd,qm,Fm,ni,jm,Mm,Qc,si,Cm,ep,is,tp,Do,Am,ds,Pm,Om,op,ai,Hd,Lm,np,ri,Nm,sp,ls,ap,ae,Im,Kd,Dm,Sm,Vd,Gm,Bm,Yd,Um,Wm,Zd,Rm,Hm,Jd,Km,Vm,Xd,Ym,Zm,Qd,Jm,Xm,rp,Ut,Qm,el,ef,tf,tl,of,nf,ip,ve,sf,ol,af,rf,nl,df,lf,sl,cf,pf,al,hf,uf,cs,mf,ff,rl,_f,gf,dp,ps,lp,ii,Tf,cp,di,hs,kf,il,bf,vf,pp,Wt,yf,us,wf,$f,ms,xf,zf,hp,So,Ef,dl,qf,Ff,up,li,mp,no,Go,ll,fs,jf,cl,Mf,fp,yt,Cf,ci,Af,Pf,_s,Of,Lf,gs,Nf,If,_p,Ts,gp,st,Df,pl,Sf,Gf,hl,Bf,Uf,pi,Wf,Rf,ul,Hf,Kf,Tp,hi,Vf,kp,ks,bp,ui,Yf,vp,bs,yp,mi,wp,so,Bo,ml,vs,Zf,fl,Jf,$p,wt,Xf,ys,Qf,e_,_l,t_,o_,gl,n_,s_,xp,ao,Uo,Tl,ws,a_,kl,r_,zp,fi,i_,Ep,$s,qp,Wo,xs,d_,zs,l_,c_,p_,Es,h_,qs,u_,m_,Fp,Fs,jp,_i,js,f_,Ms,__,g_,Mp,Cs,Cp,gi,As,T_,Ps,k_,b_,Ap,Os,Pp,re,Ls,v_,Ns,y_,w_,$_,Is,x_,Ds,z_,E_,q_,Ss,F_,Gs,j_,M_,C_,Rt,Ti,A_,P_,Bs,O_,L_,Us,N_,I_,D_,Ht,ki,S_,G_,Ws,B_,U_,Rs,W_,R_,H_,Ro,bi,K_,V_,Hs,Y_,Z_,J_,vi,Ks,X_,Q_,eg,bl,yi,tg,Op,Vs,Lp,wi,$t,$i,og,ng,Ys,sg,ag,xi,rg,ig,Zs,dg,lg,Np,Js,Ip,Kt,Vt,zi,cg,pg,Xs,hg,ug,Qs,mg,fg,_g,Yt,Ei,gg,Tg,ea,kg,bg,ta,vg,yg,wg,vl,qi,$g,Dp,oa,Sp,Ho,na,xg,sa,zg,Eg,qg,aa,Fg,ra,jg,Mg,Gp,ia,Cg,yl,Ag,Bp,Fi,da,Pg,la,Og,Lg,Up,ro,Ko,wl,ca,Ng,$l,Ig,Wp,Dt,pa,Dg,St,Sg,ji,Gg,Bg,Mi,Ug,Wg,ha,Rg,Hg,Kg,io,Vg,Ci,Yg,Zg,Ai,Jg,Xg,Rp,lo,Vo,xl,ua,Qg,zl,eT,Hp,le,ma,tT,fa,oT,_a,nT,sT,aT,ga,rT,Pi,iT,dT,lT,Zt,Ta,cT,El,pT,hT,ka,Oi,uT,ql,mT,fT,Li,_T,Fl,gT,TT,Yo,ba,kT,va,bT,jl,vT,yT,wT,Zo,ya,$T,Ml,xT,zT,Ni,wa,Kp,co,Jo,Cl,$a,ET,Al,qT,Vp,Xe,xa,FT,po,jT,Pl,MT,CT,za,AT,PT,OT,Ea,LT,Ii,NT,IT,DT,Jt,qa,ST,Ol,GT,BT,Fa,Di,UT,Ll,WT,RT,Si,HT,Nl,KT,VT,Xo,ja,YT,Il,ZT,Yp,ho,Qo,Dl,Ma,JT,Sl,XT,Zp,Ee,Ca,QT,Gl,ek,tk,Aa,ok,Pa,nk,sk,ak,Oa,rk,Gi,ik,dk,lk,La,ck,Na,pk,hk,uk,xt,Ia,mk,uo,fk,Bi,_k,gk,Bl,Tk,kk,bk,en,vk,tn,Jp,mo,on,Ul,Da,yk,Wl,wk,Xp,qe,Sa,$k,Ga,xk,Rl,zk,Ek,qk,Ba,Fk,Ua,jk,Mk,Ck,Wa,Ak,Ui,Pk,Ok,Lk,Ra,Nk,Ha,Ik,Dk,Sk,zt,Ka,Gk,fo,Bk,Wi,Uk,Wk,Hl,Rk,Hk,Kk,nn,Vk,sn,Qp,_o,an,Kl,Va,Yk,Vl,Zk,eh,Fe,Ya,Jk,Yl,Xk,Qk,Za,eb,Ja,tb,ob,nb,Xa,sb,Ri,ab,rb,ib,Qa,db,er,lb,cb,pb,Et,tr,hb,go,ub,Hi,mb,fb,Zl,_b,gb,Tb,rn,kb,dn,th,To,ln,Jl,or,bb,Xl,vb,oh,ce,nr,yb,Ql,wb,$b,sr,xb,ar,zb,Eb,qb,rr,Fb,Ki,jb,Mb,Cb,ir,Ab,dr,Pb,Ob,Lb,cn,Nb,qt,lr,Ib,ko,Db,Vi,Sb,Gb,ec,Bb,Ub,Wb,pn,Rb,hn,nh,bo,un,tc,cr,Hb,oc,Kb,sh,pe,pr,Vb,hr,Yb,nc,Zb,Jb,Xb,ur,Qb,mr,ev,tv,ov,fr,nv,Yi,sv,av,rv,_r,iv,gr,dv,lv,cv,mn,pv,Ft,Tr,hv,vo,uv,Zi,mv,fv,sc,_v,gv,Tv,fn,kv,_n,ah,yo,gn,ac,kr,bv,rc,vv,rh,he,br,yv,ic,wv,$v,vr,xv,yr,zv,Ev,qv,wr,Fv,Ji,jv,Mv,Cv,$r,Av,xr,Pv,Ov,Lv,Tn,Nv,jt,zr,Iv,wo,Dv,Xi,Sv,Gv,dc,Bv,Uv,Wv,kn,Rv,bn,ih,$o,vn,lc,Er,Hv,cc,Kv,dh,ht,qr,Vv,Mt,Fr,Yv,xo,Zv,pc,Jv,Xv,hc,Qv,ey,ty,yn,oy,wn,ny,$n,jr,sy,xn,ay,zn,Mr,ry,En,lh,zo,qn,uc,Cr,iy,mc,dy,ch,ut,Ar,ly,Ct,Pr,cy,Eo,py,fc,hy,uy,_c,my,fy,_y,Fn,gy,jn,Ty,Mn,Or,ky,Cn,by,An,Lr,vy,Pn,ph,qo,On,gc,Nr,yy,Tc,wy,hh,Fo,Ir,$y,Xt,Dr,xy,jo,zy,Qi,Ey,qy,kc,Fy,jy,My,Ln,uh;return d=new ye({}),ie=new ye({}),rs=new ye({}),is=new we({props:{code:`from transformers import T5Tokenizer, T5ForConditionalGeneration

tokenizer = T5Tokenizer.from_pretrained("t5-small")
model = T5ForConditionalGeneration.from_pretrained("t5-small")

input_ids = tokenizer("The <extra_id_0> walks in <extra_id_1> park", return_tensors="pt").input_ids
labels = tokenizer("<extra_id_0> cute dog <extra_id_1> the <extra_id_2>", return_tensors="pt").input_ids

# the forward function automatically creates the correct decoder_input_ids
loss = model(input_ids=input_ids, labels=labels).loss
loss.item()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> T5Tokenizer, T5ForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = T5Tokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = T5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(<span class="hljs-string">&quot;The &lt;extra_id_0&gt; walks in &lt;extra_id_1&gt; park&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>labels = tokenizer(<span class="hljs-string">&quot;&lt;extra_id_0&gt; cute dog &lt;extra_id_1&gt; the &lt;extra_id_2&gt;&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># the forward function automatically creates the correct decoder_input_ids</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(input_ids=input_ids, labels=labels).loss
<span class="hljs-meta">&gt;&gt;&gt; </span>loss.item()
<span class="hljs-number">3.7837</span>`}}),ls=new we({props:{code:`from transformers import T5Tokenizer, T5ForConditionalGeneration

tokenizer = T5Tokenizer.from_pretrained("t5-small")
model = T5ForConditionalGeneration.from_pretrained("t5-small")

input_ids = tokenizer("translate English to German: The house is wonderful.", return_tensors="pt").input_ids
labels = tokenizer("Das Haus ist wunderbar.", return_tensors="pt").input_ids

# the forward function automatically creates the correct decoder_input_ids
loss = model(input_ids=input_ids, labels=labels).loss
loss.item()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> T5Tokenizer, T5ForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = T5Tokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = T5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(<span class="hljs-string">&quot;translate English to German: The house is wonderful.&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>labels = tokenizer(<span class="hljs-string">&quot;Das Haus ist wunderbar.&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># the forward function automatically creates the correct decoder_input_ids</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(input_ids=input_ids, labels=labels).loss
<span class="hljs-meta">&gt;&gt;&gt; </span>loss.item()
<span class="hljs-number">0.2542</span>`}}),ps=new we({props:{code:`from transformers import T5Tokenizer, T5ForConditionalGeneration
import torch

tokenizer = T5Tokenizer.from_pretrained("t5-small")
model = T5ForConditionalGeneration.from_pretrained("t5-small")

# the following 2 hyperparameters are task-specific
max_source_length = 512
max_target_length = 128

# Suppose we have the following 2 training examples:
input_sequence_1 = "Welcome to NYC"
output_sequence_1 = "Bienvenue \xE0 NYC"

input_sequence_2 = "HuggingFace is a company"
output_sequence_2 = "HuggingFace est une entreprise"

# encode the inputs
task_prefix = "translate English to French: "
input_sequences = [input_sequence_1, input_sequence_2]

encoding = tokenizer(
    [task_prefix + sequence for sequence in input_sequences],
    padding="longest",
    max_length=max_source_length,
    truncation=True,
    return_tensors="pt",
)

input_ids, attention_mask = encoding.input_ids, encoding.attention_mask

# encode the targets
target_encoding = tokenizer(
    [output_sequence_1, output_sequence_2],
    padding="longest",
    max_length=max_target_length,
    truncation=True,
    return_tensors="pt",
)
labels = target_encoding.input_ids

# replace padding token id's of the labels by -100 so it's ignored by the loss
labels[labels == tokenizer.pad_token_id] = -100

# forward pass
loss = model(input_ids=input_ids, attention_mask=attention_mask, labels=labels).loss
loss.item()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> T5Tokenizer, T5ForConditionalGeneration
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = T5Tokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = T5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># the following 2 hyperparameters are task-specific</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>max_source_length = <span class="hljs-number">512</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>max_target_length = <span class="hljs-number">128</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Suppose we have the following 2 training examples:</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>input_sequence_1 = <span class="hljs-string">&quot;Welcome to NYC&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>output_sequence_1 = <span class="hljs-string">&quot;Bienvenue \xE0 NYC&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>input_sequence_2 = <span class="hljs-string">&quot;HuggingFace is a company&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>output_sequence_2 = <span class="hljs-string">&quot;HuggingFace est une entreprise&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># encode the inputs</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>task_prefix = <span class="hljs-string">&quot;translate English to French: &quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>input_sequences = [input_sequence_1, input_sequence_2]

<span class="hljs-meta">&gt;&gt;&gt; </span>encoding = tokenizer(
<span class="hljs-meta">... </span>    [task_prefix + sequence <span class="hljs-keyword">for</span> sequence <span class="hljs-keyword">in</span> input_sequences],
<span class="hljs-meta">... </span>    padding=<span class="hljs-string">&quot;longest&quot;</span>,
<span class="hljs-meta">... </span>    max_length=max_source_length,
<span class="hljs-meta">... </span>    truncation=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    return_tensors=<span class="hljs-string">&quot;pt&quot;</span>,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids, attention_mask = encoding.input_ids, encoding.attention_mask

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># encode the targets</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_encoding = tokenizer(
<span class="hljs-meta">... </span>    [output_sequence_1, output_sequence_2],
<span class="hljs-meta">... </span>    padding=<span class="hljs-string">&quot;longest&quot;</span>,
<span class="hljs-meta">... </span>    max_length=max_target_length,
<span class="hljs-meta">... </span>    truncation=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    return_tensors=<span class="hljs-string">&quot;pt&quot;</span>,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>labels = target_encoding.input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># replace padding token id&#x27;s of the labels by -100 so it&#x27;s ignored by the loss</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>labels[labels == tokenizer.pad_token_id] = -<span class="hljs-number">100</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(input_ids=input_ids, attention_mask=attention_mask, labels=labels).loss
<span class="hljs-meta">&gt;&gt;&gt; </span>loss.item()
<span class="hljs-number">0.188</span>`}}),fs=new ye({}),Ts=new we({props:{code:`from transformers import T5Tokenizer, T5ForConditionalGeneration

tokenizer = T5Tokenizer.from_pretrained("t5-small")
model = T5ForConditionalGeneration.from_pretrained("t5-small")

input_ids = tokenizer("translate English to German: The house is wonderful.", return_tensors="pt").input_ids
outputs = model.generate(input_ids)
print(tokenizer.decode(outputs[0], skip_special_tokens=True))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> T5Tokenizer, T5ForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = T5Tokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = T5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(<span class="hljs-string">&quot;translate English to German: The house is wonderful.&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model.generate(input_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(tokenizer.decode(outputs[<span class="hljs-number">0</span>], skip_special_tokens=<span class="hljs-literal">True</span>))
Das Haus ist wunderbar.`}}),ks=new we({props:{code:`from transformers import T5Tokenizer, T5ForConditionalGeneration

tokenizer = T5Tokenizer.from_pretrained("t5-small")
model = T5ForConditionalGeneration.from_pretrained("t5-small")

task_prefix = "translate English to German: "
# use different length sentences to test batching
sentences = ["The house is wonderful.", "I like to work in NYC."]

inputs = tokenizer([task_prefix + sentence for sentence in sentences], return_tensors="pt", padding=True)

output_sequences = model.generate(
    input_ids=inputs["input_ids"],
    attention_mask=inputs["attention_mask"],
    do_sample=False,  # disable sampling to test if batching affects output
)

print(tokenizer.batch_decode(output_sequences, skip_special_tokens=True))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> T5Tokenizer, T5ForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = T5Tokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = T5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>task_prefix = <span class="hljs-string">&quot;translate English to German: &quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># use different length sentences to test batching</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>sentences = [<span class="hljs-string">&quot;The house is wonderful.&quot;</span>, <span class="hljs-string">&quot;I like to work in NYC.&quot;</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer([task_prefix + sentence <span class="hljs-keyword">for</span> sentence <span class="hljs-keyword">in</span> sentences], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>, padding=<span class="hljs-literal">True</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>output_sequences = model.generate(
<span class="hljs-meta">... </span>    input_ids=inputs[<span class="hljs-string">&quot;input_ids&quot;</span>],
<span class="hljs-meta">... </span>    attention_mask=inputs[<span class="hljs-string">&quot;attention_mask&quot;</span>],
<span class="hljs-meta">... </span>    do_sample=<span class="hljs-literal">False</span>,  <span class="hljs-comment"># disable sampling to test if batching affects output</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(tokenizer.batch_decode(output_sequences, skip_special_tokens=<span class="hljs-literal">True</span>))
[<span class="hljs-string">&#x27;Das Haus ist wunderbar.&#x27;</span>, <span class="hljs-string">&#x27;Ich arbeite gerne in NYC.&#x27;</span>]`}}),bs=new we({props:{code:`from transformers import T5Tokenizer, T5ForConditionalGeneration

tokenizer = T5Tokenizer.from_pretrained("t5-small")
model = T5ForConditionalGeneration.from_pretrained("t5-small")

input_ids = tokenizer("The <extra_id_0> walks in <extra_id_1> park", return_tensors="pt").input_ids

sequence_ids = model.generate(input_ids)
sequences = tokenizer.batch_decode(sequence_ids)
sequences`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> T5Tokenizer, T5ForConditionalGeneration

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = T5Tokenizer.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = T5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;t5-small&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(<span class="hljs-string">&quot;The &lt;extra_id_0&gt; walks in &lt;extra_id_1&gt; park&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span>sequence_ids = model.generate(input_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>sequences = tokenizer.batch_decode(sequence_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>sequences
[<span class="hljs-string">&#x27;&lt;pad&gt;&lt;extra_id_0&gt; park offers&lt;extra_id_1&gt; the&lt;extra_id_2&gt; park.&lt;/s&gt;&#x27;</span>]`}}),vs=new ye({}),ws=new ye({}),$s=new Vr({props:{pipeline:"text-classification"}}),Fs=new Vr({props:{pipeline:"token-classification"}}),Cs=new Vr({props:{pipeline:"text-generation"}}),Os=new Vr({props:{pipeline:"summarization"}}),Vs=new Vr({props:{pipeline:"fill-mask"}}),Js=new Vr({props:{pipeline:"translation"}}),oa=new Vr({props:{pipeline:"question-answering"}}),ca=new ye({}),pa=new O({props:{name:"class transformers.T5Config",anchor:"transformers.T5Config",parameters:[{name:"vocab_size",val:" = 32128"},{name:"d_model",val:" = 512"},{name:"d_kv",val:" = 64"},{name:"d_ff",val:" = 2048"},{name:"num_layers",val:" = 6"},{name:"num_decoder_layers",val:" = None"},{name:"num_heads",val:" = 8"},{name:"relative_attention_num_buckets",val:" = 32"},{name:"relative_attention_max_distance",val:" = 128"},{name:"dropout_rate",val:" = 0.1"},{name:"layer_norm_epsilon",val:" = 1e-06"},{name:"initializer_factor",val:" = 1.0"},{name:"feed_forward_proj",val:" = 'relu'"},{name:"is_encoder_decoder",val:" = True"},{name:"use_cache",val:" = True"},{name:"pad_token_id",val:" = 0"},{name:"eos_token_id",val:" = 1"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.T5Config.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 32128) &#x2014;
Vocabulary size of the T5 model. Defines the number of different tokens that can be represented by the
<code>inputs_ids</code> passed when calling <a href="/docs/transformers/main/en/model_doc/t5#transformers.T5Model">T5Model</a> or <a href="/docs/transformers/main/en/model_doc/t5#transformers.TFT5Model">TFT5Model</a>.`,name:"vocab_size"},{anchor:"transformers.T5Config.d_model",description:`<strong>d_model</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
Size of the encoder layers and the pooler layer.`,name:"d_model"},{anchor:"transformers.T5Config.d_kv",description:`<strong>d_kv</strong> (<code>int</code>, <em>optional</em>, defaults to 64) &#x2014;
Size of the key, query, value projections per attention head. <code>d_kv</code> has to be equal to <code>d_model // num_heads</code>.`,name:"d_kv"},{anchor:"transformers.T5Config.d_ff",description:`<strong>d_ff</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Size of the intermediate feed forward layer in each <code>T5Block</code>.`,name:"d_ff"},{anchor:"transformers.T5Config.num_layers",description:`<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 6) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_layers"},{anchor:"transformers.T5Config.num_decoder_layers",description:`<strong>num_decoder_layers</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Number of hidden layers in the Transformer decoder. Will use the same value as <code>num_layers</code> if not set.`,name:"num_decoder_layers"},{anchor:"transformers.T5Config.num_heads",description:`<strong>num_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_heads"},{anchor:"transformers.T5Config.relative_attention_num_buckets",description:`<strong>relative_attention_num_buckets</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
The number of buckets to use for each attention layer.`,name:"relative_attention_num_buckets"},{anchor:"transformers.T5Config.relative_attention_max_distance",description:`<strong>relative_attention_max_distance</strong> (<code>int</code>, <em>optional</em>, defaults to 128) &#x2014;
The maximum distance of the longer sequences for the bucket separation.`,name:"relative_attention_max_distance"},{anchor:"transformers.T5Config.dropout_rate",description:`<strong>dropout_rate</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The ratio for all dropout layers.`,name:"dropout_rate"},{anchor:"transformers.T5Config.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-6) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.T5Config.initializer_factor",description:`<strong>initializer_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
A factor for initializing all weight matrices (should be kept to 1, used internally for initialization
testing).`,name:"initializer_factor"},{anchor:"transformers.T5Config.feed_forward_proj",description:`<strong>feed_forward_proj</strong> (<code>string</code>, <em>optional</em>, defaults to <code>&quot;relu&quot;</code>) &#x2014;
Type of feed forward layer to be used. Should be one of <code>&quot;relu&quot;</code> or <code>&quot;gated-gelu&quot;</code>. T5v1.1 uses the
<code>&quot;gated-gelu&quot;</code> feed forward projection. Original T5 uses <code>&quot;relu&quot;</code>.`,name:"feed_forward_proj"},{anchor:"transformers.T5Config.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the model should return the last key/values attentions (not used by all models).`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/configuration_t5.py#L34"}}),ua=new ye({}),ma=new O({props:{name:"class transformers.T5Tokenizer",anchor:"transformers.T5Tokenizer",parameters:[{name:"vocab_file",val:""},{name:"eos_token",val:" = '</s>'"},{name:"unk_token",val:" = '<unk>'"},{name:"pad_token",val:" = '<pad>'"},{name:"extra_ids",val:" = 100"},{name:"additional_special_tokens",val:" = None"},{name:"sp_model_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.T5Tokenizer.vocab_file",description:`<strong>vocab_file</strong> (<code>str</code>) &#x2014;
<a href="https://github.com/google/sentencepiece" rel="nofollow">SentencePiece</a> file (generally has a <em>.spm</em> extension) that
contains the vocabulary necessary to instantiate a tokenizer.`,name:"vocab_file"},{anchor:"transformers.T5Tokenizer.eos_token",description:`<strong>eos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;/s&gt;&quot;</code>) &#x2014;
The end of sequence token.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>When building a sequence using special tokens, this is not the token that is used for the end of sequence.
The token used is the <code>sep_token</code>.</p>

					</div>`,name:"eos_token"},{anchor:"transformers.T5Tokenizer.unk_token",description:`<strong>unk_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;unk&gt;&quot;</code>) &#x2014;
The unknown token. A token that is not in the vocabulary cannot be converted to an ID and is set to be this
token instead.`,name:"unk_token"},{anchor:"transformers.T5Tokenizer.pad_token",description:`<strong>pad_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;pad&gt;&quot;</code>) &#x2014;
The token used for padding, for example when batching sequences of different lengths.`,name:"pad_token"},{anchor:"transformers.T5Tokenizer.extra_ids",description:`<strong>extra_ids</strong> (<code>int</code>, <em>optional</em>, defaults to 100) &#x2014;
Add a number of extra ids added to the vocabulary for use as sentinels. These tokens are
accessible as &#x201C;<extra<em>id{%d}&gt;&#x201D; where &#x201D;{%d}&#x201D; is a number between 0 and extra_ids-1. These tokens can be
retrieved by calling get_sentinel_tokens method and token ids can be by calling get_sentinel_token_ids
method
additional_special_tokens (<code>List[str]</code>, <em>optional</em>):
Additional special tokens used by the tokenizer.</extra<em>`,name:"extra_ids"},{anchor:"transformers.T5Tokenizer.sp_model_kwargs",description:`<strong>sp_model_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Will be passed to the <code>SentencePieceProcessor.__init__()</code> method. The <a href="https://github.com/google/sentencepiece/tree/master/python" rel="nofollow">Python wrapper for
SentencePiece</a> can be used, among other things,
to set:</p>
<ul>
<li>
<p><code>enable_sampling</code>: Enable subword regularization.</p>
</li>
<li>
<p><code>nbest_size</code>: Sampling parameters for unigram. Invalid for BPE-Dropout.</p>
<ul>
<li><code>nbest_size = {0,1}</code>: No sampling is performed.</li>
<li><code>nbest_size &gt; 1</code>: samples from the nbest_size results.</li>
<li><code>nbest_size &lt; 0</code>: assuming that nbest_size is infinite and samples from the all hypothesis (lattice)
using forward-filtering-and-backward-sampling algorithm.</li>
</ul>
</li>
<li>
<p><code>alpha</code>: Smoothing parameter for unigram sampling, and dropout probability of merge operations for
BPE-dropout.</p>
</li>
</ul>`,name:"sp_model_kwargs"},{anchor:"transformers.T5Tokenizer.sp_model",description:`<strong>sp_model</strong> (<code>SentencePieceProcessor</code>) &#x2014;
The <em>SentencePiece</em> processor that is used for every conversion (string, tokens and IDs).`,name:"sp_model"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/tokenization_t5.py#L55"}}),Ta=new O({props:{name:"build_inputs_with_special_tokens",anchor:"transformers.T5Tokenizer.build_inputs_with_special_tokens",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.T5Tokenizer.build_inputs_with_special_tokens.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs to which the special tokens will be added.`,name:"token_ids_0"},{anchor:"transformers.T5Tokenizer.build_inputs_with_special_tokens.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/tokenization_t5.py#L256",returnDescription:`
<p>List of <a href="../glossary#input-ids">input IDs</a> with the appropriate special tokens.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),ba=new O({props:{name:"get_special_tokens_mask",anchor:"transformers.T5Tokenizer.get_special_tokens_mask",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"},{name:"already_has_special_tokens",val:": bool = False"}],parametersDescription:[{anchor:"transformers.T5Tokenizer.get_special_tokens_mask.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs.`,name:"token_ids_0"},{anchor:"transformers.T5Tokenizer.get_special_tokens_mask.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"},{anchor:"transformers.T5Tokenizer.get_special_tokens_mask.already_has_special_tokens",description:`<strong>already_has_special_tokens</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the token list is already formatted with special tokens for the model.`,name:"already_has_special_tokens"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/tokenization_t5.py#L187",returnDescription:`
<p>A list of integers in the range [0, 1]: 1 for a special token, 0 for a sequence token.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),ya=new O({props:{name:"create_token_type_ids_from_sequences",anchor:"transformers.T5Tokenizer.create_token_type_ids_from_sequences",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.T5Tokenizer.create_token_type_ids_from_sequences.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs.`,name:"token_ids_0"},{anchor:"transformers.T5Tokenizer.create_token_type_ids_from_sequences.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/tokenization_t5.py#L234",returnDescription:`
<p>List of zeros.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),wa=new O({props:{name:"save_vocabulary",anchor:"transformers.T5Tokenizer.save_vocabulary",parameters:[{name:"save_directory",val:": str"},{name:"filename_prefix",val:": typing.Optional[str] = None"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/tokenization_t5.py#L336"}}),$a=new ye({}),xa=new O({props:{name:"class transformers.T5TokenizerFast",anchor:"transformers.T5TokenizerFast",parameters:[{name:"vocab_file",val:" = None"},{name:"tokenizer_file",val:" = None"},{name:"eos_token",val:" = '</s>'"},{name:"unk_token",val:" = '<unk>'"},{name:"pad_token",val:" = '<pad>'"},{name:"extra_ids",val:" = 100"},{name:"additional_special_tokens",val:" = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.T5TokenizerFast.vocab_file",description:`<strong>vocab_file</strong> (<code>str</code>) &#x2014;
<a href="https://github.com/google/sentencepiece" rel="nofollow">SentencePiece</a> file (generally has a <em>.spm</em> extension) that
contains the vocabulary necessary to instantiate a tokenizer.`,name:"vocab_file"},{anchor:"transformers.T5TokenizerFast.eos_token",description:`<strong>eos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;/s&gt;&quot;</code>) &#x2014;
The end of sequence token.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>When building a sequence using special tokens, this is not the token that is used for the end of sequence.
The token used is the <code>sep_token</code>.</p>

					</div>`,name:"eos_token"},{anchor:"transformers.T5TokenizerFast.unk_token",description:`<strong>unk_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;unk&gt;&quot;</code>) &#x2014;
The unknown token. A token that is not in the vocabulary cannot be converted to an ID and is set to be this
token instead.`,name:"unk_token"},{anchor:"transformers.T5TokenizerFast.pad_token",description:`<strong>pad_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;pad&gt;&quot;</code>) &#x2014;
The token used for padding, for example when batching sequences of different lengths.`,name:"pad_token"},{anchor:"transformers.T5TokenizerFast.extra_ids",description:`<strong>extra_ids</strong> (<code>int</code>, <em>optional</em>, defaults to 100) &#x2014;
Add a number of extra ids added to the vocabulary for use as sentinels. These tokens are accessible as
&#x201C;<extra<em>id{%d}&gt;&#x201D; where &#x201D;{%d}&#x201D; is a number between 0 and extra_ids-1. These tokens can be retrieved by
calling get_sentinel_tokens method and token ids can be by calling get_sentinel_token_ids method</extra<em>`,name:"extra_ids"},{anchor:"transformers.T5TokenizerFast.additional_special_tokens",description:`<strong>additional_special_tokens</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
Additional special tokens used by the tokenizer.`,name:"additional_special_tokens"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/tokenization_t5_fast.py#L66"}}),qa=new O({props:{name:"build_inputs_with_special_tokens",anchor:"transformers.T5TokenizerFast.build_inputs_with_special_tokens",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.T5TokenizerFast.build_inputs_with_special_tokens.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs to which the special tokens will be added.`,name:"token_ids_0"},{anchor:"transformers.T5TokenizerFast.build_inputs_with_special_tokens.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/tokenization_t5_fast.py#L190",returnDescription:`
<p>List of <a href="../glossary#input-ids">input IDs</a> with the appropriate special tokens.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),ja=new O({props:{name:"create_token_type_ids_from_sequences",anchor:"transformers.T5TokenizerFast.create_token_type_ids_from_sequences",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.T5TokenizerFast.create_token_type_ids_from_sequences.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs.`,name:"token_ids_0"},{anchor:"transformers.T5TokenizerFast.create_token_type_ids_from_sequences.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/tokenization_t5_fast.py#L216",returnDescription:`
<p>List of zeros.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),Ma=new ye({}),Ca=new O({props:{name:"class transformers.T5Model",anchor:"transformers.T5Model",parameters:[{name:"config",val:": T5Config"}],parametersDescription:[{anchor:"transformers.T5Model.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config">T5Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_t5.py#L1306"}}),Ia=new O({props:{name:"forward",anchor:"transformers.T5Model.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_attention_mask",val:": typing.Optional[torch.BoolTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"cross_attn_head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"encoder_outputs",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.Tensor] = None"},{name:"decoder_inputs_embeds",val:": typing.Optional[torch.Tensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.T5Model.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. T5 is a model with relative position embeddings so you
should be able to pad the inputs on both the right and the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for detail.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a></p>
<p>To know more on how to prepare <code>input_ids</code> for pretraining take a look a <a href="./t5#training">T5 Training</a>.`,name:"input_ids"},{anchor:"transformers.T5Model.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.T5Model.forward.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#decoder-input-ids">What are decoder input IDs?</a></p>
<p>T5 uses the <code>pad_token_id</code> as the starting token for <code>decoder_input_ids</code> generation. If <code>past_key_values</code>
is used, optionally only the last <code>decoder_input_ids</code> have to be input (see <code>past_key_values</code>).</p>
<p>To know more on how to prepare <code>decoder_input_ids</code> for pretraining take a look at <a href="./t5#training">T5
Training</a>.`,name:"decoder_input_ids"},{anchor:"transformers.T5Model.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.`,name:"decoder_attention_mask"},{anchor:"transformers.T5Model.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the encoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.T5Model.forward.decoder_head_mask",description:`<strong>decoder_head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"decoder_head_mask"},{anchor:"transformers.T5Model.forward.cross_attn_head_mask",description:`<strong>cross_attn_head_mask</strong> (<code>torch.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the cross-attention modules in the decoder. Mask values selected in
<code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"cross_attn_head_mask"},{anchor:"transformers.T5Model.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <code>optional</code>: <em>hidden_states</em>, <code>optional</code>: <em>attentions</em>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code> is a sequence of hidden states at
the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.T5Model.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code> of length <code>config.n_layers</code> with each tuple having 4 tensors of shape <code>(batch_size, num_heads, sequence_length - 1, embed_size_per_head)</code>) &#x2014;
Contains precomputed key and value hidden states of the attention blocks. Can be used to speed up decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.T5Model.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.T5Model.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, target_sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>decoder_input_ids</code> you can choose to directly pass an embedded
representation. If <code>past_key_values</code> is used, optionally only the last <code>decoder_inputs_embeds</code> have to be
input (see <code>past_key_values</code>). This is useful if you want more control over how to convert
<code>decoder_input_ids</code> indices into associated vectors than the model&#x2019;s internal embedding lookup matrix.</p>
<p>If <code>decoder_input_ids</code> and <code>decoder_inputs_embeds</code> are both unset, <code>decoder_inputs_embeds</code> takes the value
of <code>inputs_embeds</code>.`,name:"decoder_inputs_embeds"},{anchor:"transformers.T5Model.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.T5Model.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.T5Model.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.T5Model.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_t5.py#L1393",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.Seq2SeqModelOutput"
>transformers.modeling_outputs.Seq2SeqModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config"
>T5Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</p>
<p>If <code>past_key_values</code> is used only the last hidden-state of the sequences of shape <code>(batch_size, 1, hidden_size)</code> is output.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the decoder at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
<li>
<p><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</p>
</li>
<li>
<p><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the encoder at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the encoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.Seq2SeqModelOutput"
>transformers.modeling_outputs.Seq2SeqModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),en=new Lt({props:{$$slots:{default:[c$]},$$scope:{ctx:q}}}),tn=new Nt({props:{anchor:"transformers.T5Model.forward.example",$$slots:{default:[p$]},$$scope:{ctx:q}}}),Da=new ye({}),Sa=new O({props:{name:"class transformers.T5ForConditionalGeneration",anchor:"transformers.T5ForConditionalGeneration",parameters:[{name:"config",val:": T5Config"}],parametersDescription:[{anchor:"transformers.T5ForConditionalGeneration.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config">T5Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_t5.py#L1509"}}),Ka=new O({props:{name:"forward",anchor:"transformers.T5ForConditionalGeneration.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_attention_mask",val:": typing.Optional[torch.BoolTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"cross_attn_head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"encoder_outputs",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.Tensor]]] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.Tensor]]] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.T5ForConditionalGeneration.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. T5 is a model with relative position embeddings so you
should be able to pad the inputs on both the right and the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for detail.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a></p>
<p>To know more on how to prepare <code>input_ids</code> for pretraining take a look a <a href="./t5#training">T5 Training</a>.`,name:"input_ids"},{anchor:"transformers.T5ForConditionalGeneration.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.T5ForConditionalGeneration.forward.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#decoder-input-ids">What are decoder input IDs?</a></p>
<p>T5 uses the <code>pad_token_id</code> as the starting token for <code>decoder_input_ids</code> generation. If <code>past_key_values</code>
is used, optionally only the last <code>decoder_input_ids</code> have to be input (see <code>past_key_values</code>).</p>
<p>To know more on how to prepare <code>decoder_input_ids</code> for pretraining take a look at <a href="./t5#training">T5
Training</a>.`,name:"decoder_input_ids"},{anchor:"transformers.T5ForConditionalGeneration.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.`,name:"decoder_attention_mask"},{anchor:"transformers.T5ForConditionalGeneration.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the encoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.T5ForConditionalGeneration.forward.decoder_head_mask",description:`<strong>decoder_head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"decoder_head_mask"},{anchor:"transformers.T5ForConditionalGeneration.forward.cross_attn_head_mask",description:`<strong>cross_attn_head_mask</strong> (<code>torch.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the cross-attention modules in the decoder. Mask values selected in
<code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"cross_attn_head_mask"},{anchor:"transformers.T5ForConditionalGeneration.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <code>optional</code>: <em>hidden_states</em>, <code>optional</code>: <em>attentions</em>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code> is a sequence of hidden states at
the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.T5ForConditionalGeneration.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code> of length <code>config.n_layers</code> with each tuple having 4 tensors of shape <code>(batch_size, num_heads, sequence_length - 1, embed_size_per_head)</code>) &#x2014;
Contains precomputed key and value hidden states of the attention blocks. Can be used to speed up decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.T5ForConditionalGeneration.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.T5ForConditionalGeneration.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, target_sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>decoder_input_ids</code> you can choose to directly pass an embedded
representation. If <code>past_key_values</code> is used, optionally only the last <code>decoder_inputs_embeds</code> have to be
input (see <code>past_key_values</code>). This is useful if you want more control over how to convert
<code>decoder_input_ids</code> indices into associated vectors than the model&#x2019;s internal embedding lookup matrix.</p>
<p>If <code>decoder_input_ids</code> and <code>decoder_inputs_embeds</code> are both unset, <code>decoder_inputs_embeds</code> takes the value
of <code>inputs_embeds</code>.`,name:"decoder_inputs_embeds"},{anchor:"transformers.T5ForConditionalGeneration.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.T5ForConditionalGeneration.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.T5ForConditionalGeneration.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.T5ForConditionalGeneration.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.T5ForConditionalGeneration.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[-100, 0, ..., config.vocab_size - 1]</code>. All labels set to <code>-100</code> are ignored (masked), the loss is only computed for
labels in <code>[0, ..., config.vocab_size]</code>`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_t5.py#L1601",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.Seq2SeqLMOutput"
>transformers.modeling_outputs.Seq2SeqLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config"
>T5Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the decoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
<li>
<p><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</p>
</li>
<li>
<p><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the encoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the encoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.Seq2SeqLMOutput"
>transformers.modeling_outputs.Seq2SeqLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),nn=new Lt({props:{$$slots:{default:[h$]},$$scope:{ctx:q}}}),sn=new Nt({props:{anchor:"transformers.T5ForConditionalGeneration.forward.example",$$slots:{default:[u$]},$$scope:{ctx:q}}}),Va=new ye({}),Ya=new O({props:{name:"class transformers.T5EncoderModel",anchor:"transformers.T5EncoderModel",parameters:[{name:"config",val:": T5Config"}],parametersDescription:[{anchor:"transformers.T5EncoderModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config">T5Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_t5.py#L1813"}}),tr=new O({props:{name:"forward",anchor:"transformers.T5EncoderModel.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.T5EncoderModel.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. T5 is a model with relative position embeddings so you
should be able to pad the inputs on both the right and the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for detail.</p>
<p>To know more on how to prepare <code>input_ids</code> for pretraining take a look a <a href="./t5#training">T5 Training</a>.`,name:"input_ids"},{anchor:"transformers.T5EncoderModel.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.T5EncoderModel.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.T5EncoderModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.T5EncoderModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.T5EncoderModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.T5EncoderModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_t5.py#L1880",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.BaseModelOutput"
>transformers.modeling_outputs.BaseModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config"
>T5Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.BaseModelOutput"
>transformers.modeling_outputs.BaseModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),rn=new Lt({props:{$$slots:{default:[m$]},$$scope:{ctx:q}}}),dn=new Nt({props:{anchor:"transformers.T5EncoderModel.forward.example",$$slots:{default:[f$]},$$scope:{ctx:q}}}),or=new ye({}),nr=new O({props:{name:"class transformers.TFT5Model",anchor:"transformers.TFT5Model",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFT5Model.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config">T5Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_tf_t5.py#L1127"}}),cn=new Lt({props:{$$slots:{default:[_$]},$$scope:{ctx:q}}}),lr=new O({props:{name:"call",anchor:"transformers.TFT5Model.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"decoder_input_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"decoder_attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"decoder_head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"encoder_outputs",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"decoder_inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFT5Model.call.input_ids",description:`<strong>input_ids</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. T5 is a model with relative position embeddings so you
should be able to pad the inputs on the right or the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/bert#transformers.BertTokenizer">BertTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a></p>
<p>To know more on how to prepare <code>inputs</code> for pretraining take a look at <a href="./t5#training">T5 Training</a>.`,name:"input_ids"},{anchor:"transformers.TFT5Model.call.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Provide for sequence to sequence training. T5 uses the <code>pad_token_id</code> as the starting token for
<code>decoder_input_ids</code> generation. If <code>past_key_values</code> is used, optionally only the last <code>decoder_input_ids</code>
have to be input (see <code>past_key_values</code>).</p>
<p>To know more on how to prepare <code>decoder_input_ids</code> for pretraining take a look at <a href="./t5#training">T5
Training</a>.`,name:"decoder_input_ids"},{anchor:"transformers.TFT5Model.call.attention_mask",description:`<strong>attention_mask</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFT5Model.call.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.`,name:"decoder_attention_mask"},{anchor:"transformers.TFT5Model.call.head_mask",description:`<strong>head_mask</strong> (<code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the encoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFT5Model.call.decoder_head_mask",description:`<strong>decoder_head_mask</strong> (<code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"decoder_head_mask"},{anchor:"transformers.TFT5Model.call.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(tf.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <code>optional</code>: <em>hidden_states</em>, <code>optional</code>: <em>attentions</em>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code> is a sequence of hidden states at
the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.TFT5Model.call.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(tf.Tensor))</code> of length <code>config.n_layers</code> with each tuple having 4 tensors of shape <code>(batch_size, num_heads, sequence_length - 1, embed_size_per_head)</code>) &#x2014;
contains precomputed key and value hidden states of the attention blocks. Can be used to speed up decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.TFT5Model.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFT5Model.call.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, target_sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>decoder_input_ids</code> you can choose to directly pass an embedded
representation. If <code>past_key_values</code> is used, optionally only the last <code>decoder_inputs_embeds</code> have to be
input (see <code>past_key_values</code>). This is useful if you want more control over how to convert
<code>decoder_input_ids</code> indices into associated vectors than the model&#x2019;s internal embedding lookup matrix.</p>
<p>If <code>decoder_input_ids</code> and <code>decoder_inputs_embeds</code> are both unset, <code>decoder_inputs_embeds</code> takes the value
of <code>inputs_embeds</code>.`,name:"decoder_inputs_embeds"},{anchor:"transformers.TFT5Model.call.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.TFT5Model.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFT5Model.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFT5Model.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used in
eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFT5Model.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_tf_t5.py#L1155",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFSeq2SeqModelOutput"
>transformers.modeling_tf_outputs.TFSeq2SeqModelOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config"
>T5Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</p>
<p>If <code>past_key_values</code> is used only the last hidden-state of the sequences of shape <code>(batch_size, 1, hidden_size)</code> is output.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>List[tf.Tensor]</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 List of <code>tf.Tensor</code> of length <code>config.n_layers</code>, with each tensor of shape <code>(2, batch_size, num_heads, sequence_length, embed_size_per_head)</code>).</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) of the decoder that can be
used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>decoder_hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the decoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>decoder_attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
<li>
<p><strong>encoder_last_hidden_state</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</p>
</li>
<li>
<p><strong>encoder_hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the encoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>encoder_attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the encoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFSeq2SeqModelOutput"
>transformers.modeling_tf_outputs.TFSeq2SeqModelOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),pn=new Lt({props:{$$slots:{default:[g$]},$$scope:{ctx:q}}}),hn=new Nt({props:{anchor:"transformers.TFT5Model.call.example",$$slots:{default:[T$]},$$scope:{ctx:q}}}),cr=new ye({}),pr=new O({props:{name:"class transformers.TFT5ForConditionalGeneration",anchor:"transformers.TFT5ForConditionalGeneration",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFT5ForConditionalGeneration.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config">T5Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_tf_t5.py#L1279"}}),mn=new Lt({props:{$$slots:{default:[k$]},$$scope:{ctx:q}}}),Tr=new O({props:{name:"call",anchor:"transformers.TFT5ForConditionalGeneration.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"decoder_input_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"decoder_attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"decoder_head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"encoder_outputs",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"decoder_inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFT5ForConditionalGeneration.call.input_ids",description:`<strong>input_ids</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. T5 is a model with relative position embeddings so you
should be able to pad the inputs on the right or the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/bert#transformers.BertTokenizer">BertTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a></p>
<p>To know more on how to prepare <code>inputs</code> for pretraining take a look at <a href="./t5#training">T5 Training</a>.`,name:"input_ids"},{anchor:"transformers.TFT5ForConditionalGeneration.call.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Provide for sequence to sequence training. T5 uses the <code>pad_token_id</code> as the starting token for
<code>decoder_input_ids</code> generation. If <code>past_key_values</code> is used, optionally only the last <code>decoder_input_ids</code>
have to be input (see <code>past_key_values</code>).</p>
<p>To know more on how to prepare <code>decoder_input_ids</code> for pretraining take a look at <a href="./t5#training">T5
Training</a>.`,name:"decoder_input_ids"},{anchor:"transformers.TFT5ForConditionalGeneration.call.attention_mask",description:`<strong>attention_mask</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFT5ForConditionalGeneration.call.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.`,name:"decoder_attention_mask"},{anchor:"transformers.TFT5ForConditionalGeneration.call.head_mask",description:`<strong>head_mask</strong> (<code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the encoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFT5ForConditionalGeneration.call.decoder_head_mask",description:`<strong>decoder_head_mask</strong> (<code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules in the decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"decoder_head_mask"},{anchor:"transformers.TFT5ForConditionalGeneration.call.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(tf.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <code>optional</code>: <em>hidden_states</em>, <code>optional</code>: <em>attentions</em>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code> is a sequence of hidden states at
the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.TFT5ForConditionalGeneration.call.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(tf.Tensor))</code> of length <code>config.n_layers</code> with each tuple having 4 tensors of shape <code>(batch_size, num_heads, sequence_length - 1, embed_size_per_head)</code>) &#x2014;
contains precomputed key and value hidden states of the attention blocks. Can be used to speed up decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.TFT5ForConditionalGeneration.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFT5ForConditionalGeneration.call.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, target_sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>decoder_input_ids</code> you can choose to directly pass an embedded
representation. If <code>past_key_values</code> is used, optionally only the last <code>decoder_inputs_embeds</code> have to be
input (see <code>past_key_values</code>). This is useful if you want more control over how to convert
<code>decoder_input_ids</code> indices into associated vectors than the model&#x2019;s internal embedding lookup matrix.</p>
<p>If <code>decoder_input_ids</code> and <code>decoder_inputs_embeds</code> are both unset, <code>decoder_inputs_embeds</code> takes the value
of <code>inputs_embeds</code>.`,name:"decoder_inputs_embeds"},{anchor:"transformers.TFT5ForConditionalGeneration.call.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.TFT5ForConditionalGeneration.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFT5ForConditionalGeneration.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFT5ForConditionalGeneration.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used in
eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFT5ForConditionalGeneration.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFT5ForConditionalGeneration.call.labels",description:`<strong>labels</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the cross entropy classification loss. Indices should be in <code>[0, ..., config.vocab_size - 1]</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_tf_t5.py#L1334",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFSeq2SeqLMOutput"
>transformers.modeling_tf_outputs.TFSeq2SeqLMOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config"
>T5Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(n,)</code>, <em>optional</em>, where n is the number of non-masked labels, returned when <code>labels</code> is provided) \u2014 Language modeling loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>List[tf.Tensor]</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 List of <code>tf.Tensor</code> of length <code>config.n_layers</code>, with each tensor of shape <code>(2, batch_size, num_heads, sequence_length, embed_size_per_head)</code>).</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) of the decoder that can be
used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>decoder_hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the decoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>decoder_attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
<li>
<p><strong>encoder_last_hidden_state</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</p>
</li>
<li>
<p><strong>encoder_hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the encoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>encoder_attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the encoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFSeq2SeqLMOutput"
>transformers.modeling_tf_outputs.TFSeq2SeqLMOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),fn=new Lt({props:{$$slots:{default:[b$]},$$scope:{ctx:q}}}),_n=new Nt({props:{anchor:"transformers.TFT5ForConditionalGeneration.call.example",$$slots:{default:[v$]},$$scope:{ctx:q}}}),kr=new ye({}),br=new O({props:{name:"class transformers.TFT5EncoderModel",anchor:"transformers.TFT5EncoderModel",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFT5EncoderModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config">T5Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_tf_t5.py#L1532"}}),Tn=new Lt({props:{$$slots:{default:[y$]},$$scope:{ctx:q}}}),zr=new O({props:{name:"call",anchor:"transformers.TFT5EncoderModel.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFT5EncoderModel.call.inputs",description:`<strong>inputs</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. T5 is a model with relative position embeddings so you
should be able to pad the inputs on the right or the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p>To know more on how to prepare <code>inputs</code> for pre-training take a look at <a href="./t5#training">T5 Training</a>.`,name:"inputs"},{anchor:"transformers.TFT5EncoderModel.call.attention_mask",description:`<strong>attention_mask</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFT5EncoderModel.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFT5EncoderModel.call.head_mask",description:`<strong>head_mask</strong> (<code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFT5EncoderModel.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TFT5EncoderModel.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TFT5EncoderModel.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.TFT5EncoderModel.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_tf_t5.py#L1555",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFBaseModelOutput"
>transformers.modeling_tf_outputs.TFBaseModelOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config"
>T5Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFBaseModelOutput"
>transformers.modeling_tf_outputs.TFBaseModelOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),kn=new Lt({props:{$$slots:{default:[w$]},$$scope:{ctx:q}}}),bn=new Nt({props:{anchor:"transformers.TFT5EncoderModel.call.example",$$slots:{default:[$$]},$$scope:{ctx:q}}}),Er=new ye({}),qr=new O({props:{name:"class transformers.FlaxT5Model",anchor:"transformers.FlaxT5Model",parameters:[{name:"config",val:": T5Config"},{name:"input_shape",val:": typing.Tuple[int] = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"gradient_checkpointing",val:": bool = False"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_flax_t5.py#L1367"}}),Fr=new O({props:{name:"__call__",anchor:"transformers.FlaxT5Model.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"attention_mask",val:": typing.Optional[jax._src.numpy.ndarray.ndarray] = None"},{name:"decoder_input_ids",val:": ndarray = None"},{name:"decoder_attention_mask",val:": typing.Optional[jax._src.numpy.ndarray.ndarray] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"train",val:": bool = False"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"}],parametersDescription:[{anchor:"transformers.FlaxT5Model.__call__.input_ids",description:`<strong>input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. T5 is a model with relative position embeddings so you
should be able to pad the inputs on both the right and the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for detail.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a></p>
<p>To know more on how to prepare <code>input_ids</code> for pretraining take a look a <a href="./t5#training">T5 Training</a>.`,name:"input_ids"},{anchor:"transformers.FlaxT5Model.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxT5Model.__call__.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#decoder-input-ids">What are decoder input IDs?</a></p>
<p>T5 uses the <code>pad_token_id</code> as the starting token for <code>decoder_input_ids</code> generation. If <code>past_key_values</code>
is used, optionally only the last <code>decoder_input_ids</code> have to be input (see <code>past_key_values</code>).</p>
<p>To know more on how to prepare <code>decoder_input_ids</code> for pretraining take a look at <a href="./t5#training">T5
Training</a>.`,name:"decoder_input_ids"},{anchor:"transformers.FlaxT5Model.__call__.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.`,name:"decoder_attention_mask"},{anchor:"transformers.FlaxT5Model.__call__.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(jnp.ndarray)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <code>optional</code>: <em>hidden_states</em>, <code>optional</code>: <em>attentions</em>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code> is a sequence of hidden states at
the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.FlaxT5Model.__call__.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(jnp.ndarray))</code> of length <code>config.n_layers</code> with each tuple having 4 tensors of shape <code>(batch_size, num_heads, sequence_length - 1, embed_size_per_head)</code>) &#x2014;
Contains precomputed key and value hidden states of the attention blocks. Can be used to speed up decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_flax_t5.py#L986",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxSeq2SeqLMOutput"
>transformers.modeling_flax_outputs.FlaxSeq2SeqLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config"
>T5Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(jnp.ndarray))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(jnp.ndarray)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>decoder_hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the decoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>decoder_attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
<li>
<p><strong>encoder_last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</p>
</li>
<li>
<p><strong>encoder_hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the encoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>encoder_attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the encoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxSeq2SeqLMOutput"
>transformers.modeling_flax_outputs.FlaxSeq2SeqLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),yn=new Lt({props:{$$slots:{default:[x$]},$$scope:{ctx:q}}}),wn=new Nt({props:{anchor:"transformers.FlaxT5Model.__call__.example",$$slots:{default:[z$]},$$scope:{ctx:q}}}),jr=new O({props:{name:"encode",anchor:"transformers.FlaxT5Model.encode",parameters:[{name:"input_ids",val:": ndarray"},{name:"attention_mask",val:": typing.Optional[jax._src.numpy.ndarray.ndarray] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"train",val:": bool = False"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"}],parametersDescription:[{anchor:"transformers.FlaxT5Model.encode.input_ids",description:`<strong>input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. T5 is a model with relative position embeddings so you
should be able to pad the inputs on both the right and the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for detail.</p>
<p>To know more on how to prepare <code>input_ids</code> for pretraining take a look a <a href="./t5#training">T5 Training</a>.`,name:"input_ids"},{anchor:"transformers.FlaxT5Model.encode.attention_mask",description:`<strong>attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxT5Model.encode.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxT5Model.encode.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxT5Model.encode.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_flax_t5.py#L1072",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutput"
>transformers.modeling_flax_outputs.FlaxBaseModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.t5.configuration_t5.T5Config'&gt;</code>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutput"
>transformers.modeling_flax_outputs.FlaxBaseModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),xn=new Nt({props:{anchor:"transformers.FlaxT5Model.encode.example",$$slots:{default:[E$]},$$scope:{ctx:q}}}),Mr=new O({props:{name:"decode",anchor:"transformers.FlaxT5Model.decode",parameters:[{name:"decoder_input_ids",val:""},{name:"encoder_outputs",val:""},{name:"encoder_attention_mask",val:": typing.Optional[jax._src.numpy.ndarray.ndarray] = None"},{name:"decoder_attention_mask",val:": typing.Optional[jax._src.numpy.ndarray.ndarray] = None"},{name:"past_key_values",val:": dict = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"train",val:": bool = False"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"}],parametersDescription:[{anchor:"transformers.FlaxT5Model.decode.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, target_sequence_length)</code>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#decoder-input-ids">What are decoder input IDs?</a></p>
<p>For training, <code>decoder_input_ids</code> should be provided.`,name:"decoder_input_ids"},{anchor:"transformers.FlaxT5Model.decode.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(jnp.ndarray)</code>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.FlaxT5Model.decode.encoder_attention_mask",description:`<strong>encoder_attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"encoder_attention_mask"},{anchor:"transformers.FlaxT5Model.decode.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.</p>
<p>If you want to change padding behavior, you should modify to your needs. See diagram 1 in <a href="https://arxiv.org/abs/1910.13461" rel="nofollow">the
paper</a> for more information on the default strategy.`,name:"decoder_attention_mask"},{anchor:"transformers.FlaxT5Model.decode.past_key_values",description:`<strong>past_key_values</strong> (<code>Dict[str, np.ndarray]</code>, <em>optional</em>, returned by <code>init_cache</code> or when passing previous <code>past_key_values</code>) &#x2014;
Dictionary of pre-computed hidden-states (key and values in the attention blocks) that can be used for fast
auto-regressive decoding. Pre-computed key and value hidden-states are of shape <em>[batch_size, max_length]</em>.`,name:"past_key_values"},{anchor:"transformers.FlaxT5Model.decode.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxT5Model.decode.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxT5Model.decode.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_flax_t5.py#L1130",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPastAndCrossAttentions"
>transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPastAndCrossAttentions</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.t5.configuration_t5.T5Config'&gt;</code>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
<p>If <code>past_key_values</code> is used only the last hidden-state of the sequences of shape <code>(batch_size, 1, hidden_size)</code> is output.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(jnp.ndarray))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(jnp.ndarray)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and optionally if
<code>config.is_encoder_decoder=True</code> 2 additional tensors of shape <code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and optionally if
<code>config.is_encoder_decoder=True</code> in the cross-attention blocks) that can be used (see <code>past_key_values</code>
input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> and <code>config.add_cross_attention=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPastAndCrossAttentions"
>transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPastAndCrossAttentions</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),En=new Nt({props:{anchor:"transformers.FlaxT5Model.decode.example",$$slots:{default:[q$]},$$scope:{ctx:q}}}),Cr=new ye({}),Ar=new O({props:{name:"class transformers.FlaxT5ForConditionalGeneration",anchor:"transformers.FlaxT5ForConditionalGeneration",parameters:[{name:"config",val:": T5Config"},{name:"input_shape",val:": typing.Tuple[int] = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"gradient_checkpointing",val:": bool = False"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_flax_t5.py#L1605"}}),Pr=new O({props:{name:"__call__",anchor:"transformers.FlaxT5ForConditionalGeneration.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"attention_mask",val:": typing.Optional[jax._src.numpy.ndarray.ndarray] = None"},{name:"decoder_input_ids",val:": ndarray = None"},{name:"decoder_attention_mask",val:": typing.Optional[jax._src.numpy.ndarray.ndarray] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"train",val:": bool = False"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"}],parametersDescription:[{anchor:"transformers.FlaxT5ForConditionalGeneration.__call__.input_ids",description:`<strong>input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. T5 is a model with relative position embeddings so you
should be able to pad the inputs on both the right and the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for detail.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a></p>
<p>To know more on how to prepare <code>input_ids</code> for pretraining take a look a <a href="./t5#training">T5 Training</a>.`,name:"input_ids"},{anchor:"transformers.FlaxT5ForConditionalGeneration.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxT5ForConditionalGeneration.__call__.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#decoder-input-ids">What are decoder input IDs?</a></p>
<p>T5 uses the <code>pad_token_id</code> as the starting token for <code>decoder_input_ids</code> generation. If <code>past_key_values</code>
is used, optionally only the last <code>decoder_input_ids</code> have to be input (see <code>past_key_values</code>).</p>
<p>To know more on how to prepare <code>decoder_input_ids</code> for pretraining take a look at <a href="./t5#training">T5
Training</a>.`,name:"decoder_input_ids"},{anchor:"transformers.FlaxT5ForConditionalGeneration.__call__.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.`,name:"decoder_attention_mask"},{anchor:"transformers.FlaxT5ForConditionalGeneration.__call__.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(jnp.ndarray)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <code>optional</code>: <em>hidden_states</em>, <code>optional</code>: <em>attentions</em>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code> is a sequence of hidden states at
the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.FlaxT5ForConditionalGeneration.__call__.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(jnp.ndarray))</code> of length <code>config.n_layers</code> with each tuple having 4 tensors of shape <code>(batch_size, num_heads, sequence_length - 1, embed_size_per_head)</code>) &#x2014;
Contains precomputed key and value hidden states of the attention blocks. Can be used to speed up decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_flax_t5.py#L986",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxSeq2SeqLMOutput"
>transformers.modeling_flax_outputs.FlaxSeq2SeqLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/t5#transformers.T5Config"
>T5Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(jnp.ndarray))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(jnp.ndarray)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>decoder_hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the decoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>decoder_attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
<li>
<p><strong>encoder_last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</p>
</li>
<li>
<p><strong>encoder_hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the encoder at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>encoder_attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the encoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxSeq2SeqLMOutput"
>transformers.modeling_flax_outputs.FlaxSeq2SeqLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Fn=new Lt({props:{$$slots:{default:[F$]},$$scope:{ctx:q}}}),jn=new Nt({props:{anchor:"transformers.FlaxT5ForConditionalGeneration.__call__.example",$$slots:{default:[j$]},$$scope:{ctx:q}}}),Or=new O({props:{name:"encode",anchor:"transformers.FlaxT5ForConditionalGeneration.encode",parameters:[{name:"input_ids",val:": ndarray"},{name:"attention_mask",val:": typing.Optional[jax._src.numpy.ndarray.ndarray] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"train",val:": bool = False"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"}],parametersDescription:[{anchor:"transformers.FlaxT5ForConditionalGeneration.encode.input_ids",description:`<strong>input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. T5 is a model with relative position embeddings so you
should be able to pad the inputs on both the right and the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for detail.</p>
<p>To know more on how to prepare <code>input_ids</code> for pretraining take a look a <a href="./t5#training">T5 Training</a>.`,name:"input_ids"},{anchor:"transformers.FlaxT5ForConditionalGeneration.encode.attention_mask",description:`<strong>attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxT5ForConditionalGeneration.encode.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxT5ForConditionalGeneration.encode.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxT5ForConditionalGeneration.encode.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_flax_t5.py#L1072",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutput"
>transformers.modeling_flax_outputs.FlaxBaseModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.t5.configuration_t5.T5Config'&gt;</code>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutput"
>transformers.modeling_flax_outputs.FlaxBaseModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Cn=new Nt({props:{anchor:"transformers.FlaxT5ForConditionalGeneration.encode.example",$$slots:{default:[M$]},$$scope:{ctx:q}}}),Lr=new O({props:{name:"decode",anchor:"transformers.FlaxT5ForConditionalGeneration.decode",parameters:[{name:"decoder_input_ids",val:""},{name:"encoder_outputs",val:""},{name:"encoder_attention_mask",val:": typing.Optional[jax._src.numpy.ndarray.ndarray] = None"},{name:"decoder_attention_mask",val:": typing.Optional[jax._src.numpy.ndarray.ndarray] = None"},{name:"past_key_values",val:": dict = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"train",val:": bool = False"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"}],parametersDescription:[{anchor:"transformers.FlaxT5ForConditionalGeneration.decode.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, target_sequence_length)</code>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#decoder-input-ids">What are decoder input IDs?</a></p>
<p>For training, <code>decoder_input_ids</code> should be provided.`,name:"decoder_input_ids"},{anchor:"transformers.FlaxT5ForConditionalGeneration.decode.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(jnp.ndarray)</code>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.FlaxT5ForConditionalGeneration.decode.encoder_attention_mask",description:`<strong>encoder_attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"encoder_attention_mask"},{anchor:"transformers.FlaxT5ForConditionalGeneration.decode.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.</p>
<p>If you want to change padding behavior, you should modify to your needs. See diagram 1 in <a href="https://arxiv.org/abs/1910.13461" rel="nofollow">the
paper</a> for more information on the default strategy.`,name:"decoder_attention_mask"},{anchor:"transformers.FlaxT5ForConditionalGeneration.decode.past_key_values",description:`<strong>past_key_values</strong> (<code>Dict[str, np.ndarray]</code>, <em>optional</em>, returned by <code>init_cache</code> or when passing previous <code>past_key_values</code>) &#x2014;
Dictionary of pre-computed hidden-states (key and values in the attention blocks) that can be used for fast
auto-regressive decoding. Pre-computed key and value hidden-states are of shape <em>[batch_size, max_length]</em>.`,name:"past_key_values"},{anchor:"transformers.FlaxT5ForConditionalGeneration.decode.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxT5ForConditionalGeneration.decode.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxT5ForConditionalGeneration.decode.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_flax_t5.py#L1608",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxCausalLMOutputWithCrossAttentions"
>transformers.modeling_flax_outputs.FlaxCausalLMOutputWithCrossAttentions</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.t5.configuration_t5.T5Config'&gt;</code>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Cross attentions weights after the attention softmax, used to compute the weighted average in the
cross-attention heads.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(jnp.ndarray))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> tuples of length <code>config.n_layers</code>, with each tuple containing the cached key, value
states of the self-attention and the cross-attention layers if model is used in encoder-decoder setting.
Only relevant if <code>config.is_decoder = True</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxCausalLMOutputWithCrossAttentions"
>transformers.modeling_flax_outputs.FlaxCausalLMOutputWithCrossAttentions</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Pn=new Nt({props:{anchor:"transformers.FlaxT5ForConditionalGeneration.decode.example",$$slots:{default:[C$]},$$scope:{ctx:q}}}),Nr=new ye({}),Ir=new O({props:{name:"class transformers.FlaxT5EncoderModel",anchor:"transformers.FlaxT5EncoderModel",parameters:[{name:"config",val:": T5Config"},{name:"input_shape",val:": typing.Tuple[int] = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"gradient_checkpointing",val:": bool = False"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_flax_t5.py#L1454"}}),Dr=new O({props:{name:"__call__",anchor:"transformers.FlaxT5EncoderModel.__call__",parameters:[{name:"input_ids",val:": ndarray"},{name:"attention_mask",val:": typing.Optional[jax._src.numpy.ndarray.ndarray] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"train",val:": bool = False"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"}],parametersDescription:[{anchor:"transformers.FlaxT5EncoderModel.__call__.input_ids",description:`<strong>input_ids</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. T5 is a model with relative position embeddings so you
should be able to pad the inputs on both the right and the left.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for detail.</p>
<p>To know more on how to prepare <code>input_ids</code> for pretraining take a look a <a href="./t5#training">T5 Training</a>.`,name:"input_ids"},{anchor:"transformers.FlaxT5EncoderModel.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxT5EncoderModel.__call__.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxT5EncoderModel.__call__.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxT5EncoderModel.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/t5/modeling_flax_t5.py#L1457"}}),Ln=new Lt({props:{$$slots:{default:[A$]},$$scope:{ctx:q}}}),{c(){m=a("meta"),k=c(),g=a("h1"),_=a("a"),T=a("span"),b(d.$$.fragment),f=c(),F=a("span"),Le=n("T5"),je=c(),I=a("div"),ue=a("a"),J=a("img"),Ne=c(),B=a("a"),me=a("img"),Y=c(),X=a("h2"),ne=a("a"),R=a("span"),b(ie.$$.fragment),Ie=c(),H=a("span"),De=n("Overview"),Me=c(),S=a("p"),Se=n("The T5 model was presented in "),de=a("a"),fe=n("Exploring the Limits of Transfer Learning with a Unified Text-to-Text Transformer"),C=n(` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan Narang,
Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu.`),P=c(),_e=a("p"),Q=n("The abstract from the paper is the following:"),Ce=c(),ge=a("p"),K=a("em"),Ge=n(`Transfer learning, where a model is first pre-trained on a data-rich task before being fine-tuned on a downstream
task, has emerged as a powerful technique in natural language processing (NLP). The effectiveness of transfer learning
has given rise to a diversity of approaches, methodology, and practice. In this paper, we explore the landscape of
transfer learning techniques for NLP by introducing a unified framework that converts every language problem into a
text-to-text format. Our systematic study compares pretraining objectives, architectures, unlabeled datasets, transfer
approaches, and other factors on dozens of language understanding tasks. By combining the insights from our exploration
with scale and our new \u201CColossal Clean Crawled Corpus\u201D, we achieve state-of-the-art results on many benchmarks covering
summarization, question answering, text classification, and more. To facilitate future work on transfer learning for
NLP, we release our dataset, pre-trained models, and code.`),Ae=c(),A=a("p"),Be=n("Tips:"),Z=c(),G=a("ul"),$e=a("li"),D=a("p"),Ue=n(`T5 is an encoder-decoder model pre-trained on a multi-task mixture of unsupervised and supervised tasks and for which
each task is converted into a text-to-text format. T5 works well on a variety of tasks out-of-the-box by prepending a
different prefix to the input corresponding to each task, e.g., for translation: `),xe=a("em"),U=n("translate English to German: \u2026"),We=n(`,
for summarization: `),V=a("em"),Re=n("summarize: \u2026"),Te=n("."),L=c(),ze=a("li"),N=a("p"),He=n("The pretraining includes both supervised and self-supervised training. Supervised training is conducted on downstream tasks provided by the GLUE and SuperGLUE benchmarks (converting them into text-to-text tasks as explained above)."),Ke=c(),z=a("li"),j=a("p"),ft=n("Self-supervised training uses corrupted tokens, by randomly removing 15% of the tokens and replacing them with individual sentinel tokens (if several consecutive tokens are marked for removal, the whole group is replaced with a single sentinel token). The input of the encoder is the corrupted sentence, the input of the decoder is the original sentence and the target is then the dropped out tokens delimited by their sentinel tokens."),ke=c(),et=a("li"),tt=a("p"),M=n("T5 uses relative scalar embeddings. Encoder input padding can be done on the left and on the right."),_t=c(),ot=a("li"),se=a("p"),gt=n("See the "),Ve=a("a"),W=n("training"),ee=n(", "),Ye=a("a"),Tt=n("inference"),te=n(" and "),Ze=a("a"),kt=n("scripts"),Je=n(" sections below for all details regarding usage."),pt=c(),oe=a("p"),bt=n("T5 comes in different sizes:"),Bc=c(),nt=a("ul"),bd=a("li"),vd=a("p"),Xn=a("a"),Eu=n("t5-small"),qu=c(),yd=a("li"),wd=a("p"),Qn=a("a"),Fu=n("t5-base"),ju=c(),$d=a("li"),xd=a("p"),es=a("a"),Mu=n("t5-large"),Cu=c(),zd=a("li"),Ed=a("p"),ts=a("a"),Au=n("t5-3b"),Pu=c(),qd=a("li"),Yr=a("p"),os=a("a"),Ou=n("t5-11b"),Lu=n("."),Uc=c(),Zr=a("p"),Nu=n("Based on the original T5 model, Google has released some follow-up works:"),Wc=c(),Gt=a("ul"),Fd=a("li"),Ao=a("p"),jd=a("strong"),Iu=n("T5v1.1"),Du=n(`: T5v1.1 is an improved version of T5 with some architectural tweaks, and is pre-trained on C4 only without
mixing in the supervised tasks. Refer to the documentation of T5v1.1 which can be found `),Jr=a("a"),Su=n("here"),Gu=n("."),Bu=c(),Md=a("li"),Po=a("p"),Cd=a("strong"),Uu=n("mT5"),Wu=n(`: mT5 is a multilingual T5 model. It is pre-trained on the mC4 corpus, which includes 101 languages. Refer to
the documentation of mT5 which can be found `),Xr=a("a"),Ru=n("here"),Hu=n("."),Ku=c(),Ad=a("li"),Oo=a("p"),Pd=a("strong"),Vu=n("byT5"),Yu=n(`: byT5 is a T5 model pre-trained on byte sequences rather than SentencePiece subword token sequences. Refer
to the documentation of byT5 which can be found `),Qr=a("a"),Zu=n("here"),Ju=n("."),Rc=c(),Lo=a("p"),Xu=n("All checkpoints can be found on the "),ns=a("a"),Qu=n("hub"),em=n("."),Hc=c(),Bt=a("p"),tm=n("This model was contributed by "),ss=a("a"),om=n("thomwolf"),nm=n(". The original code can be found "),as=a("a"),sm=n("here"),am=n("."),Kc=c(),ei=a("a"),Vc=c(),oo=a("h2"),No=a("a"),Od=a("span"),b(rs.$$.fragment),rm=c(),Ld=a("span"),im=n("Training"),Yc=c(),vt=a("p"),dm=n(`T5 is an encoder-decoder model and converts all NLP problems into a text-to-text format. It is trained using teacher
forcing. This means that for training, we always need an input sequence and a corresponding target sequence. The input
sequence is fed to the model using `),Nd=a("code"),lm=n("input_ids"),cm=n(`. The target sequence is shifted to the right, i.e., prepended by a
start-sequence token and fed to the decoder using the `),Id=a("code"),pm=n("decoder_input_ids"),hm=n(`. In teacher-forcing style, the target
sequence is then appended by the EOS token and corresponds to the `),Dd=a("code"),um=n("labels"),mm=n(`. The PAD token is hereby used as the
start-sequence token. T5 can be trained / fine-tuned both in a supervised and unsupervised fashion.`),Zc=c(),Io=a("p"),fm=n("One can use "),ti=a("a"),_m=n("T5ForConditionalGeneration"),gm=n(` (or the Tensorflow/Flax variant), which includes the
language modeling head on top of the decoder.`),Jc=c(),oi=a("ul"),Sd=a("li"),Tm=n("Unsupervised denoising training"),Xc=c(),be=a("p"),km=n("In this setup, spans of the input sequence are masked by so-called sentinel tokens ("),Gd=a("em"),bm=n("a.k.a"),vm=n(` unique mask tokens) and
the output sequence is formed as a concatenation of the same sentinel tokens and the `),Bd=a("em"),ym=n("real"),wm=n(` masked tokens. Each
sentinel token represents a unique mask token for this sentence and should start with `),Ud=a("code"),$m=n("<extra_id_0>"),xm=n(`,
`),Wd=a("code"),zm=n("<extra_id_1>"),Em=n(", \u2026 up to "),Rd=a("code"),qm=n("<extra_id_99>"),Fm=n(`. As a default, 100 sentinel tokens are available in
`),ni=a("a"),jm=n("T5Tokenizer"),Mm=n("."),Qc=c(),si=a("p"),Cm=n(`For instance, the sentence \u201CThe cute dog walks in the park\u201D with the masks put on \u201Ccute dog\u201D and \u201Cthe\u201D should be
processed as follows:`),ep=c(),b(is.$$.fragment),tp=c(),Do=a("p"),Am=n("If you\u2019re interested in pre-training T5 on a new corpus, check out the "),ds=a("a"),Pm=n("run_t5_mlm_flax.py"),Om=n(` script in the Examples
directory.`),op=c(),ai=a("ul"),Hd=a("li"),Lm=n("Supervised training"),np=c(),ri=a("p"),Nm=n(`In this setup, the input sequence and output sequence are a standard sequence-to-sequence input-output mapping.
Suppose that we want to fine-tune the model for translation for example, and we have a training example: the input
sequence \u201CThe house is wonderful.\u201D and output sequence \u201CDas Haus ist wunderbar.\u201D, then they should be prepared for
the model as follows:`),sp=c(),b(ls.$$.fragment),ap=c(),ae=a("p"),Im=n("As you can see, only 2 inputs are required for the model in order to compute a loss: "),Kd=a("code"),Dm=n("input_ids"),Sm=n(` (which are the
`),Vd=a("code"),Gm=n("input_ids"),Bm=n(" of the encoded input sequence) and "),Yd=a("code"),Um=n("labels"),Wm=n(" (which are the "),Zd=a("code"),Rm=n("input_ids"),Hm=n(` of the encoded
target sequence). The model will automatically create the `),Jd=a("code"),Km=n("decoder_input_ids"),Vm=n(" based on the "),Xd=a("code"),Ym=n("labels"),Zm=n(`, by
shifting them one position to the right and prepending the `),Qd=a("code"),Jm=n("config.decoder_start_token_id"),Xm=n(`, which for T5 is
equal to 0 (i.e. the id of the pad token). Also note the task prefix: we prepend the input sequence with \u2018translate
English to German: \u2019 before encoding it. This will help in improving the performance, as this task prefix was used
during T5\u2019s pre-training.`),rp=c(),Ut=a("p"),Qm=n(`However, the example above only shows a single training example. In practice, one trains deep learning models in
batches. This entails that we must pad/truncate examples to the same length. For encoder-decoder models, one
typically defines a `),el=a("code"),ef=n("max_source_length"),tf=n(" and "),tl=a("code"),of=n("max_target_length"),nf=n(`, which determine the maximum length of the
input and output sequences respectively (otherwise they are truncated). These should be carefully set depending on
the task.`),ip=c(),ve=a("p"),sf=n("In addition, we must make sure that padding token id\u2019s of the "),ol=a("code"),af=n("labels"),rf=n(` are not taken into account by the loss
function. In PyTorch and Tensorflow, this can be done by replacing them with -100, which is the `),nl=a("code"),df=n("ignore_index"),lf=n(`
of the `),sl=a("code"),cf=n("CrossEntropyLoss"),pf=n(". In Flax, one can use the "),al=a("code"),hf=n("decoder_attention_mask"),uf=n(` to ignore padded tokens from
the loss (see the `),cs=a("a"),mf=n("Flax summarization script"),ff=n(` for details). We also pass
`),rl=a("code"),_f=n("attention_mask"),gf=n(` as additional input to the model, which makes sure that padding tokens of the inputs are
ignored. The code example below illustrates all of this.`),dp=c(),b(ps.$$.fragment),lp=c(),ii=a("p"),Tf=n("Additional training tips:"),cp=c(),di=a("ul"),hs=a("li"),kf=n("T5 models need a slightly higher learning rate than the default one set in the "),il=a("code"),bf=n("Trainer"),vf=n(` when using the AdamW
optimizer. Typically, 1e-4 and 3e-4 work well for most problems (classification, summarization, translation, question
answering, question generation). Note that T5 was pre-trained using the AdaFactor optimizer.`),pp=c(),Wt=a("p"),yf=n("According to "),us=a("a"),wf=n("this forum post"),$f=n(`, task prefixes matter when
(1) doing multi-task training (2) your task is similar or related to one of the supervised tasks used in T5\u2019s
pre-training mixture (see Appendix D of the `),ms=a("a"),xf=n("paper"),zf=n(` for the task prefixes
used).`),hp=c(),So=a("p"),Ef=n(`If training on TPU, it is recommended to pad all examples of the dataset to the same length or make use of
`),dl=a("em"),qf=n("pad_to_multiple_of"),Ff=n(` to have a small number of predefined bucket sizes to fit all examples in. Dynamically padding
batches to the longest example is not recommended on TPU as it triggers a recompilation for every batch shape that is
encountered during training thus significantly slowing down the training. only padding up to the longest example in a
batch) leads to very slow training on TPU.`),up=c(),li=a("a"),mp=c(),no=a("h2"),Go=a("a"),ll=a("span"),b(fs.$$.fragment),jf=c(),cl=a("span"),Mf=n("Inference"),fp=c(),yt=a("p"),Cf=n("At inference time, it is recommended to use "),ci=a("a"),Af=n("generate()"),Pf=n(`. This
method takes care of encoding the input and feeding the encoded hidden states via cross-attention layers to the decoder
and auto-regressively generates the decoder output. Check out `),_s=a("a"),Of=n("this blog post"),Lf=n(` to know all the details about generating text with Transformers.
There\u2019s also `),gs=a("a"),Nf=n("this blog post"),If=n(` which explains how
generation works in general in encoder-decoder models.`),_p=c(),b(Ts.$$.fragment),gp=c(),st=a("p"),Df=n("Note that T5 uses the "),pl=a("code"),Sf=n("pad_token_id"),Gf=n(" as the "),hl=a("code"),Bf=n("decoder_start_token_id"),Uf=n(`, so when doing generation without using
`),pi=a("a"),Wf=n("generate()"),Rf=n(", make sure you start it with the "),ul=a("code"),Hf=n("pad_token_id"),Kf=n("."),Tp=c(),hi=a("p"),Vf=n("The example above only shows a single example. You can also do batched inference, like so:"),kp=c(),b(ks.$$.fragment),bp=c(),ui=a("p"),Yf=n(`Because T5 has been trained with the span-mask denoising objective,
it can be used to predict the sentinel (masked-out) tokens during inference.
The predicted tokens will then be placed between the sentinel tokens.`),vp=c(),b(bs.$$.fragment),yp=c(),mi=a("a"),wp=c(),so=a("h2"),Bo=a("a"),ml=a("span"),b(vs.$$.fragment),Zf=c(),fl=a("span"),Jf=n("Performance"),$p=c(),wt=a("p"),Xf=n("If you\u2019d like a faster training and inference performance, install "),ys=a("a"),Qf=n("apex"),e_=n(" and then the model will automatically use "),_l=a("code"),t_=n("apex.normalization.FusedRMSNorm"),o_=n(" instead of "),gl=a("code"),n_=n("T5LayerNorm"),s_=n(". The former uses an optimized fused kernel which is several times faster than the latter."),xp=c(),ao=a("h2"),Uo=a("a"),Tl=a("span"),b(ws.$$.fragment),a_=c(),kl=a("span"),r_=n("Resources"),zp=c(),fi=a("p"),i_=n("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with T5. If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Ep=c(),b($s.$$.fragment),qp=c(),Wo=a("ul"),xs=a("li"),d_=n("A notebook for how to "),zs=a("a"),l_=n("finetune T5 for classification and multiple choice"),c_=n("."),p_=c(),Es=a("li"),h_=n("A notebook for how to "),qs=a("a"),u_=n("finetune T5 for sentiment span extraction"),m_=n(". \u{1F30E}"),Fp=c(),b(Fs.$$.fragment),jp=c(),_i=a("ul"),js=a("li"),f_=n("A notebook for how to "),Ms=a("a"),__=n("finetune T5 for named entity recognition"),g_=n(". \u{1F30E}"),Mp=c(),b(Cs.$$.fragment),Cp=c(),gi=a("ul"),As=a("li"),T_=n("A notebook for "),Ps=a("a"),k_=n("Finetuning CodeT5 for generating docstrings from Ruby code"),b_=n("."),Ap=c(),b(Os.$$.fragment),Pp=c(),re=a("ul"),Ls=a("li"),v_=n("A notebook to "),Ns=a("a"),y_=n("Finetune T5-base-dutch to perform Dutch abstractive summarization on a TPU"),w_=n("."),$_=c(),Is=a("li"),x_=n("A notebook for how to "),Ds=a("a"),z_=n("finetune T5 for summarization in PyTorch and track experiments with WandB"),E_=n(". \u{1F30E}"),q_=c(),Ss=a("li"),F_=n("A blog post on "),Gs=a("a"),j_=n("Distributed Training: Train BART/T5 for Summarization using \u{1F917} Transformers and Amazon SageMaker"),M_=n("."),C_=c(),Rt=a("li"),Ti=a("a"),A_=n("T5ForConditionalGeneration"),P_=n(" is supported by this "),Bs=a("a"),O_=n("example script"),L_=n(" and "),Us=a("a"),N_=n("notebook"),I_=n("."),D_=c(),Ht=a("li"),ki=a("a"),S_=n("TFT5ForConditionalGeneration"),G_=n(" is supported by this "),Ws=a("a"),B_=n("example script"),U_=n(" and "),Rs=a("a"),W_=n("notebook"),R_=n("."),H_=c(),Ro=a("li"),bi=a("a"),K_=n("FlaxT5ForConditionalGeneration"),V_=n(" is supported by this "),Hs=a("a"),Y_=n("example script"),Z_=n("."),J_=c(),vi=a("li"),Ks=a("a"),X_=n("Summarization"),Q_=n(" chapter of the \u{1F917} Hugging Face course."),eg=c(),bl=a("li"),yi=a("a"),tg=n("Summarization task guide"),Op=c(),b(Vs.$$.fragment),Lp=c(),wi=a("ul"),$t=a("li"),$i=a("a"),og=n("FlaxT5ForConditionalGeneration"),ng=n(" is supported by this "),Ys=a("a"),sg=n("example script"),ag=n(" for training T5 with a span-masked language model objective. The script also shows how to train a T5 tokenizer. "),xi=a("a"),rg=n("FlaxT5ForConditionalGeneration"),ig=n(" is also supported by this "),Zs=a("a"),dg=n("notebook"),lg=n("."),Np=c(),b(Js.$$.fragment),Ip=c(),Kt=a("ul"),Vt=a("li"),zi=a("a"),cg=n("T5ForConditionalGeneration"),pg=n(" is supported by this "),Xs=a("a"),hg=n("example script"),ug=n(" and "),Qs=a("a"),mg=n("notebook"),fg=n("."),_g=c(),Yt=a("li"),Ei=a("a"),gg=n("TFT5ForConditionalGeneration"),Tg=n(" is supported by this "),ea=a("a"),kg=n("example script"),bg=n(" and "),ta=a("a"),vg=n("notebook"),yg=n("."),wg=c(),vl=a("li"),qi=a("a"),$g=n("Translation task guide"),Dp=c(),b(oa.$$.fragment),Sp=c(),Ho=a("ul"),na=a("li"),xg=n("A notebook on how to "),sa=a("a"),zg=n("finetune T5 for question answering with TensorFlow 2"),Eg=n(". \u{1F30E}"),qg=c(),aa=a("li"),Fg=n("A notebook on how to "),ra=a("a"),jg=n("finetune T5 for question answering on a TPU"),Mg=n("."),Gp=c(),ia=a("p"),Cg=n("\u{1F680} "),yl=a("strong"),Ag=n("Deploy"),Bp=c(),Fi=a("ul"),da=a("li"),Pg=n("A blog post on how to deploy "),la=a("a"),Og=n("T5 11B for inference for less than $500"),Lg=n("."),Up=c(),ro=a("h2"),Ko=a("a"),wl=a("span"),b(ca.$$.fragment),Ng=c(),$l=a("span"),Ig=n("T5Config"),Wp=c(),Dt=a("div"),b(pa.$$.fragment),Dg=c(),St=a("p"),Sg=n("This is the configuration class to store the configuration of a "),ji=a("a"),Gg=n("T5Model"),Bg=n(" or a "),Mi=a("a"),Ug=n("TFT5Model"),Wg=n(`. It is used to
instantiate a T5 model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the T5
`),ha=a("a"),Rg=n("t5-small"),Hg=n(" architecture."),Kg=c(),io=a("p"),Vg=n("Configuration objects inherit from "),Ci=a("a"),Yg=n("PretrainedConfig"),Zg=n(` and can be used to control the model outputs. Read the
documentation from `),Ai=a("a"),Jg=n("PretrainedConfig"),Xg=n(" for more information."),Rp=c(),lo=a("h2"),Vo=a("a"),xl=a("span"),b(ua.$$.fragment),Qg=c(),zl=a("span"),eT=n("T5Tokenizer"),Hp=c(),le=a("div"),b(ma.$$.fragment),tT=c(),fa=a("p"),oT=n("Construct a T5 tokenizer. Based on "),_a=a("a"),nT=n("SentencePiece"),sT=n("."),aT=c(),ga=a("p"),rT=n("This tokenizer inherits from "),Pi=a("a"),iT=n("PreTrainedTokenizer"),dT=n(` which contains most of the main methods. Users should refer to
this superclass for more information regarding those methods.`),lT=c(),Zt=a("div"),b(Ta.$$.fragment),cT=c(),El=a("p"),pT=n(`Build model inputs from a sequence or a pair of sequence for sequence classification tasks by concatenating and
adding special tokens. A sequence has the following format:`),hT=c(),ka=a("ul"),Oi=a("li"),uT=n("single sequence: "),ql=a("code"),mT=n("X </s>"),fT=c(),Li=a("li"),_T=n("pair of sequences: "),Fl=a("code"),gT=n("A </s> B </s>"),TT=c(),Yo=a("div"),b(ba.$$.fragment),kT=c(),va=a("p"),bT=n(`Retrieve sequence ids from a token list that has no special tokens added. This method is called when adding
special tokens using the tokenizer `),jl=a("code"),vT=n("prepare_for_model"),yT=n(" method."),wT=c(),Zo=a("div"),b(ya.$$.fragment),$T=c(),Ml=a("p"),xT=n(`Create a mask from the two sequences passed to be used in a sequence-pair classification task. T5 does not make
use of token type ids, therefore a list of zeros is returned.`),zT=c(),Ni=a("div"),b(wa.$$.fragment),Kp=c(),co=a("h2"),Jo=a("a"),Cl=a("span"),b($a.$$.fragment),ET=c(),Al=a("span"),qT=n("T5TokenizerFast"),Vp=c(),Xe=a("div"),b(xa.$$.fragment),FT=c(),po=a("p"),jT=n("Construct a \u201Cfast\u201D T5 tokenizer (backed by HuggingFace\u2019s "),Pl=a("em"),MT=n("tokenizers"),CT=n(` library). Based on
`),za=a("a"),AT=n("Unigram"),PT=n("."),OT=c(),Ea=a("p"),LT=n("This tokenizer inherits from "),Ii=a("a"),NT=n("PreTrainedTokenizerFast"),IT=n(` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),DT=c(),Jt=a("div"),b(qa.$$.fragment),ST=c(),Ol=a("p"),GT=n(`Build model inputs from a sequence or a pair of sequence for sequence classification tasks by concatenating and
adding special tokens. A sequence has the following format:`),BT=c(),Fa=a("ul"),Di=a("li"),UT=n("single sequence: "),Ll=a("code"),WT=n("X </s>"),RT=c(),Si=a("li"),HT=n("pair of sequences: "),Nl=a("code"),KT=n("A </s> B </s>"),VT=c(),Xo=a("div"),b(ja.$$.fragment),YT=c(),Il=a("p"),ZT=n(`Create a mask from the two sequences passed to be used in a sequence-pair classification task. T5 does not make
use of token type ids, therefore a list of zeros is returned.`),Yp=c(),ho=a("h2"),Qo=a("a"),Dl=a("span"),b(Ma.$$.fragment),JT=c(),Sl=a("span"),XT=n("T5Model"),Zp=c(),Ee=a("div"),b(Ca.$$.fragment),QT=c(),Gl=a("p"),ek=n("The bare T5 Model transformer outputting raw hidden-states without any specific head on top."),tk=c(),Aa=a("p"),ok=n("The T5 model was proposed in "),Pa=a("a"),nk=n(`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),sk=n(` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),ak=c(),Oa=a("p"),rk=n("This model inherits from "),Gi=a("a"),ik=n("PreTrainedModel"),dk=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),lk=c(),La=a("p"),ck=n("This model is also a PyTorch "),Na=a("a"),pk=n("torch.nn.Module"),hk=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),uk=c(),xt=a("div"),b(Ia.$$.fragment),mk=c(),uo=a("p"),fk=n("The "),Bi=a("a"),_k=n("T5Model"),gk=n(" forward method, overrides the "),Bl=a("code"),Tk=n("__call__"),kk=n(" special method."),bk=c(),b(en.$$.fragment),vk=c(),b(tn.$$.fragment),Jp=c(),mo=a("h2"),on=a("a"),Ul=a("span"),b(Da.$$.fragment),yk=c(),Wl=a("span"),wk=n("T5ForConditionalGeneration"),Xp=c(),qe=a("div"),b(Sa.$$.fragment),$k=c(),Ga=a("p"),xk=n("T5 Model with a "),Rl=a("code"),zk=n("language modeling"),Ek=n(" head on top."),qk=c(),Ba=a("p"),Fk=n("The T5 model was proposed in "),Ua=a("a"),jk=n(`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),Mk=n(` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),Ck=c(),Wa=a("p"),Ak=n("This model inherits from "),Ui=a("a"),Pk=n("PreTrainedModel"),Ok=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Lk=c(),Ra=a("p"),Nk=n("This model is also a PyTorch "),Ha=a("a"),Ik=n("torch.nn.Module"),Dk=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Sk=c(),zt=a("div"),b(Ka.$$.fragment),Gk=c(),fo=a("p"),Bk=n("The "),Wi=a("a"),Uk=n("T5ForConditionalGeneration"),Wk=n(" forward method, overrides the "),Hl=a("code"),Rk=n("__call__"),Hk=n(" special method."),Kk=c(),b(nn.$$.fragment),Vk=c(),b(sn.$$.fragment),Qp=c(),_o=a("h2"),an=a("a"),Kl=a("span"),b(Va.$$.fragment),Yk=c(),Vl=a("span"),Zk=n("T5EncoderModel"),eh=c(),Fe=a("div"),b(Ya.$$.fragment),Jk=c(),Yl=a("p"),Xk=n("The bare T5 Model transformer outputting encoder\u2019s raw hidden-states without any specific head on top."),Qk=c(),Za=a("p"),eb=n("The T5 model was proposed in "),Ja=a("a"),tb=n(`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),ob=n(` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),nb=c(),Xa=a("p"),sb=n("This model inherits from "),Ri=a("a"),ab=n("PreTrainedModel"),rb=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ib=c(),Qa=a("p"),db=n("This model is also a PyTorch "),er=a("a"),lb=n("torch.nn.Module"),cb=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),pb=c(),Et=a("div"),b(tr.$$.fragment),hb=c(),go=a("p"),ub=n("The "),Hi=a("a"),mb=n("T5EncoderModel"),fb=n(" forward method, overrides the "),Zl=a("code"),_b=n("__call__"),gb=n(" special method."),Tb=c(),b(rn.$$.fragment),kb=c(),b(dn.$$.fragment),th=c(),To=a("h2"),ln=a("a"),Jl=a("span"),b(or.$$.fragment),bb=c(),Xl=a("span"),vb=n("TFT5Model"),oh=c(),ce=a("div"),b(nr.$$.fragment),yb=c(),Ql=a("p"),wb=n("The bare T5 Model transformer outputting raw hidden-stateswithout any specific head on top."),$b=c(),sr=a("p"),xb=n("The T5 model was proposed in "),ar=a("a"),zb=n(`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),Eb=n(` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),qb=c(),rr=a("p"),Fb=n("This model inherits from "),Ki=a("a"),jb=n("TFPreTrainedModel"),Mb=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Cb=c(),ir=a("p"),Ab=n("This model is also a "),dr=a("a"),Pb=n("tf.keras.Model"),Ob=n(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Lb=c(),b(cn.$$.fragment),Nb=c(),qt=a("div"),b(lr.$$.fragment),Ib=c(),ko=a("p"),Db=n("The "),Vi=a("a"),Sb=n("TFT5Model"),Gb=n(" forward method, overrides the "),ec=a("code"),Bb=n("__call__"),Ub=n(" special method."),Wb=c(),b(pn.$$.fragment),Rb=c(),b(hn.$$.fragment),nh=c(),bo=a("h2"),un=a("a"),tc=a("span"),b(cr.$$.fragment),Hb=c(),oc=a("span"),Kb=n("TFT5ForConditionalGeneration"),sh=c(),pe=a("div"),b(pr.$$.fragment),Vb=c(),hr=a("p"),Yb=n("T5 Model with a "),nc=a("code"),Zb=n("language modeling"),Jb=n(" head on top."),Xb=c(),ur=a("p"),Qb=n("The T5 model was proposed in "),mr=a("a"),ev=n(`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),tv=n(` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),ov=c(),fr=a("p"),nv=n("This model inherits from "),Yi=a("a"),sv=n("TFPreTrainedModel"),av=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),rv=c(),_r=a("p"),iv=n("This model is also a "),gr=a("a"),dv=n("tf.keras.Model"),lv=n(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),cv=c(),b(mn.$$.fragment),pv=c(),Ft=a("div"),b(Tr.$$.fragment),hv=c(),vo=a("p"),uv=n("The "),Zi=a("a"),mv=n("TFT5ForConditionalGeneration"),fv=n(" forward method, overrides the "),sc=a("code"),_v=n("__call__"),gv=n(" special method."),Tv=c(),b(fn.$$.fragment),kv=c(),b(_n.$$.fragment),ah=c(),yo=a("h2"),gn=a("a"),ac=a("span"),b(kr.$$.fragment),bv=c(),rc=a("span"),vv=n("TFT5EncoderModel"),rh=c(),he=a("div"),b(br.$$.fragment),yv=c(),ic=a("p"),wv=n("The bare T5 Model transformer outputting encoder\u2019s raw hidden-stateswithout any specific head on top."),$v=c(),vr=a("p"),xv=n("The T5 model was proposed in "),yr=a("a"),zv=n(`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),Ev=n(` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),qv=c(),wr=a("p"),Fv=n("This model inherits from "),Ji=a("a"),jv=n("TFPreTrainedModel"),Mv=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Cv=c(),$r=a("p"),Av=n("This model is also a "),xr=a("a"),Pv=n("tf.keras.Model"),Ov=n(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Lv=c(),b(Tn.$$.fragment),Nv=c(),jt=a("div"),b(zr.$$.fragment),Iv=c(),wo=a("p"),Dv=n("The "),Xi=a("a"),Sv=n("TFT5EncoderModel"),Gv=n(" forward method, overrides the "),dc=a("code"),Bv=n("__call__"),Uv=n(" special method."),Wv=c(),b(kn.$$.fragment),Rv=c(),b(bn.$$.fragment),ih=c(),$o=a("h2"),vn=a("a"),lc=a("span"),b(Er.$$.fragment),Hv=c(),cc=a("span"),Kv=n("FlaxT5Model"),dh=c(),ht=a("div"),b(qr.$$.fragment),Vv=c(),Mt=a("div"),b(Fr.$$.fragment),Yv=c(),xo=a("p"),Zv=n("The "),pc=a("code"),Jv=n("FlaxT5PreTrainedModel"),Xv=n(" forward method, overrides the "),hc=a("code"),Qv=n("__call__"),ey=n(" special method."),ty=c(),b(yn.$$.fragment),oy=c(),b(wn.$$.fragment),ny=c(),$n=a("div"),b(jr.$$.fragment),sy=c(),b(xn.$$.fragment),ay=c(),zn=a("div"),b(Mr.$$.fragment),ry=c(),b(En.$$.fragment),lh=c(),zo=a("h2"),qn=a("a"),uc=a("span"),b(Cr.$$.fragment),iy=c(),mc=a("span"),dy=n("FlaxT5ForConditionalGeneration"),ch=c(),ut=a("div"),b(Ar.$$.fragment),ly=c(),Ct=a("div"),b(Pr.$$.fragment),cy=c(),Eo=a("p"),py=n("The "),fc=a("code"),hy=n("FlaxT5PreTrainedModel"),uy=n(" forward method, overrides the "),_c=a("code"),my=n("__call__"),fy=n(" special method."),_y=c(),b(Fn.$$.fragment),gy=c(),b(jn.$$.fragment),Ty=c(),Mn=a("div"),b(Or.$$.fragment),ky=c(),b(Cn.$$.fragment),by=c(),An=a("div"),b(Lr.$$.fragment),vy=c(),b(Pn.$$.fragment),ph=c(),qo=a("h2"),On=a("a"),gc=a("span"),b(Nr.$$.fragment),yy=c(),Tc=a("span"),wy=n("FlaxT5EncoderModel"),hh=c(),Fo=a("div"),b(Ir.$$.fragment),$y=c(),Xt=a("div"),b(Dr.$$.fragment),xy=c(),jo=a("p"),zy=n("The "),Qi=a("a"),Ey=n("FlaxT5EncoderModel"),qy=n(" forward method, overrides the "),kc=a("code"),Fy=n("__call__"),jy=n(" special method."),My=c(),b(Ln.$$.fragment),this.h()},l(t){const h=d$('[data-svelte="svelte-1phssyn"]',document.head);m=r(h,"META",{name:!0,content:!0}),h.forEach(o),k=p(t),g=r(t,"H1",{class:!0});var Sr=i(g);_=r(Sr,"A",{id:!0,class:!0,href:!0});var bc=i(_);T=r(bc,"SPAN",{});var vc=i(T);v(d.$$.fragment,vc),vc.forEach(o),bc.forEach(o),f=p(Sr),F=r(Sr,"SPAN",{});var yc=i(F);Le=s(yc,"T5"),yc.forEach(o),Sr.forEach(o),je=p(t),I=r(t,"DIV",{class:!0});var Gr=i(I);ue=r(Gr,"A",{href:!0});var wc=i(ue);J=r(wc,"IMG",{alt:!0,src:!0}),wc.forEach(o),Ne=p(Gr),B=r(Gr,"A",{href:!0});var $c=i(B);me=r($c,"IMG",{alt:!0,src:!0}),$c.forEach(o),Gr.forEach(o),Y=p(t),X=r(t,"H2",{class:!0});var Br=i(X);ne=r(Br,"A",{id:!0,class:!0,href:!0});var xc=i(ne);R=r(xc,"SPAN",{});var zc=i(R);v(ie.$$.fragment,zc),zc.forEach(o),xc.forEach(o),Ie=p(Br),H=r(Br,"SPAN",{});var Ec=i(H);De=s(Ec,"Overview"),Ec.forEach(o),Br.forEach(o),Me=p(t),S=r(t,"P",{});var Ur=i(S);Se=s(Ur,"The T5 model was presented in "),de=r(Ur,"A",{href:!0,rel:!0});var qc=i(de);fe=s(qc,"Exploring the Limits of Transfer Learning with a Unified Text-to-Text Transformer"),qc.forEach(o),C=s(Ur,` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan Narang,
Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu.`),Ur.forEach(o),P=p(t),_e=r(t,"P",{});var Fc=i(_e);Q=s(Fc,"The abstract from the paper is the following:"),Fc.forEach(o),Ce=p(t),ge=r(t,"P",{});var jc=i(ge);K=r(jc,"EM",{});var Mc=i(K);Ge=s(Mc,`Transfer learning, where a model is first pre-trained on a data-rich task before being fine-tuned on a downstream
task, has emerged as a powerful technique in natural language processing (NLP). The effectiveness of transfer learning
has given rise to a diversity of approaches, methodology, and practice. In this paper, we explore the landscape of
transfer learning techniques for NLP by introducing a unified framework that converts every language problem into a
text-to-text format. Our systematic study compares pretraining objectives, architectures, unlabeled datasets, transfer
approaches, and other factors on dozens of language understanding tasks. By combining the insights from our exploration
with scale and our new \u201CColossal Clean Crawled Corpus\u201D, we achieve state-of-the-art results on many benchmarks covering
summarization, question answering, text classification, and more. To facilitate future work on transfer learning for
NLP, we release our dataset, pre-trained models, and code.`),Mc.forEach(o),jc.forEach(o),Ae=p(t),A=r(t,"P",{});var Cc=i(A);Be=s(Cc,"Tips:"),Cc.forEach(o),Z=p(t),G=r(t,"UL",{});var mt=i(G);$e=r(mt,"LI",{});var Ac=i($e);D=r(Ac,"P",{});var Mo=i(D);Ue=s(Mo,`T5 is an encoder-decoder model pre-trained on a multi-task mixture of unsupervised and supervised tasks and for which
each task is converted into a text-to-text format. T5 works well on a variety of tasks out-of-the-box by prepending a
different prefix to the input corresponding to each task, e.g., for translation: `),xe=r(Mo,"EM",{});var Pc=i(xe);U=s(Pc,"translate English to German: \u2026"),Pc.forEach(o),We=s(Mo,`,
for summarization: `),V=r(Mo,"EM",{});var Oc=i(V);Re=s(Oc,"summarize: \u2026"),Oc.forEach(o),Te=s(Mo,"."),Mo.forEach(o),Ac.forEach(o),L=p(mt),ze=r(mt,"LI",{});var Lc=i(ze);N=r(Lc,"P",{});var Nc=i(N);He=s(Nc,"The pretraining includes both supervised and self-supervised training. Supervised training is conducted on downstream tasks provided by the GLUE and SuperGLUE benchmarks (converting them into text-to-text tasks as explained above)."),Nc.forEach(o),Lc.forEach(o),Ke=p(mt),z=r(mt,"LI",{});var Dy=i(z);j=r(Dy,"P",{});var Sy=i(j);ft=s(Sy,"Self-supervised training uses corrupted tokens, by randomly removing 15% of the tokens and replacing them with individual sentinel tokens (if several consecutive tokens are marked for removal, the whole group is replaced with a single sentinel token). The input of the encoder is the corrupted sentence, the input of the decoder is the original sentence and the target is then the dropped out tokens delimited by their sentinel tokens."),Sy.forEach(o),Dy.forEach(o),ke=p(mt),et=r(mt,"LI",{});var Gy=i(et);tt=r(Gy,"P",{});var By=i(tt);M=s(By,"T5 uses relative scalar embeddings. Encoder input padding can be done on the left and on the right."),By.forEach(o),Gy.forEach(o),_t=p(mt),ot=r(mt,"LI",{});var Uy=i(ot);se=r(Uy,"P",{});var Nn=i(se);gt=s(Nn,"See the "),Ve=r(Nn,"A",{href:!0});var Wy=i(Ve);W=s(Wy,"training"),Wy.forEach(o),ee=s(Nn,", "),Ye=r(Nn,"A",{href:!0});var Ry=i(Ye);Tt=s(Ry,"inference"),Ry.forEach(o),te=s(Nn," and "),Ze=r(Nn,"A",{href:!0});var Hy=i(Ze);kt=s(Hy,"scripts"),Hy.forEach(o),Je=s(Nn," sections below for all details regarding usage."),Nn.forEach(o),Uy.forEach(o),mt.forEach(o),pt=p(t),oe=r(t,"P",{});var Ky=i(oe);bt=s(Ky,"T5 comes in different sizes:"),Ky.forEach(o),Bc=p(t),nt=r(t,"UL",{});var Qt=i(nt);bd=r(Qt,"LI",{});var Vy=i(bd);vd=r(Vy,"P",{});var Yy=i(vd);Xn=r(Yy,"A",{href:!0,rel:!0});var Zy=i(Xn);Eu=s(Zy,"t5-small"),Zy.forEach(o),Yy.forEach(o),Vy.forEach(o),qu=p(Qt),yd=r(Qt,"LI",{});var Jy=i(yd);wd=r(Jy,"P",{});var Xy=i(wd);Qn=r(Xy,"A",{href:!0,rel:!0});var Qy=i(Qn);Fu=s(Qy,"t5-base"),Qy.forEach(o),Xy.forEach(o),Jy.forEach(o),ju=p(Qt),$d=r(Qt,"LI",{});var ew=i($d);xd=r(ew,"P",{});var tw=i(xd);es=r(tw,"A",{href:!0,rel:!0});var ow=i(es);Mu=s(ow,"t5-large"),ow.forEach(o),tw.forEach(o),ew.forEach(o),Cu=p(Qt),zd=r(Qt,"LI",{});var nw=i(zd);Ed=r(nw,"P",{});var sw=i(Ed);ts=r(sw,"A",{href:!0,rel:!0});var aw=i(ts);Au=s(aw,"t5-3b"),aw.forEach(o),sw.forEach(o),nw.forEach(o),Pu=p(Qt),qd=r(Qt,"LI",{});var rw=i(qd);Yr=r(rw,"P",{});var Cy=i(Yr);os=r(Cy,"A",{href:!0,rel:!0});var iw=i(os);Ou=s(iw,"t5-11b"),iw.forEach(o),Lu=s(Cy,"."),Cy.forEach(o),rw.forEach(o),Qt.forEach(o),Uc=p(t),Zr=r(t,"P",{});var dw=i(Zr);Nu=s(dw,"Based on the original T5 model, Google has released some follow-up works:"),dw.forEach(o),Wc=p(t),Gt=r(t,"UL",{});var ed=i(Gt);Fd=r(ed,"LI",{});var lw=i(Fd);Ao=r(lw,"P",{});var Ic=i(Ao);jd=r(Ic,"STRONG",{});var cw=i(jd);Iu=s(cw,"T5v1.1"),cw.forEach(o),Du=s(Ic,`: T5v1.1 is an improved version of T5 with some architectural tweaks, and is pre-trained on C4 only without
mixing in the supervised tasks. Refer to the documentation of T5v1.1 which can be found `),Jr=r(Ic,"A",{href:!0});var pw=i(Jr);Su=s(pw,"here"),pw.forEach(o),Gu=s(Ic,"."),Ic.forEach(o),lw.forEach(o),Bu=p(ed),Md=r(ed,"LI",{});var hw=i(Md);Po=r(hw,"P",{});var Dc=i(Po);Cd=r(Dc,"STRONG",{});var uw=i(Cd);Uu=s(uw,"mT5"),uw.forEach(o),Wu=s(Dc,`: mT5 is a multilingual T5 model. It is pre-trained on the mC4 corpus, which includes 101 languages. Refer to
the documentation of mT5 which can be found `),Xr=r(Dc,"A",{href:!0});var mw=i(Xr);Ru=s(mw,"here"),mw.forEach(o),Hu=s(Dc,"."),Dc.forEach(o),hw.forEach(o),Ku=p(ed),Ad=r(ed,"LI",{});var fw=i(Ad);Oo=r(fw,"P",{});var Sc=i(Oo);Pd=r(Sc,"STRONG",{});var _w=i(Pd);Vu=s(_w,"byT5"),_w.forEach(o),Yu=s(Sc,`: byT5 is a T5 model pre-trained on byte sequences rather than SentencePiece subword token sequences. Refer
to the documentation of byT5 which can be found `),Qr=r(Sc,"A",{href:!0});var gw=i(Qr);Zu=s(gw,"here"),gw.forEach(o),Ju=s(Sc,"."),Sc.forEach(o),fw.forEach(o),ed.forEach(o),Rc=p(t),Lo=r(t,"P",{});var mh=i(Lo);Xu=s(mh,"All checkpoints can be found on the "),ns=r(mh,"A",{href:!0,rel:!0});var Tw=i(ns);Qu=s(Tw,"hub"),Tw.forEach(o),em=s(mh,"."),mh.forEach(o),Hc=p(t),Bt=r(t,"P",{});var td=i(Bt);tm=s(td,"This model was contributed by "),ss=r(td,"A",{href:!0,rel:!0});var kw=i(ss);om=s(kw,"thomwolf"),kw.forEach(o),nm=s(td,". The original code can be found "),as=r(td,"A",{href:!0,rel:!0});var bw=i(as);sm=s(bw,"here"),bw.forEach(o),am=s(td,"."),td.forEach(o),Kc=p(t),ei=r(t,"A",{id:!0}),i(ei).forEach(o),Vc=p(t),oo=r(t,"H2",{class:!0});var fh=i(oo);No=r(fh,"A",{id:!0,class:!0,href:!0});var vw=i(No);Od=r(vw,"SPAN",{});var yw=i(Od);v(rs.$$.fragment,yw),yw.forEach(o),vw.forEach(o),rm=p(fh),Ld=r(fh,"SPAN",{});var ww=i(Ld);im=s(ww,"Training"),ww.forEach(o),fh.forEach(o),Yc=p(t),vt=r(t,"P",{});var In=i(vt);dm=s(In,`T5 is an encoder-decoder model and converts all NLP problems into a text-to-text format. It is trained using teacher
forcing. This means that for training, we always need an input sequence and a corresponding target sequence. The input
sequence is fed to the model using `),Nd=r(In,"CODE",{});var $w=i(Nd);lm=s($w,"input_ids"),$w.forEach(o),cm=s(In,`. The target sequence is shifted to the right, i.e., prepended by a
start-sequence token and fed to the decoder using the `),Id=r(In,"CODE",{});var xw=i(Id);pm=s(xw,"decoder_input_ids"),xw.forEach(o),hm=s(In,`. In teacher-forcing style, the target
sequence is then appended by the EOS token and corresponds to the `),Dd=r(In,"CODE",{});var zw=i(Dd);um=s(zw,"labels"),zw.forEach(o),mm=s(In,`. The PAD token is hereby used as the
start-sequence token. T5 can be trained / fine-tuned both in a supervised and unsupervised fashion.`),In.forEach(o),Zc=p(t),Io=r(t,"P",{});var _h=i(Io);fm=s(_h,"One can use "),ti=r(_h,"A",{href:!0});var Ew=i(ti);_m=s(Ew,"T5ForConditionalGeneration"),Ew.forEach(o),gm=s(_h,` (or the Tensorflow/Flax variant), which includes the
language modeling head on top of the decoder.`),_h.forEach(o),Jc=p(t),oi=r(t,"UL",{});var qw=i(oi);Sd=r(qw,"LI",{});var Fw=i(Sd);Tm=s(Fw,"Unsupervised denoising training"),Fw.forEach(o),qw.forEach(o),Xc=p(t),be=r(t,"P",{});var at=i(be);km=s(at,"In this setup, spans of the input sequence are masked by so-called sentinel tokens ("),Gd=r(at,"EM",{});var jw=i(Gd);bm=s(jw,"a.k.a"),jw.forEach(o),vm=s(at,` unique mask tokens) and
the output sequence is formed as a concatenation of the same sentinel tokens and the `),Bd=r(at,"EM",{});var Mw=i(Bd);ym=s(Mw,"real"),Mw.forEach(o),wm=s(at,` masked tokens. Each
sentinel token represents a unique mask token for this sentence and should start with `),Ud=r(at,"CODE",{});var Cw=i(Ud);$m=s(Cw,"<extra_id_0>"),Cw.forEach(o),xm=s(at,`,
`),Wd=r(at,"CODE",{});var Aw=i(Wd);zm=s(Aw,"<extra_id_1>"),Aw.forEach(o),Em=s(at,", \u2026 up to "),Rd=r(at,"CODE",{});var Pw=i(Rd);qm=s(Pw,"<extra_id_99>"),Pw.forEach(o),Fm=s(at,`. As a default, 100 sentinel tokens are available in
`),ni=r(at,"A",{href:!0});var Ow=i(ni);jm=s(Ow,"T5Tokenizer"),Ow.forEach(o),Mm=s(at,"."),at.forEach(o),Qc=p(t),si=r(t,"P",{});var Lw=i(si);Cm=s(Lw,`For instance, the sentence \u201CThe cute dog walks in the park\u201D with the masks put on \u201Ccute dog\u201D and \u201Cthe\u201D should be
processed as follows:`),Lw.forEach(o),ep=p(t),v(is.$$.fragment,t),tp=p(t),Do=r(t,"P",{});var gh=i(Do);Am=s(gh,"If you\u2019re interested in pre-training T5 on a new corpus, check out the "),ds=r(gh,"A",{href:!0,rel:!0});var Nw=i(ds);Pm=s(Nw,"run_t5_mlm_flax.py"),Nw.forEach(o),Om=s(gh,` script in the Examples
directory.`),gh.forEach(o),op=p(t),ai=r(t,"UL",{});var Iw=i(ai);Hd=r(Iw,"LI",{});var Dw=i(Hd);Lm=s(Dw,"Supervised training"),Dw.forEach(o),Iw.forEach(o),np=p(t),ri=r(t,"P",{});var Sw=i(ri);Nm=s(Sw,`In this setup, the input sequence and output sequence are a standard sequence-to-sequence input-output mapping.
Suppose that we want to fine-tune the model for translation for example, and we have a training example: the input
sequence \u201CThe house is wonderful.\u201D and output sequence \u201CDas Haus ist wunderbar.\u201D, then they should be prepared for
the model as follows:`),Sw.forEach(o),sp=p(t),v(ls.$$.fragment,t),ap=p(t),ae=r(t,"P",{});var Pe=i(ae);Im=s(Pe,"As you can see, only 2 inputs are required for the model in order to compute a loss: "),Kd=r(Pe,"CODE",{});var Gw=i(Kd);Dm=s(Gw,"input_ids"),Gw.forEach(o),Sm=s(Pe,` (which are the
`),Vd=r(Pe,"CODE",{});var Bw=i(Vd);Gm=s(Bw,"input_ids"),Bw.forEach(o),Bm=s(Pe," of the encoded input sequence) and "),Yd=r(Pe,"CODE",{});var Uw=i(Yd);Um=s(Uw,"labels"),Uw.forEach(o),Wm=s(Pe," (which are the "),Zd=r(Pe,"CODE",{});var Ww=i(Zd);Rm=s(Ww,"input_ids"),Ww.forEach(o),Hm=s(Pe,` of the encoded
target sequence). The model will automatically create the `),Jd=r(Pe,"CODE",{});var Rw=i(Jd);Km=s(Rw,"decoder_input_ids"),Rw.forEach(o),Vm=s(Pe," based on the "),Xd=r(Pe,"CODE",{});var Hw=i(Xd);Ym=s(Hw,"labels"),Hw.forEach(o),Zm=s(Pe,`, by
shifting them one position to the right and prepending the `),Qd=r(Pe,"CODE",{});var Kw=i(Qd);Jm=s(Kw,"config.decoder_start_token_id"),Kw.forEach(o),Xm=s(Pe,`, which for T5 is
equal to 0 (i.e. the id of the pad token). Also note the task prefix: we prepend the input sequence with \u2018translate
English to German: \u2019 before encoding it. This will help in improving the performance, as this task prefix was used
during T5\u2019s pre-training.`),Pe.forEach(o),rp=p(t),Ut=r(t,"P",{});var od=i(Ut);Qm=s(od,`However, the example above only shows a single training example. In practice, one trains deep learning models in
batches. This entails that we must pad/truncate examples to the same length. For encoder-decoder models, one
typically defines a `),el=r(od,"CODE",{});var Vw=i(el);ef=s(Vw,"max_source_length"),Vw.forEach(o),tf=s(od," and "),tl=r(od,"CODE",{});var Yw=i(tl);of=s(Yw,"max_target_length"),Yw.forEach(o),nf=s(od,`, which determine the maximum length of the
input and output sequences respectively (otherwise they are truncated). These should be carefully set depending on
the task.`),od.forEach(o),ip=p(t),ve=r(t,"P",{});var rt=i(ve);sf=s(rt,"In addition, we must make sure that padding token id\u2019s of the "),ol=r(rt,"CODE",{});var Zw=i(ol);af=s(Zw,"labels"),Zw.forEach(o),rf=s(rt,` are not taken into account by the loss
function. In PyTorch and Tensorflow, this can be done by replacing them with -100, which is the `),nl=r(rt,"CODE",{});var Jw=i(nl);df=s(Jw,"ignore_index"),Jw.forEach(o),lf=s(rt,`
of the `),sl=r(rt,"CODE",{});var Xw=i(sl);cf=s(Xw,"CrossEntropyLoss"),Xw.forEach(o),pf=s(rt,". In Flax, one can use the "),al=r(rt,"CODE",{});var Qw=i(al);hf=s(Qw,"decoder_attention_mask"),Qw.forEach(o),uf=s(rt,` to ignore padded tokens from
the loss (see the `),cs=r(rt,"A",{href:!0,rel:!0});var e5=i(cs);mf=s(e5,"Flax summarization script"),e5.forEach(o),ff=s(rt,` for details). We also pass
`),rl=r(rt,"CODE",{});var t5=i(rl);_f=s(t5,"attention_mask"),t5.forEach(o),gf=s(rt,` as additional input to the model, which makes sure that padding tokens of the inputs are
ignored. The code example below illustrates all of this.`),rt.forEach(o),dp=p(t),v(ps.$$.fragment,t),lp=p(t),ii=r(t,"P",{});var o5=i(ii);Tf=s(o5,"Additional training tips:"),o5.forEach(o),cp=p(t),di=r(t,"UL",{});var n5=i(di);hs=r(n5,"LI",{});var Th=i(hs);kf=s(Th,"T5 models need a slightly higher learning rate than the default one set in the "),il=r(Th,"CODE",{});var s5=i(il);bf=s(s5,"Trainer"),s5.forEach(o),vf=s(Th,` when using the AdamW
optimizer. Typically, 1e-4 and 3e-4 work well for most problems (classification, summarization, translation, question
answering, question generation). Note that T5 was pre-trained using the AdaFactor optimizer.`),Th.forEach(o),n5.forEach(o),pp=p(t),Wt=r(t,"P",{});var nd=i(Wt);yf=s(nd,"According to "),us=r(nd,"A",{href:!0,rel:!0});var a5=i(us);wf=s(a5,"this forum post"),a5.forEach(o),$f=s(nd,`, task prefixes matter when
(1) doing multi-task training (2) your task is similar or related to one of the supervised tasks used in T5\u2019s
pre-training mixture (see Appendix D of the `),ms=r(nd,"A",{href:!0,rel:!0});var r5=i(ms);xf=s(r5,"paper"),r5.forEach(o),zf=s(nd,` for the task prefixes
used).`),nd.forEach(o),hp=p(t),So=r(t,"P",{});var kh=i(So);Ef=s(kh,`If training on TPU, it is recommended to pad all examples of the dataset to the same length or make use of
`),dl=r(kh,"EM",{});var i5=i(dl);qf=s(i5,"pad_to_multiple_of"),i5.forEach(o),Ff=s(kh,` to have a small number of predefined bucket sizes to fit all examples in. Dynamically padding
batches to the longest example is not recommended on TPU as it triggers a recompilation for every batch shape that is
encountered during training thus significantly slowing down the training. only padding up to the longest example in a
batch) leads to very slow training on TPU.`),kh.forEach(o),up=p(t),li=r(t,"A",{id:!0}),i(li).forEach(o),mp=p(t),no=r(t,"H2",{class:!0});var bh=i(no);Go=r(bh,"A",{id:!0,class:!0,href:!0});var d5=i(Go);ll=r(d5,"SPAN",{});var l5=i(ll);v(fs.$$.fragment,l5),l5.forEach(o),d5.forEach(o),jf=p(bh),cl=r(bh,"SPAN",{});var c5=i(cl);Mf=s(c5,"Inference"),c5.forEach(o),bh.forEach(o),fp=p(t),yt=r(t,"P",{});var Dn=i(yt);Cf=s(Dn,"At inference time, it is recommended to use "),ci=r(Dn,"A",{href:!0});var p5=i(ci);Af=s(p5,"generate()"),p5.forEach(o),Pf=s(Dn,`. This
method takes care of encoding the input and feeding the encoded hidden states via cross-attention layers to the decoder
and auto-regressively generates the decoder output. Check out `),_s=r(Dn,"A",{href:!0,rel:!0});var h5=i(_s);Of=s(h5,"this blog post"),h5.forEach(o),Lf=s(Dn,` to know all the details about generating text with Transformers.
There\u2019s also `),gs=r(Dn,"A",{href:!0,rel:!0});var u5=i(gs);Nf=s(u5,"this blog post"),u5.forEach(o),If=s(Dn,` which explains how
generation works in general in encoder-decoder models.`),Dn.forEach(o),_p=p(t),v(Ts.$$.fragment,t),gp=p(t),st=r(t,"P",{});var eo=i(st);Df=s(eo,"Note that T5 uses the "),pl=r(eo,"CODE",{});var m5=i(pl);Sf=s(m5,"pad_token_id"),m5.forEach(o),Gf=s(eo," as the "),hl=r(eo,"CODE",{});var f5=i(hl);Bf=s(f5,"decoder_start_token_id"),f5.forEach(o),Uf=s(eo,`, so when doing generation without using
`),pi=r(eo,"A",{href:!0});var _5=i(pi);Wf=s(_5,"generate()"),_5.forEach(o),Rf=s(eo,", make sure you start it with the "),ul=r(eo,"CODE",{});var g5=i(ul);Hf=s(g5,"pad_token_id"),g5.forEach(o),Kf=s(eo,"."),eo.forEach(o),Tp=p(t),hi=r(t,"P",{});var T5=i(hi);Vf=s(T5,"The example above only shows a single example. You can also do batched inference, like so:"),T5.forEach(o),kp=p(t),v(ks.$$.fragment,t),bp=p(t),ui=r(t,"P",{});var k5=i(ui);Yf=s(k5,`Because T5 has been trained with the span-mask denoising objective,
it can be used to predict the sentinel (masked-out) tokens during inference.
The predicted tokens will then be placed between the sentinel tokens.`),k5.forEach(o),vp=p(t),v(bs.$$.fragment,t),yp=p(t),mi=r(t,"A",{id:!0}),i(mi).forEach(o),wp=p(t),so=r(t,"H2",{class:!0});var vh=i(so);Bo=r(vh,"A",{id:!0,class:!0,href:!0});var b5=i(Bo);ml=r(b5,"SPAN",{});var v5=i(ml);v(vs.$$.fragment,v5),v5.forEach(o),b5.forEach(o),Zf=p(vh),fl=r(vh,"SPAN",{});var y5=i(fl);Jf=s(y5,"Performance"),y5.forEach(o),vh.forEach(o),$p=p(t),wt=r(t,"P",{});var Sn=i(wt);Xf=s(Sn,"If you\u2019d like a faster training and inference performance, install "),ys=r(Sn,"A",{href:!0,rel:!0});var w5=i(ys);Qf=s(w5,"apex"),w5.forEach(o),e_=s(Sn," and then the model will automatically use "),_l=r(Sn,"CODE",{});var $5=i(_l);t_=s($5,"apex.normalization.FusedRMSNorm"),$5.forEach(o),o_=s(Sn," instead of "),gl=r(Sn,"CODE",{});var x5=i(gl);n_=s(x5,"T5LayerNorm"),x5.forEach(o),s_=s(Sn,". The former uses an optimized fused kernel which is several times faster than the latter."),Sn.forEach(o),xp=p(t),ao=r(t,"H2",{class:!0});var yh=i(ao);Uo=r(yh,"A",{id:!0,class:!0,href:!0});var z5=i(Uo);Tl=r(z5,"SPAN",{});var E5=i(Tl);v(ws.$$.fragment,E5),E5.forEach(o),z5.forEach(o),a_=p(yh),kl=r(yh,"SPAN",{});var q5=i(kl);r_=s(q5,"Resources"),q5.forEach(o),yh.forEach(o),zp=p(t),fi=r(t,"P",{});var F5=i(fi);i_=s(F5,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with T5. If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),F5.forEach(o),Ep=p(t),v($s.$$.fragment,t),qp=p(t),Wo=r(t,"UL",{});var wh=i(Wo);xs=r(wh,"LI",{});var $h=i(xs);d_=s($h,"A notebook for how to "),zs=r($h,"A",{href:!0,rel:!0});var j5=i(zs);l_=s(j5,"finetune T5 for classification and multiple choice"),j5.forEach(o),c_=s($h,"."),$h.forEach(o),p_=p(wh),Es=r(wh,"LI",{});var xh=i(Es);h_=s(xh,"A notebook for how to "),qs=r(xh,"A",{href:!0,rel:!0});var M5=i(qs);u_=s(M5,"finetune T5 for sentiment span extraction"),M5.forEach(o),m_=s(xh,". \u{1F30E}"),xh.forEach(o),wh.forEach(o),Fp=p(t),v(Fs.$$.fragment,t),jp=p(t),_i=r(t,"UL",{});var C5=i(_i);js=r(C5,"LI",{});var zh=i(js);f_=s(zh,"A notebook for how to "),Ms=r(zh,"A",{href:!0,rel:!0});var A5=i(Ms);__=s(A5,"finetune T5 for named entity recognition"),A5.forEach(o),g_=s(zh,". \u{1F30E}"),zh.forEach(o),C5.forEach(o),Mp=p(t),v(Cs.$$.fragment,t),Cp=p(t),gi=r(t,"UL",{});var P5=i(gi);As=r(P5,"LI",{});var Eh=i(As);T_=s(Eh,"A notebook for "),Ps=r(Eh,"A",{href:!0,rel:!0});var O5=i(Ps);k_=s(O5,"Finetuning CodeT5 for generating docstrings from Ruby code"),O5.forEach(o),b_=s(Eh,"."),Eh.forEach(o),P5.forEach(o),Ap=p(t),v(Os.$$.fragment,t),Pp=p(t),re=r(t,"UL",{});var Oe=i(re);Ls=r(Oe,"LI",{});var qh=i(Ls);v_=s(qh,"A notebook to "),Ns=r(qh,"A",{href:!0,rel:!0});var L5=i(Ns);y_=s(L5,"Finetune T5-base-dutch to perform Dutch abstractive summarization on a TPU"),L5.forEach(o),w_=s(qh,"."),qh.forEach(o),$_=p(Oe),Is=r(Oe,"LI",{});var Fh=i(Is);x_=s(Fh,"A notebook for how to "),Ds=r(Fh,"A",{href:!0,rel:!0});var N5=i(Ds);z_=s(N5,"finetune T5 for summarization in PyTorch and track experiments with WandB"),N5.forEach(o),E_=s(Fh,". \u{1F30E}"),Fh.forEach(o),q_=p(Oe),Ss=r(Oe,"LI",{});var jh=i(Ss);F_=s(jh,"A blog post on "),Gs=r(jh,"A",{href:!0,rel:!0});var I5=i(Gs);j_=s(I5,"Distributed Training: Train BART/T5 for Summarization using \u{1F917} Transformers and Amazon SageMaker"),I5.forEach(o),M_=s(jh,"."),jh.forEach(o),C_=p(Oe),Rt=r(Oe,"LI",{});var Wr=i(Rt);Ti=r(Wr,"A",{href:!0});var D5=i(Ti);A_=s(D5,"T5ForConditionalGeneration"),D5.forEach(o),P_=s(Wr," is supported by this "),Bs=r(Wr,"A",{href:!0,rel:!0});var S5=i(Bs);O_=s(S5,"example script"),S5.forEach(o),L_=s(Wr," and "),Us=r(Wr,"A",{href:!0,rel:!0});var G5=i(Us);N_=s(G5,"notebook"),G5.forEach(o),I_=s(Wr,"."),Wr.forEach(o),D_=p(Oe),Ht=r(Oe,"LI",{});var Rr=i(Ht);ki=r(Rr,"A",{href:!0});var B5=i(ki);S_=s(B5,"TFT5ForConditionalGeneration"),B5.forEach(o),G_=s(Rr," is supported by this "),Ws=r(Rr,"A",{href:!0,rel:!0});var U5=i(Ws);B_=s(U5,"example script"),U5.forEach(o),U_=s(Rr," and "),Rs=r(Rr,"A",{href:!0,rel:!0});var W5=i(Rs);W_=s(W5,"notebook"),W5.forEach(o),R_=s(Rr,"."),Rr.forEach(o),H_=p(Oe),Ro=r(Oe,"LI",{});var Gc=i(Ro);bi=r(Gc,"A",{href:!0});var R5=i(bi);K_=s(R5,"FlaxT5ForConditionalGeneration"),R5.forEach(o),V_=s(Gc," is supported by this "),Hs=r(Gc,"A",{href:!0,rel:!0});var H5=i(Hs);Y_=s(H5,"example script"),H5.forEach(o),Z_=s(Gc,"."),Gc.forEach(o),J_=p(Oe),vi=r(Oe,"LI",{});var Ay=i(vi);Ks=r(Ay,"A",{href:!0,rel:!0});var K5=i(Ks);X_=s(K5,"Summarization"),K5.forEach(o),Q_=s(Ay," chapter of the \u{1F917} Hugging Face course."),Ay.forEach(o),eg=p(Oe),bl=r(Oe,"LI",{});var V5=i(bl);yi=r(V5,"A",{href:!0});var Y5=i(yi);tg=s(Y5,"Summarization task guide"),Y5.forEach(o),V5.forEach(o),Oe.forEach(o),Op=p(t),v(Vs.$$.fragment,t),Lp=p(t),wi=r(t,"UL",{});var Z5=i(wi);$t=r(Z5,"LI",{});var Co=i($t);$i=r(Co,"A",{href:!0});var J5=i($i);og=s(J5,"FlaxT5ForConditionalGeneration"),J5.forEach(o),ng=s(Co," is supported by this "),Ys=r(Co,"A",{href:!0,rel:!0});var X5=i(Ys);sg=s(X5,"example script"),X5.forEach(o),ag=s(Co," for training T5 with a span-masked language model objective. The script also shows how to train a T5 tokenizer. "),xi=r(Co,"A",{href:!0});var Q5=i(xi);rg=s(Q5,"FlaxT5ForConditionalGeneration"),Q5.forEach(o),ig=s(Co," is also supported by this "),Zs=r(Co,"A",{href:!0,rel:!0});var e1=i(Zs);dg=s(e1,"notebook"),e1.forEach(o),lg=s(Co,"."),Co.forEach(o),Z5.forEach(o),Np=p(t),v(Js.$$.fragment,t),Ip=p(t),Kt=r(t,"UL",{});var sd=i(Kt);Vt=r(sd,"LI",{});var Hr=i(Vt);zi=r(Hr,"A",{href:!0});var t1=i(zi);cg=s(t1,"T5ForConditionalGeneration"),t1.forEach(o),pg=s(Hr," is supported by this "),Xs=r(Hr,"A",{href:!0,rel:!0});var o1=i(Xs);hg=s(o1,"example script"),o1.forEach(o),ug=s(Hr," and "),Qs=r(Hr,"A",{href:!0,rel:!0});var n1=i(Qs);mg=s(n1,"notebook"),n1.forEach(o),fg=s(Hr,"."),Hr.forEach(o),_g=p(sd),Yt=r(sd,"LI",{});var Kr=i(Yt);Ei=r(Kr,"A",{href:!0});var s1=i(Ei);gg=s(s1,"TFT5ForConditionalGeneration"),s1.forEach(o),Tg=s(Kr," is supported by this "),ea=r(Kr,"A",{href:!0,rel:!0});var a1=i(ea);kg=s(a1,"example script"),a1.forEach(o),bg=s(Kr," and "),ta=r(Kr,"A",{href:!0,rel:!0});var r1=i(ta);vg=s(r1,"notebook"),r1.forEach(o),yg=s(Kr,"."),Kr.forEach(o),wg=p(sd),vl=r(sd,"LI",{});var i1=i(vl);qi=r(i1,"A",{href:!0});var d1=i(qi);$g=s(d1,"Translation task guide"),d1.forEach(o),i1.forEach(o),sd.forEach(o),Dp=p(t),v(oa.$$.fragment,t),Sp=p(t),Ho=r(t,"UL",{});var Mh=i(Ho);na=r(Mh,"LI",{});var Ch=i(na);xg=s(Ch,"A notebook on how to "),sa=r(Ch,"A",{href:!0,rel:!0});var l1=i(sa);zg=s(l1,"finetune T5 for question answering with TensorFlow 2"),l1.forEach(o),Eg=s(Ch,". \u{1F30E}"),Ch.forEach(o),qg=p(Mh),aa=r(Mh,"LI",{});var Ah=i(aa);Fg=s(Ah,"A notebook on how to "),ra=r(Ah,"A",{href:!0,rel:!0});var c1=i(ra);jg=s(c1,"finetune T5 for question answering on a TPU"),c1.forEach(o),Mg=s(Ah,"."),Ah.forEach(o),Mh.forEach(o),Gp=p(t),ia=r(t,"P",{});var Py=i(ia);Cg=s(Py,"\u{1F680} "),yl=r(Py,"STRONG",{});var p1=i(yl);Ag=s(p1,"Deploy"),p1.forEach(o),Py.forEach(o),Bp=p(t),Fi=r(t,"UL",{});var h1=i(Fi);da=r(h1,"LI",{});var Ph=i(da);Pg=s(Ph,"A blog post on how to deploy "),la=r(Ph,"A",{href:!0,rel:!0});var u1=i(la);Og=s(u1,"T5 11B for inference for less than $500"),u1.forEach(o),Lg=s(Ph,"."),Ph.forEach(o),h1.forEach(o),Up=p(t),ro=r(t,"H2",{class:!0});var Oh=i(ro);Ko=r(Oh,"A",{id:!0,class:!0,href:!0});var m1=i(Ko);wl=r(m1,"SPAN",{});var f1=i(wl);v(ca.$$.fragment,f1),f1.forEach(o),m1.forEach(o),Ng=p(Oh),$l=r(Oh,"SPAN",{});var _1=i($l);Ig=s(_1,"T5Config"),_1.forEach(o),Oh.forEach(o),Wp=p(t),Dt=r(t,"DIV",{class:!0});var ad=i(Dt);v(pa.$$.fragment,ad),Dg=p(ad),St=r(ad,"P",{});var Gn=i(St);Sg=s(Gn,"This is the configuration class to store the configuration of a "),ji=r(Gn,"A",{href:!0});var g1=i(ji);Gg=s(g1,"T5Model"),g1.forEach(o),Bg=s(Gn," or a "),Mi=r(Gn,"A",{href:!0});var T1=i(Mi);Ug=s(T1,"TFT5Model"),T1.forEach(o),Wg=s(Gn,`. It is used to
instantiate a T5 model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the T5
`),ha=r(Gn,"A",{href:!0,rel:!0});var k1=i(ha);Rg=s(k1,"t5-small"),k1.forEach(o),Hg=s(Gn," architecture."),Gn.forEach(o),Kg=p(ad),io=r(ad,"P",{});var rd=i(io);Vg=s(rd,"Configuration objects inherit from "),Ci=r(rd,"A",{href:!0});var b1=i(Ci);Yg=s(b1,"PretrainedConfig"),b1.forEach(o),Zg=s(rd,` and can be used to control the model outputs. Read the
documentation from `),Ai=r(rd,"A",{href:!0});var v1=i(Ai);Jg=s(v1,"PretrainedConfig"),v1.forEach(o),Xg=s(rd," for more information."),rd.forEach(o),ad.forEach(o),Rp=p(t),lo=r(t,"H2",{class:!0});var Lh=i(lo);Vo=r(Lh,"A",{id:!0,class:!0,href:!0});var y1=i(Vo);xl=r(y1,"SPAN",{});var w1=i(xl);v(ua.$$.fragment,w1),w1.forEach(o),y1.forEach(o),Qg=p(Lh),zl=r(Lh,"SPAN",{});var $1=i(zl);eT=s($1,"T5Tokenizer"),$1.forEach(o),Lh.forEach(o),Hp=p(t),le=r(t,"DIV",{class:!0});var it=i(le);v(ma.$$.fragment,it),tT=p(it),fa=r(it,"P",{});var Nh=i(fa);oT=s(Nh,"Construct a T5 tokenizer. Based on "),_a=r(Nh,"A",{href:!0,rel:!0});var x1=i(_a);nT=s(x1,"SentencePiece"),x1.forEach(o),sT=s(Nh,"."),Nh.forEach(o),aT=p(it),ga=r(it,"P",{});var Ih=i(ga);rT=s(Ih,"This tokenizer inherits from "),Pi=r(Ih,"A",{href:!0});var z1=i(Pi);iT=s(z1,"PreTrainedTokenizer"),z1.forEach(o),dT=s(Ih,` which contains most of the main methods. Users should refer to
this superclass for more information regarding those methods.`),Ih.forEach(o),lT=p(it),Zt=r(it,"DIV",{class:!0});var id=i(Zt);v(Ta.$$.fragment,id),cT=p(id),El=r(id,"P",{});var E1=i(El);pT=s(E1,`Build model inputs from a sequence or a pair of sequence for sequence classification tasks by concatenating and
adding special tokens. A sequence has the following format:`),E1.forEach(o),hT=p(id),ka=r(id,"UL",{});var Dh=i(ka);Oi=r(Dh,"LI",{});var Oy=i(Oi);uT=s(Oy,"single sequence: "),ql=r(Oy,"CODE",{});var q1=i(ql);mT=s(q1,"X </s>"),q1.forEach(o),Oy.forEach(o),fT=p(Dh),Li=r(Dh,"LI",{});var Ly=i(Li);_T=s(Ly,"pair of sequences: "),Fl=r(Ly,"CODE",{});var F1=i(Fl);gT=s(F1,"A </s> B </s>"),F1.forEach(o),Ly.forEach(o),Dh.forEach(o),id.forEach(o),TT=p(it),Yo=r(it,"DIV",{class:!0});var Sh=i(Yo);v(ba.$$.fragment,Sh),kT=p(Sh),va=r(Sh,"P",{});var Gh=i(va);bT=s(Gh,`Retrieve sequence ids from a token list that has no special tokens added. This method is called when adding
special tokens using the tokenizer `),jl=r(Gh,"CODE",{});var j1=i(jl);vT=s(j1,"prepare_for_model"),j1.forEach(o),yT=s(Gh," method."),Gh.forEach(o),Sh.forEach(o),wT=p(it),Zo=r(it,"DIV",{class:!0});var Bh=i(Zo);v(ya.$$.fragment,Bh),$T=p(Bh),Ml=r(Bh,"P",{});var M1=i(Ml);xT=s(M1,`Create a mask from the two sequences passed to be used in a sequence-pair classification task. T5 does not make
use of token type ids, therefore a list of zeros is returned.`),M1.forEach(o),Bh.forEach(o),zT=p(it),Ni=r(it,"DIV",{class:!0});var C1=i(Ni);v(wa.$$.fragment,C1),C1.forEach(o),it.forEach(o),Kp=p(t),co=r(t,"H2",{class:!0});var Uh=i(co);Jo=r(Uh,"A",{id:!0,class:!0,href:!0});var A1=i(Jo);Cl=r(A1,"SPAN",{});var P1=i(Cl);v($a.$$.fragment,P1),P1.forEach(o),A1.forEach(o),ET=p(Uh),Al=r(Uh,"SPAN",{});var O1=i(Al);qT=s(O1,"T5TokenizerFast"),O1.forEach(o),Uh.forEach(o),Vp=p(t),Xe=r(t,"DIV",{class:!0});var to=i(Xe);v(xa.$$.fragment,to),FT=p(to),po=r(to,"P",{});var dd=i(po);jT=s(dd,"Construct a \u201Cfast\u201D T5 tokenizer (backed by HuggingFace\u2019s "),Pl=r(dd,"EM",{});var L1=i(Pl);MT=s(L1,"tokenizers"),L1.forEach(o),CT=s(dd,` library). Based on
`),za=r(dd,"A",{href:!0,rel:!0});var N1=i(za);AT=s(N1,"Unigram"),N1.forEach(o),PT=s(dd,"."),dd.forEach(o),OT=p(to),Ea=r(to,"P",{});var Wh=i(Ea);LT=s(Wh,"This tokenizer inherits from "),Ii=r(Wh,"A",{href:!0});var I1=i(Ii);NT=s(I1,"PreTrainedTokenizerFast"),I1.forEach(o),IT=s(Wh,` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),Wh.forEach(o),DT=p(to),Jt=r(to,"DIV",{class:!0});var ld=i(Jt);v(qa.$$.fragment,ld),ST=p(ld),Ol=r(ld,"P",{});var D1=i(Ol);GT=s(D1,`Build model inputs from a sequence or a pair of sequence for sequence classification tasks by concatenating and
adding special tokens. A sequence has the following format:`),D1.forEach(o),BT=p(ld),Fa=r(ld,"UL",{});var Rh=i(Fa);Di=r(Rh,"LI",{});var Ny=i(Di);UT=s(Ny,"single sequence: "),Ll=r(Ny,"CODE",{});var S1=i(Ll);WT=s(S1,"X </s>"),S1.forEach(o),Ny.forEach(o),RT=p(Rh),Si=r(Rh,"LI",{});var Iy=i(Si);HT=s(Iy,"pair of sequences: "),Nl=r(Iy,"CODE",{});var G1=i(Nl);KT=s(G1,"A </s> B </s>"),G1.forEach(o),Iy.forEach(o),Rh.forEach(o),ld.forEach(o),VT=p(to),Xo=r(to,"DIV",{class:!0});var Hh=i(Xo);v(ja.$$.fragment,Hh),YT=p(Hh),Il=r(Hh,"P",{});var B1=i(Il);ZT=s(B1,`Create a mask from the two sequences passed to be used in a sequence-pair classification task. T5 does not make
use of token type ids, therefore a list of zeros is returned.`),B1.forEach(o),Hh.forEach(o),to.forEach(o),Yp=p(t),ho=r(t,"H2",{class:!0});var Kh=i(ho);Qo=r(Kh,"A",{id:!0,class:!0,href:!0});var U1=i(Qo);Dl=r(U1,"SPAN",{});var W1=i(Dl);v(Ma.$$.fragment,W1),W1.forEach(o),U1.forEach(o),JT=p(Kh),Sl=r(Kh,"SPAN",{});var R1=i(Sl);XT=s(R1,"T5Model"),R1.forEach(o),Kh.forEach(o),Zp=p(t),Ee=r(t,"DIV",{class:!0});var At=i(Ee);v(Ca.$$.fragment,At),QT=p(At),Gl=r(At,"P",{});var H1=i(Gl);ek=s(H1,"The bare T5 Model transformer outputting raw hidden-states without any specific head on top."),H1.forEach(o),tk=p(At),Aa=r(At,"P",{});var Vh=i(Aa);ok=s(Vh,"The T5 model was proposed in "),Pa=r(Vh,"A",{href:!0,rel:!0});var K1=i(Pa);nk=s(K1,`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),K1.forEach(o),sk=s(Vh,` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),Vh.forEach(o),ak=p(At),Oa=r(At,"P",{});var Yh=i(Oa);rk=s(Yh,"This model inherits from "),Gi=r(Yh,"A",{href:!0});var V1=i(Gi);ik=s(V1,"PreTrainedModel"),V1.forEach(o),dk=s(Yh,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Yh.forEach(o),lk=p(At),La=r(At,"P",{});var Zh=i(La);ck=s(Zh,"This model is also a PyTorch "),Na=r(Zh,"A",{href:!0,rel:!0});var Y1=i(Na);pk=s(Y1,"torch.nn.Module"),Y1.forEach(o),hk=s(Zh,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Zh.forEach(o),uk=p(At),xt=r(At,"DIV",{class:!0});var Bn=i(xt);v(Ia.$$.fragment,Bn),mk=p(Bn),uo=r(Bn,"P",{});var cd=i(uo);fk=s(cd,"The "),Bi=r(cd,"A",{href:!0});var Z1=i(Bi);_k=s(Z1,"T5Model"),Z1.forEach(o),gk=s(cd," forward method, overrides the "),Bl=r(cd,"CODE",{});var J1=i(Bl);Tk=s(J1,"__call__"),J1.forEach(o),kk=s(cd," special method."),cd.forEach(o),bk=p(Bn),v(en.$$.fragment,Bn),vk=p(Bn),v(tn.$$.fragment,Bn),Bn.forEach(o),At.forEach(o),Jp=p(t),mo=r(t,"H2",{class:!0});var Jh=i(mo);on=r(Jh,"A",{id:!0,class:!0,href:!0});var X1=i(on);Ul=r(X1,"SPAN",{});var Q1=i(Ul);v(Da.$$.fragment,Q1),Q1.forEach(o),X1.forEach(o),yk=p(Jh),Wl=r(Jh,"SPAN",{});var e2=i(Wl);wk=s(e2,"T5ForConditionalGeneration"),e2.forEach(o),Jh.forEach(o),Xp=p(t),qe=r(t,"DIV",{class:!0});var Pt=i(qe);v(Sa.$$.fragment,Pt),$k=p(Pt),Ga=r(Pt,"P",{});var Xh=i(Ga);xk=s(Xh,"T5 Model with a "),Rl=r(Xh,"CODE",{});var t2=i(Rl);zk=s(t2,"language modeling"),t2.forEach(o),Ek=s(Xh," head on top."),Xh.forEach(o),qk=p(Pt),Ba=r(Pt,"P",{});var Qh=i(Ba);Fk=s(Qh,"The T5 model was proposed in "),Ua=r(Qh,"A",{href:!0,rel:!0});var o2=i(Ua);jk=s(o2,`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),o2.forEach(o),Mk=s(Qh,` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),Qh.forEach(o),Ck=p(Pt),Wa=r(Pt,"P",{});var eu=i(Wa);Ak=s(eu,"This model inherits from "),Ui=r(eu,"A",{href:!0});var n2=i(Ui);Pk=s(n2,"PreTrainedModel"),n2.forEach(o),Ok=s(eu,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),eu.forEach(o),Lk=p(Pt),Ra=r(Pt,"P",{});var tu=i(Ra);Nk=s(tu,"This model is also a PyTorch "),Ha=r(tu,"A",{href:!0,rel:!0});var s2=i(Ha);Ik=s(s2,"torch.nn.Module"),s2.forEach(o),Dk=s(tu,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),tu.forEach(o),Sk=p(Pt),zt=r(Pt,"DIV",{class:!0});var Un=i(zt);v(Ka.$$.fragment,Un),Gk=p(Un),fo=r(Un,"P",{});var pd=i(fo);Bk=s(pd,"The "),Wi=r(pd,"A",{href:!0});var a2=i(Wi);Uk=s(a2,"T5ForConditionalGeneration"),a2.forEach(o),Wk=s(pd," forward method, overrides the "),Hl=r(pd,"CODE",{});var r2=i(Hl);Rk=s(r2,"__call__"),r2.forEach(o),Hk=s(pd," special method."),pd.forEach(o),Kk=p(Un),v(nn.$$.fragment,Un),Vk=p(Un),v(sn.$$.fragment,Un),Un.forEach(o),Pt.forEach(o),Qp=p(t),_o=r(t,"H2",{class:!0});var ou=i(_o);an=r(ou,"A",{id:!0,class:!0,href:!0});var i2=i(an);Kl=r(i2,"SPAN",{});var d2=i(Kl);v(Va.$$.fragment,d2),d2.forEach(o),i2.forEach(o),Yk=p(ou),Vl=r(ou,"SPAN",{});var l2=i(Vl);Zk=s(l2,"T5EncoderModel"),l2.forEach(o),ou.forEach(o),eh=p(t),Fe=r(t,"DIV",{class:!0});var Ot=i(Fe);v(Ya.$$.fragment,Ot),Jk=p(Ot),Yl=r(Ot,"P",{});var c2=i(Yl);Xk=s(c2,"The bare T5 Model transformer outputting encoder\u2019s raw hidden-states without any specific head on top."),c2.forEach(o),Qk=p(Ot),Za=r(Ot,"P",{});var nu=i(Za);eb=s(nu,"The T5 model was proposed in "),Ja=r(nu,"A",{href:!0,rel:!0});var p2=i(Ja);tb=s(p2,`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),p2.forEach(o),ob=s(nu,` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),nu.forEach(o),nb=p(Ot),Xa=r(Ot,"P",{});var su=i(Xa);sb=s(su,"This model inherits from "),Ri=r(su,"A",{href:!0});var h2=i(Ri);ab=s(h2,"PreTrainedModel"),h2.forEach(o),rb=s(su,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),su.forEach(o),ib=p(Ot),Qa=r(Ot,"P",{});var au=i(Qa);db=s(au,"This model is also a PyTorch "),er=r(au,"A",{href:!0,rel:!0});var u2=i(er);lb=s(u2,"torch.nn.Module"),u2.forEach(o),cb=s(au,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),au.forEach(o),pb=p(Ot),Et=r(Ot,"DIV",{class:!0});var Wn=i(Et);v(tr.$$.fragment,Wn),hb=p(Wn),go=r(Wn,"P",{});var hd=i(go);ub=s(hd,"The "),Hi=r(hd,"A",{href:!0});var m2=i(Hi);mb=s(m2,"T5EncoderModel"),m2.forEach(o),fb=s(hd," forward method, overrides the "),Zl=r(hd,"CODE",{});var f2=i(Zl);_b=s(f2,"__call__"),f2.forEach(o),gb=s(hd," special method."),hd.forEach(o),Tb=p(Wn),v(rn.$$.fragment,Wn),kb=p(Wn),v(dn.$$.fragment,Wn),Wn.forEach(o),Ot.forEach(o),th=p(t),To=r(t,"H2",{class:!0});var ru=i(To);ln=r(ru,"A",{id:!0,class:!0,href:!0});var _2=i(ln);Jl=r(_2,"SPAN",{});var g2=i(Jl);v(or.$$.fragment,g2),g2.forEach(o),_2.forEach(o),bb=p(ru),Xl=r(ru,"SPAN",{});var T2=i(Xl);vb=s(T2,"TFT5Model"),T2.forEach(o),ru.forEach(o),oh=p(t),ce=r(t,"DIV",{class:!0});var dt=i(ce);v(nr.$$.fragment,dt),yb=p(dt),Ql=r(dt,"P",{});var k2=i(Ql);wb=s(k2,"The bare T5 Model transformer outputting raw hidden-stateswithout any specific head on top."),k2.forEach(o),$b=p(dt),sr=r(dt,"P",{});var iu=i(sr);xb=s(iu,"The T5 model was proposed in "),ar=r(iu,"A",{href:!0,rel:!0});var b2=i(ar);zb=s(b2,`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),b2.forEach(o),Eb=s(iu,` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),iu.forEach(o),qb=p(dt),rr=r(dt,"P",{});var du=i(rr);Fb=s(du,"This model inherits from "),Ki=r(du,"A",{href:!0});var v2=i(Ki);jb=s(v2,"TFPreTrainedModel"),v2.forEach(o),Mb=s(du,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),du.forEach(o),Cb=p(dt),ir=r(dt,"P",{});var lu=i(ir);Ab=s(lu,"This model is also a "),dr=r(lu,"A",{href:!0,rel:!0});var y2=i(dr);Pb=s(y2,"tf.keras.Model"),y2.forEach(o),Ob=s(lu,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),lu.forEach(o),Lb=p(dt),v(cn.$$.fragment,dt),Nb=p(dt),qt=r(dt,"DIV",{class:!0});var Rn=i(qt);v(lr.$$.fragment,Rn),Ib=p(Rn),ko=r(Rn,"P",{});var ud=i(ko);Db=s(ud,"The "),Vi=r(ud,"A",{href:!0});var w2=i(Vi);Sb=s(w2,"TFT5Model"),w2.forEach(o),Gb=s(ud," forward method, overrides the "),ec=r(ud,"CODE",{});var $2=i(ec);Bb=s($2,"__call__"),$2.forEach(o),Ub=s(ud," special method."),ud.forEach(o),Wb=p(Rn),v(pn.$$.fragment,Rn),Rb=p(Rn),v(hn.$$.fragment,Rn),Rn.forEach(o),dt.forEach(o),nh=p(t),bo=r(t,"H2",{class:!0});var cu=i(bo);un=r(cu,"A",{id:!0,class:!0,href:!0});var x2=i(un);tc=r(x2,"SPAN",{});var z2=i(tc);v(cr.$$.fragment,z2),z2.forEach(o),x2.forEach(o),Hb=p(cu),oc=r(cu,"SPAN",{});var E2=i(oc);Kb=s(E2,"TFT5ForConditionalGeneration"),E2.forEach(o),cu.forEach(o),sh=p(t),pe=r(t,"DIV",{class:!0});var lt=i(pe);v(pr.$$.fragment,lt),Vb=p(lt),hr=r(lt,"P",{});var pu=i(hr);Yb=s(pu,"T5 Model with a "),nc=r(pu,"CODE",{});var q2=i(nc);Zb=s(q2,"language modeling"),q2.forEach(o),Jb=s(pu," head on top."),pu.forEach(o),Xb=p(lt),ur=r(lt,"P",{});var hu=i(ur);Qb=s(hu,"The T5 model was proposed in "),mr=r(hu,"A",{href:!0,rel:!0});var F2=i(mr);ev=s(F2,`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),F2.forEach(o),tv=s(hu,` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),hu.forEach(o),ov=p(lt),fr=r(lt,"P",{});var uu=i(fr);nv=s(uu,"This model inherits from "),Yi=r(uu,"A",{href:!0});var j2=i(Yi);sv=s(j2,"TFPreTrainedModel"),j2.forEach(o),av=s(uu,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),uu.forEach(o),rv=p(lt),_r=r(lt,"P",{});var mu=i(_r);iv=s(mu,"This model is also a "),gr=r(mu,"A",{href:!0,rel:!0});var M2=i(gr);dv=s(M2,"tf.keras.Model"),M2.forEach(o),lv=s(mu,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),mu.forEach(o),cv=p(lt),v(mn.$$.fragment,lt),pv=p(lt),Ft=r(lt,"DIV",{class:!0});var Hn=i(Ft);v(Tr.$$.fragment,Hn),hv=p(Hn),vo=r(Hn,"P",{});var md=i(vo);uv=s(md,"The "),Zi=r(md,"A",{href:!0});var C2=i(Zi);mv=s(C2,"TFT5ForConditionalGeneration"),C2.forEach(o),fv=s(md," forward method, overrides the "),sc=r(md,"CODE",{});var A2=i(sc);_v=s(A2,"__call__"),A2.forEach(o),gv=s(md," special method."),md.forEach(o),Tv=p(Hn),v(fn.$$.fragment,Hn),kv=p(Hn),v(_n.$$.fragment,Hn),Hn.forEach(o),lt.forEach(o),ah=p(t),yo=r(t,"H2",{class:!0});var fu=i(yo);gn=r(fu,"A",{id:!0,class:!0,href:!0});var P2=i(gn);ac=r(P2,"SPAN",{});var O2=i(ac);v(kr.$$.fragment,O2),O2.forEach(o),P2.forEach(o),bv=p(fu),rc=r(fu,"SPAN",{});var L2=i(rc);vv=s(L2,"TFT5EncoderModel"),L2.forEach(o),fu.forEach(o),rh=p(t),he=r(t,"DIV",{class:!0});var ct=i(he);v(br.$$.fragment,ct),yv=p(ct),ic=r(ct,"P",{});var N2=i(ic);wv=s(N2,"The bare T5 Model transformer outputting encoder\u2019s raw hidden-stateswithout any specific head on top."),N2.forEach(o),$v=p(ct),vr=r(ct,"P",{});var _u=i(vr);xv=s(_u,"The T5 model was proposed in "),yr=r(_u,"A",{href:!0,rel:!0});var I2=i(yr);zv=s(I2,`Exploring the Limits of Transfer Learning with a Unified Text-to-Text
Transformer`),I2.forEach(o),Ev=s(_u,` by Colin Raffel, Noam Shazeer, Adam Roberts, Katherine Lee, Sharan
Narang, Michael Matena, Yanqi Zhou, Wei Li, Peter J. Liu. It\u2019s an encoder decoder transformer pre-trained in a
text-to-text denoising generative setting.`),_u.forEach(o),qv=p(ct),wr=r(ct,"P",{});var gu=i(wr);Fv=s(gu,"This model inherits from "),Ji=r(gu,"A",{href:!0});var D2=i(Ji);jv=s(D2,"TFPreTrainedModel"),D2.forEach(o),Mv=s(gu,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),gu.forEach(o),Cv=p(ct),$r=r(ct,"P",{});var Tu=i($r);Av=s(Tu,"This model is also a "),xr=r(Tu,"A",{href:!0,rel:!0});var S2=i(xr);Pv=s(S2,"tf.keras.Model"),S2.forEach(o),Ov=s(Tu,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Tu.forEach(o),Lv=p(ct),v(Tn.$$.fragment,ct),Nv=p(ct),jt=r(ct,"DIV",{class:!0});var Kn=i(jt);v(zr.$$.fragment,Kn),Iv=p(Kn),wo=r(Kn,"P",{});var fd=i(wo);Dv=s(fd,"The "),Xi=r(fd,"A",{href:!0});var G2=i(Xi);Sv=s(G2,"TFT5EncoderModel"),G2.forEach(o),Gv=s(fd," forward method, overrides the "),dc=r(fd,"CODE",{});var B2=i(dc);Bv=s(B2,"__call__"),B2.forEach(o),Uv=s(fd," special method."),fd.forEach(o),Wv=p(Kn),v(kn.$$.fragment,Kn),Rv=p(Kn),v(bn.$$.fragment,Kn),Kn.forEach(o),ct.forEach(o),ih=p(t),$o=r(t,"H2",{class:!0});var ku=i($o);vn=r(ku,"A",{id:!0,class:!0,href:!0});var U2=i(vn);lc=r(U2,"SPAN",{});var W2=i(lc);v(Er.$$.fragment,W2),W2.forEach(o),U2.forEach(o),Hv=p(ku),cc=r(ku,"SPAN",{});var R2=i(cc);Kv=s(R2,"FlaxT5Model"),R2.forEach(o),ku.forEach(o),dh=p(t),ht=r(t,"DIV",{class:!0});var Vn=i(ht);v(qr.$$.fragment,Vn),Vv=p(Vn),Mt=r(Vn,"DIV",{class:!0});var Yn=i(Mt);v(Fr.$$.fragment,Yn),Yv=p(Yn),xo=r(Yn,"P",{});var _d=i(xo);Zv=s(_d,"The "),pc=r(_d,"CODE",{});var H2=i(pc);Jv=s(H2,"FlaxT5PreTrainedModel"),H2.forEach(o),Xv=s(_d," forward method, overrides the "),hc=r(_d,"CODE",{});var K2=i(hc);Qv=s(K2,"__call__"),K2.forEach(o),ey=s(_d," special method."),_d.forEach(o),ty=p(Yn),v(yn.$$.fragment,Yn),oy=p(Yn),v(wn.$$.fragment,Yn),Yn.forEach(o),ny=p(Vn),$n=r(Vn,"DIV",{class:!0});var bu=i($n);v(jr.$$.fragment,bu),sy=p(bu),v(xn.$$.fragment,bu),bu.forEach(o),ay=p(Vn),zn=r(Vn,"DIV",{class:!0});var vu=i(zn);v(Mr.$$.fragment,vu),ry=p(vu),v(En.$$.fragment,vu),vu.forEach(o),Vn.forEach(o),lh=p(t),zo=r(t,"H2",{class:!0});var yu=i(zo);qn=r(yu,"A",{id:!0,class:!0,href:!0});var V2=i(qn);uc=r(V2,"SPAN",{});var Y2=i(uc);v(Cr.$$.fragment,Y2),Y2.forEach(o),V2.forEach(o),iy=p(yu),mc=r(yu,"SPAN",{});var Z2=i(mc);dy=s(Z2,"FlaxT5ForConditionalGeneration"),Z2.forEach(o),yu.forEach(o),ch=p(t),ut=r(t,"DIV",{class:!0});var Zn=i(ut);v(Ar.$$.fragment,Zn),ly=p(Zn),Ct=r(Zn,"DIV",{class:!0});var Jn=i(Ct);v(Pr.$$.fragment,Jn),cy=p(Jn),Eo=r(Jn,"P",{});var gd=i(Eo);py=s(gd,"The "),fc=r(gd,"CODE",{});var J2=i(fc);hy=s(J2,"FlaxT5PreTrainedModel"),J2.forEach(o),uy=s(gd," forward method, overrides the "),_c=r(gd,"CODE",{});var X2=i(_c);my=s(X2,"__call__"),X2.forEach(o),fy=s(gd," special method."),gd.forEach(o),_y=p(Jn),v(Fn.$$.fragment,Jn),gy=p(Jn),v(jn.$$.fragment,Jn),Jn.forEach(o),Ty=p(Zn),Mn=r(Zn,"DIV",{class:!0});var wu=i(Mn);v(Or.$$.fragment,wu),ky=p(wu),v(Cn.$$.fragment,wu),wu.forEach(o),by=p(Zn),An=r(Zn,"DIV",{class:!0});var $u=i(An);v(Lr.$$.fragment,$u),vy=p($u),v(Pn.$$.fragment,$u),$u.forEach(o),Zn.forEach(o),ph=p(t),qo=r(t,"H2",{class:!0});var xu=i(qo);On=r(xu,"A",{id:!0,class:!0,href:!0});var Q2=i(On);gc=r(Q2,"SPAN",{});var e$=i(gc);v(Nr.$$.fragment,e$),e$.forEach(o),Q2.forEach(o),yy=p(xu),Tc=r(xu,"SPAN",{});var t$=i(Tc);wy=s(t$,"FlaxT5EncoderModel"),t$.forEach(o),xu.forEach(o),hh=p(t),Fo=r(t,"DIV",{class:!0});var zu=i(Fo);v(Ir.$$.fragment,zu),$y=p(zu),Xt=r(zu,"DIV",{class:!0});var Td=i(Xt);v(Dr.$$.fragment,Td),xy=p(Td),jo=r(Td,"P",{});var kd=i(jo);zy=s(kd,"The "),Qi=r(kd,"A",{href:!0});var o$=i(Qi);Ey=s(o$,"FlaxT5EncoderModel"),o$.forEach(o),qy=s(kd," forward method, overrides the "),kc=r(kd,"CODE",{});var n$=i(kc);Fy=s(n$,"__call__"),n$.forEach(o),jy=s(kd," special method."),kd.forEach(o),My=p(Td),v(Ln.$$.fragment,Td),Td.forEach(o),zu.forEach(o),this.h()},h(){l(m,"name","hf:doc:metadata"),l(m,"content",JSON.stringify(O$)),l(_,"id","t5"),l(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(_,"href","#t5"),l(g,"class","relative group"),l(J,"alt","Models"),s$(J.src,E="https://img.shields.io/badge/All_model_pages-t5-blueviolet")||l(J,"src",E),l(ue,"href","https://huggingface.co/models?filter=t5"),l(me,"alt","Spaces"),s$(me.src,Qe="https://img.shields.io/badge/%F0%9F%A4%97%20Hugging%20Face-Spaces-blue")||l(me,"src",Qe),l(B,"href","https://huggingface.co/spaces/docs-demos/t5-base"),l(I,"class","flex flex-wrap space-x-1"),l(ne,"id","overview"),l(ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ne,"href","#overview"),l(X,"class","relative group"),l(de,"href","https://arxiv.org/pdf/1910.10683.pdf"),l(de,"rel","nofollow"),l(Ve,"href","#training"),l(Ye,"href","#inference"),l(Ze,"href","#scripts"),l(Xn,"href","https://huggingface.co/t5-small"),l(Xn,"rel","nofollow"),l(Qn,"href","https://huggingface.co/t5-base"),l(Qn,"rel","nofollow"),l(es,"href","https://huggingface.co/t5-large"),l(es,"rel","nofollow"),l(ts,"href","https://huggingface.co/t5-3b"),l(ts,"rel","nofollow"),l(os,"href","https://huggingface.co/t5-11b"),l(os,"rel","nofollow"),l(Jr,"href","t5v1.1"),l(Xr,"href","mt5"),l(Qr,"href","byt5"),l(ns,"href","https://huggingface.co/models?search=t5"),l(ns,"rel","nofollow"),l(ss,"href","https://huggingface.co/thomwolf"),l(ss,"rel","nofollow"),l(as,"href","https://github.com/google-research/text-to-text-transfer-transformer"),l(as,"rel","nofollow"),l(ei,"id","training"),l(No,"id","training"),l(No,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(No,"href","#training"),l(oo,"class","relative group"),l(ti,"href","/docs/transformers/main/en/model_doc/t5#transformers.T5ForConditionalGeneration"),l(ni,"href","/docs/transformers/main/en/model_doc/mt5#transformers.T5Tokenizer"),l(ds,"href","https://github.com/huggingface/transformers/tree/main/examples/flax/language-modeling"),l(ds,"rel","nofollow"),l(cs,"href","https://github.com/huggingface/transformers/tree/main/examples/flax/summarization"),l(cs,"rel","nofollow"),l(us,"href","https://discuss.huggingface.co/t/t5-finetuning-tips/684"),l(us,"rel","nofollow"),l(ms,"href","https://arxiv.org/pdf/1910.10683.pdf"),l(ms,"rel","nofollow"),l(li,"id","inference"),l(Go,"id","inference"),l(Go,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Go,"href","#inference"),l(no,"class","relative group"),l(ci,"href","/docs/transformers/main/en/main_classes/text_generation#transformers.GenerationMixin.generate"),l(_s,"href","https://huggingface.co/blog/how-to-generate"),l(_s,"rel","nofollow"),l(gs,"href","https://huggingface.co/blog/encoder-decoder#encoder-decoder"),l(gs,"rel","nofollow"),l(pi,"href","/docs/transformers/main/en/main_classes/text_generation#transformers.GenerationMixin.generate"),l(mi,"id","scripts"),l(Bo,"id","performance"),l(Bo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Bo,"href","#performance"),l(so,"class","relative group"),l(ys,"href","https://github.com/NVIDIA/apex#quick-start"),l(ys,"rel","nofollow"),l(Uo,"id","resources"),l(Uo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Uo,"href","#resources"),l(ao,"class","relative group"),l(zs,"href","https://colab.research.google.com/github/patil-suraj/exploring-T5/blob/master/t5_fine_tuning.ipynb"),l(zs,"rel","nofollow"),l(qs,"href","https://colab.research.google.com/github/enzoampil/t5-intro/blob/master/t5_qa_training_pytorch_span_extraction.ipynb"),l(qs,"rel","nofollow"),l(Ms,"href","https://colab.research.google.com/drive/1obr78FY_cBmWY5ODViCmzdY6O1KB65Vc?usp=sharing"),l(Ms,"rel","nofollow"),l(Ps,"href","https://colab.research.google.com/github/NielsRogge/Transformers-Tutorials/blob/master/T5/Fine_tune_CodeT5_for_generating_docstrings_from_Ruby_code.ipynb"),l(Ps,"rel","nofollow"),l(Ns,"href","https://colab.research.google.com/github/NielsRogge/Transformers-Tutorials/blob/master/T5/Fine_tuning_Dutch_T5_base_on_CNN_Daily_Mail_for_summarization_(on_TPU_using_HuggingFace_Accelerate).ipynb"),l(Ns,"rel","nofollow"),l(Ds,"href","https://colab.research.google.com/github/abhimishra91/transformers-tutorials/blob/master/transformers_summarization_wandb.ipynb#scrollTo=OKRpFvYhBauC"),l(Ds,"rel","nofollow"),l(Gs,"href","https://huggingface.co/blog/sagemaker-distributed-training-seq2seq"),l(Gs,"rel","nofollow"),l(Ti,"href","/docs/transformers/main/en/model_doc/t5#transformers.T5ForConditionalGeneration"),l(Bs,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/summarization"),l(Bs,"rel","nofollow"),l(Us,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/summarization.ipynb"),l(Us,"rel","nofollow"),l(ki,"href","/docs/transformers/main/en/model_doc/t5#transformers.TFT5ForConditionalGeneration"),l(Ws,"href","https://github.com/huggingface/transformers/tree/main/examples/tensorflow/summarization"),l(Ws,"rel","nofollow"),l(Rs,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/summarization-tf.ipynb"),l(Rs,"rel","nofollow"),l(bi,"href","/docs/transformers/main/en/model_doc/t5#transformers.FlaxT5ForConditionalGeneration"),l(Hs,"href","https://github.com/huggingface/transformers/tree/main/examples/flax/summarization"),l(Hs,"rel","nofollow"),l(Ks,"href","https://huggingface.co/course/chapter7/5?fw=pt#summarization"),l(Ks,"rel","nofollow"),l(yi,"href","./tasks/summarization"),l($i,"href","/docs/transformers/main/en/model_doc/t5#transformers.FlaxT5ForConditionalGeneration"),l(Ys,"href","https://github.com/huggingface/transformers/tree/main/examples/flax/language-modeling#t5-like-span-masked-language-modeling"),l(Ys,"rel","nofollow"),l(xi,"href","/docs/transformers/main/en/model_doc/t5#transformers.FlaxT5ForConditionalGeneration"),l(Zs,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/masked_language_modeling_flax.ipynb"),l(Zs,"rel","nofollow"),l(zi,"href","/docs/transformers/main/en/model_doc/t5#transformers.T5ForConditionalGeneration"),l(Xs,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/translation"),l(Xs,"rel","nofollow"),l(Qs,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/translation.ipynb"),l(Qs,"rel","nofollow"),l(Ei,"href","/docs/transformers/main/en/model_doc/t5#transformers.TFT5ForConditionalGeneration"),l(ea,"href","https://github.com/huggingface/transformers/tree/main/examples/tensorflow/translation"),l(ea,"rel","nofollow"),l(ta,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/translation-tf.ipynb"),l(ta,"rel","nofollow"),l(qi,"href","./tasks/translation"),l(sa,"href","https://colab.research.google.com/github/snapthat/TF-T5-text-to-text/blob/master/snapthatT5/notebooks/TF-T5-Datasets%20Training.ipynb"),l(sa,"rel","nofollow"),l(ra,"href","https://colab.research.google.com/github/patil-suraj/exploring-T5/blob/master/T5_on_TPU.ipynb#scrollTo=QLGiFCDqvuil"),l(ra,"rel","nofollow"),l(la,"href","https://www.philschmid.de/deploy-t5-11b"),l(la,"rel","nofollow"),l(Ko,"id","transformers.T5Config"),l(Ko,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Ko,"href","#transformers.T5Config"),l(ro,"class","relative group"),l(ji,"href","/docs/transformers/main/en/model_doc/t5#transformers.T5Model"),l(Mi,"href","/docs/transformers/main/en/model_doc/t5#transformers.TFT5Model"),l(ha,"href","https://huggingface.co/t5-small"),l(ha,"rel","nofollow"),l(Ci,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(Ai,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(Dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Vo,"id","transformers.T5Tokenizer"),l(Vo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Vo,"href","#transformers.T5Tokenizer"),l(lo,"class","relative group"),l(_a,"href","https://github.com/google/sentencepiece"),l(_a,"rel","nofollow"),l(Pi,"href","/docs/transformers/main/en/main_classes/tokenizer#transformers.PreTrainedTokenizer"),l(Zt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Yo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Zo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ni,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Jo,"id","transformers.T5TokenizerFast"),l(Jo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Jo,"href","#transformers.T5TokenizerFast"),l(co,"class","relative group"),l(za,"href","https://huggingface.co/docs/tokenizers/python/latest/components.html?highlight=unigram#models"),l(za,"rel","nofollow"),l(Ii,"href","/docs/transformers/main/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast"),l(Jt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Xo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Qo,"id","transformers.T5Model"),l(Qo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Qo,"href","#transformers.T5Model"),l(ho,"class","relative group"),l(Pa,"href","https://arxiv.org/abs/1910.10683"),l(Pa,"rel","nofollow"),l(Gi,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(Na,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Na,"rel","nofollow"),l(Bi,"href","/docs/transformers/main/en/model_doc/t5#transformers.T5Model"),l(xt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(on,"id","transformers.T5ForConditionalGeneration"),l(on,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(on,"href","#transformers.T5ForConditionalGeneration"),l(mo,"class","relative group"),l(Ua,"href","https://arxiv.org/abs/1910.10683"),l(Ua,"rel","nofollow"),l(Ui,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(Ha,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Ha,"rel","nofollow"),l(Wi,"href","/docs/transformers/main/en/model_doc/t5#transformers.T5ForConditionalGeneration"),l(zt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(qe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(an,"id","transformers.T5EncoderModel"),l(an,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(an,"href","#transformers.T5EncoderModel"),l(_o,"class","relative group"),l(Ja,"href","https://arxiv.org/abs/1910.10683"),l(Ja,"rel","nofollow"),l(Ri,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(er,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(er,"rel","nofollow"),l(Hi,"href","/docs/transformers/main/en/model_doc/t5#transformers.T5EncoderModel"),l(Et,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ln,"id","transformers.TFT5Model"),l(ln,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ln,"href","#transformers.TFT5Model"),l(To,"class","relative group"),l(ar,"href","https://arxiv.org/abs/1910.10683"),l(ar,"rel","nofollow"),l(Ki,"href","/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel"),l(dr,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),l(dr,"rel","nofollow"),l(Vi,"href","/docs/transformers/main/en/model_doc/t5#transformers.TFT5Model"),l(qt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(un,"id","transformers.TFT5ForConditionalGeneration"),l(un,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(un,"href","#transformers.TFT5ForConditionalGeneration"),l(bo,"class","relative group"),l(mr,"href","https://arxiv.org/abs/1910.10683"),l(mr,"rel","nofollow"),l(Yi,"href","/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel"),l(gr,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),l(gr,"rel","nofollow"),l(Zi,"href","/docs/transformers/main/en/model_doc/t5#transformers.TFT5ForConditionalGeneration"),l(Ft,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(gn,"id","transformers.TFT5EncoderModel"),l(gn,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(gn,"href","#transformers.TFT5EncoderModel"),l(yo,"class","relative group"),l(yr,"href","https://arxiv.org/abs/1910.10683"),l(yr,"rel","nofollow"),l(Ji,"href","/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel"),l(xr,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),l(xr,"rel","nofollow"),l(Xi,"href","/docs/transformers/main/en/model_doc/t5#transformers.TFT5EncoderModel"),l(jt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(vn,"id","transformers.FlaxT5Model"),l(vn,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(vn,"href","#transformers.FlaxT5Model"),l($o,"class","relative group"),l(Mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l($n,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(zn,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ht,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(qn,"id","transformers.FlaxT5ForConditionalGeneration"),l(qn,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(qn,"href","#transformers.FlaxT5ForConditionalGeneration"),l(zo,"class","relative group"),l(Ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Mn,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(An,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ut,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(On,"id","transformers.FlaxT5EncoderModel"),l(On,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(On,"href","#transformers.FlaxT5EncoderModel"),l(qo,"class","relative group"),l(Qi,"href","/docs/transformers/main/en/model_doc/t5#transformers.FlaxT5EncoderModel"),l(Xt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Fo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,h){e(document.head,m),u(t,k,h),u(t,g,h),e(g,_),e(_,T),y(d,T,null),e(g,f),e(g,F),e(F,Le),u(t,je,h),u(t,I,h),e(I,ue),e(ue,J),e(I,Ne),e(I,B),e(B,me),u(t,Y,h),u(t,X,h),e(X,ne),e(ne,R),y(ie,R,null),e(X,Ie),e(X,H),e(H,De),u(t,Me,h),u(t,S,h),e(S,Se),e(S,de),e(de,fe),e(S,C),u(t,P,h),u(t,_e,h),e(_e,Q),u(t,Ce,h),u(t,ge,h),e(ge,K),e(K,Ge),u(t,Ae,h),u(t,A,h),e(A,Be),u(t,Z,h),u(t,G,h),e(G,$e),e($e,D),e(D,Ue),e(D,xe),e(xe,U),e(D,We),e(D,V),e(V,Re),e(D,Te),e(G,L),e(G,ze),e(ze,N),e(N,He),e(G,Ke),e(G,z),e(z,j),e(j,ft),e(G,ke),e(G,et),e(et,tt),e(tt,M),e(G,_t),e(G,ot),e(ot,se),e(se,gt),e(se,Ve),e(Ve,W),e(se,ee),e(se,Ye),e(Ye,Tt),e(se,te),e(se,Ze),e(Ze,kt),e(se,Je),u(t,pt,h),u(t,oe,h),e(oe,bt),u(t,Bc,h),u(t,nt,h),e(nt,bd),e(bd,vd),e(vd,Xn),e(Xn,Eu),e(nt,qu),e(nt,yd),e(yd,wd),e(wd,Qn),e(Qn,Fu),e(nt,ju),e(nt,$d),e($d,xd),e(xd,es),e(es,Mu),e(nt,Cu),e(nt,zd),e(zd,Ed),e(Ed,ts),e(ts,Au),e(nt,Pu),e(nt,qd),e(qd,Yr),e(Yr,os),e(os,Ou),e(Yr,Lu),u(t,Uc,h),u(t,Zr,h),e(Zr,Nu),u(t,Wc,h),u(t,Gt,h),e(Gt,Fd),e(Fd,Ao),e(Ao,jd),e(jd,Iu),e(Ao,Du),e(Ao,Jr),e(Jr,Su),e(Ao,Gu),e(Gt,Bu),e(Gt,Md),e(Md,Po),e(Po,Cd),e(Cd,Uu),e(Po,Wu),e(Po,Xr),e(Xr,Ru),e(Po,Hu),e(Gt,Ku),e(Gt,Ad),e(Ad,Oo),e(Oo,Pd),e(Pd,Vu),e(Oo,Yu),e(Oo,Qr),e(Qr,Zu),e(Oo,Ju),u(t,Rc,h),u(t,Lo,h),e(Lo,Xu),e(Lo,ns),e(ns,Qu),e(Lo,em),u(t,Hc,h),u(t,Bt,h),e(Bt,tm),e(Bt,ss),e(ss,om),e(Bt,nm),e(Bt,as),e(as,sm),e(Bt,am),u(t,Kc,h),u(t,ei,h),u(t,Vc,h),u(t,oo,h),e(oo,No),e(No,Od),y(rs,Od,null),e(oo,rm),e(oo,Ld),e(Ld,im),u(t,Yc,h),u(t,vt,h),e(vt,dm),e(vt,Nd),e(Nd,lm),e(vt,cm),e(vt,Id),e(Id,pm),e(vt,hm),e(vt,Dd),e(Dd,um),e(vt,mm),u(t,Zc,h),u(t,Io,h),e(Io,fm),e(Io,ti),e(ti,_m),e(Io,gm),u(t,Jc,h),u(t,oi,h),e(oi,Sd),e(Sd,Tm),u(t,Xc,h),u(t,be,h),e(be,km),e(be,Gd),e(Gd,bm),e(be,vm),e(be,Bd),e(Bd,ym),e(be,wm),e(be,Ud),e(Ud,$m),e(be,xm),e(be,Wd),e(Wd,zm),e(be,Em),e(be,Rd),e(Rd,qm),e(be,Fm),e(be,ni),e(ni,jm),e(be,Mm),u(t,Qc,h),u(t,si,h),e(si,Cm),u(t,ep,h),y(is,t,h),u(t,tp,h),u(t,Do,h),e(Do,Am),e(Do,ds),e(ds,Pm),e(Do,Om),u(t,op,h),u(t,ai,h),e(ai,Hd),e(Hd,Lm),u(t,np,h),u(t,ri,h),e(ri,Nm),u(t,sp,h),y(ls,t,h),u(t,ap,h),u(t,ae,h),e(ae,Im),e(ae,Kd),e(Kd,Dm),e(ae,Sm),e(ae,Vd),e(Vd,Gm),e(ae,Bm),e(ae,Yd),e(Yd,Um),e(ae,Wm),e(ae,Zd),e(Zd,Rm),e(ae,Hm),e(ae,Jd),e(Jd,Km),e(ae,Vm),e(ae,Xd),e(Xd,Ym),e(ae,Zm),e(ae,Qd),e(Qd,Jm),e(ae,Xm),u(t,rp,h),u(t,Ut,h),e(Ut,Qm),e(Ut,el),e(el,ef),e(Ut,tf),e(Ut,tl),e(tl,of),e(Ut,nf),u(t,ip,h),u(t,ve,h),e(ve,sf),e(ve,ol),e(ol,af),e(ve,rf),e(ve,nl),e(nl,df),e(ve,lf),e(ve,sl),e(sl,cf),e(ve,pf),e(ve,al),e(al,hf),e(ve,uf),e(ve,cs),e(cs,mf),e(ve,ff),e(ve,rl),e(rl,_f),e(ve,gf),u(t,dp,h),y(ps,t,h),u(t,lp,h),u(t,ii,h),e(ii,Tf),u(t,cp,h),u(t,di,h),e(di,hs),e(hs,kf),e(hs,il),e(il,bf),e(hs,vf),u(t,pp,h),u(t,Wt,h),e(Wt,yf),e(Wt,us),e(us,wf),e(Wt,$f),e(Wt,ms),e(ms,xf),e(Wt,zf),u(t,hp,h),u(t,So,h),e(So,Ef),e(So,dl),e(dl,qf),e(So,Ff),u(t,up,h),u(t,li,h),u(t,mp,h),u(t,no,h),e(no,Go),e(Go,ll),y(fs,ll,null),e(no,jf),e(no,cl),e(cl,Mf),u(t,fp,h),u(t,yt,h),e(yt,Cf),e(yt,ci),e(ci,Af),e(yt,Pf),e(yt,_s),e(_s,Of),e(yt,Lf),e(yt,gs),e(gs,Nf),e(yt,If),u(t,_p,h),y(Ts,t,h),u(t,gp,h),u(t,st,h),e(st,Df),e(st,pl),e(pl,Sf),e(st,Gf),e(st,hl),e(hl,Bf),e(st,Uf),e(st,pi),e(pi,Wf),e(st,Rf),e(st,ul),e(ul,Hf),e(st,Kf),u(t,Tp,h),u(t,hi,h),e(hi,Vf),u(t,kp,h),y(ks,t,h),u(t,bp,h),u(t,ui,h),e(ui,Yf),u(t,vp,h),y(bs,t,h),u(t,yp,h),u(t,mi,h),u(t,wp,h),u(t,so,h),e(so,Bo),e(Bo,ml),y(vs,ml,null),e(so,Zf),e(so,fl),e(fl,Jf),u(t,$p,h),u(t,wt,h),e(wt,Xf),e(wt,ys),e(ys,Qf),e(wt,e_),e(wt,_l),e(_l,t_),e(wt,o_),e(wt,gl),e(gl,n_),e(wt,s_),u(t,xp,h),u(t,ao,h),e(ao,Uo),e(Uo,Tl),y(ws,Tl,null),e(ao,a_),e(ao,kl),e(kl,r_),u(t,zp,h),u(t,fi,h),e(fi,i_),u(t,Ep,h),y($s,t,h),u(t,qp,h),u(t,Wo,h),e(Wo,xs),e(xs,d_),e(xs,zs),e(zs,l_),e(xs,c_),e(Wo,p_),e(Wo,Es),e(Es,h_),e(Es,qs),e(qs,u_),e(Es,m_),u(t,Fp,h),y(Fs,t,h),u(t,jp,h),u(t,_i,h),e(_i,js),e(js,f_),e(js,Ms),e(Ms,__),e(js,g_),u(t,Mp,h),y(Cs,t,h),u(t,Cp,h),u(t,gi,h),e(gi,As),e(As,T_),e(As,Ps),e(Ps,k_),e(As,b_),u(t,Ap,h),y(Os,t,h),u(t,Pp,h),u(t,re,h),e(re,Ls),e(Ls,v_),e(Ls,Ns),e(Ns,y_),e(Ls,w_),e(re,$_),e(re,Is),e(Is,x_),e(Is,Ds),e(Ds,z_),e(Is,E_),e(re,q_),e(re,Ss),e(Ss,F_),e(Ss,Gs),e(Gs,j_),e(Ss,M_),e(re,C_),e(re,Rt),e(Rt,Ti),e(Ti,A_),e(Rt,P_),e(Rt,Bs),e(Bs,O_),e(Rt,L_),e(Rt,Us),e(Us,N_),e(Rt,I_),e(re,D_),e(re,Ht),e(Ht,ki),e(ki,S_),e(Ht,G_),e(Ht,Ws),e(Ws,B_),e(Ht,U_),e(Ht,Rs),e(Rs,W_),e(Ht,R_),e(re,H_),e(re,Ro),e(Ro,bi),e(bi,K_),e(Ro,V_),e(Ro,Hs),e(Hs,Y_),e(Ro,Z_),e(re,J_),e(re,vi),e(vi,Ks),e(Ks,X_),e(vi,Q_),e(re,eg),e(re,bl),e(bl,yi),e(yi,tg),u(t,Op,h),y(Vs,t,h),u(t,Lp,h),u(t,wi,h),e(wi,$t),e($t,$i),e($i,og),e($t,ng),e($t,Ys),e(Ys,sg),e($t,ag),e($t,xi),e(xi,rg),e($t,ig),e($t,Zs),e(Zs,dg),e($t,lg),u(t,Np,h),y(Js,t,h),u(t,Ip,h),u(t,Kt,h),e(Kt,Vt),e(Vt,zi),e(zi,cg),e(Vt,pg),e(Vt,Xs),e(Xs,hg),e(Vt,ug),e(Vt,Qs),e(Qs,mg),e(Vt,fg),e(Kt,_g),e(Kt,Yt),e(Yt,Ei),e(Ei,gg),e(Yt,Tg),e(Yt,ea),e(ea,kg),e(Yt,bg),e(Yt,ta),e(ta,vg),e(Yt,yg),e(Kt,wg),e(Kt,vl),e(vl,qi),e(qi,$g),u(t,Dp,h),y(oa,t,h),u(t,Sp,h),u(t,Ho,h),e(Ho,na),e(na,xg),e(na,sa),e(sa,zg),e(na,Eg),e(Ho,qg),e(Ho,aa),e(aa,Fg),e(aa,ra),e(ra,jg),e(aa,Mg),u(t,Gp,h),u(t,ia,h),e(ia,Cg),e(ia,yl),e(yl,Ag),u(t,Bp,h),u(t,Fi,h),e(Fi,da),e(da,Pg),e(da,la),e(la,Og),e(da,Lg),u(t,Up,h),u(t,ro,h),e(ro,Ko),e(Ko,wl),y(ca,wl,null),e(ro,Ng),e(ro,$l),e($l,Ig),u(t,Wp,h),u(t,Dt,h),y(pa,Dt,null),e(Dt,Dg),e(Dt,St),e(St,Sg),e(St,ji),e(ji,Gg),e(St,Bg),e(St,Mi),e(Mi,Ug),e(St,Wg),e(St,ha),e(ha,Rg),e(St,Hg),e(Dt,Kg),e(Dt,io),e(io,Vg),e(io,Ci),e(Ci,Yg),e(io,Zg),e(io,Ai),e(Ai,Jg),e(io,Xg),u(t,Rp,h),u(t,lo,h),e(lo,Vo),e(Vo,xl),y(ua,xl,null),e(lo,Qg),e(lo,zl),e(zl,eT),u(t,Hp,h),u(t,le,h),y(ma,le,null),e(le,tT),e(le,fa),e(fa,oT),e(fa,_a),e(_a,nT),e(fa,sT),e(le,aT),e(le,ga),e(ga,rT),e(ga,Pi),e(Pi,iT),e(ga,dT),e(le,lT),e(le,Zt),y(Ta,Zt,null),e(Zt,cT),e(Zt,El),e(El,pT),e(Zt,hT),e(Zt,ka),e(ka,Oi),e(Oi,uT),e(Oi,ql),e(ql,mT),e(ka,fT),e(ka,Li),e(Li,_T),e(Li,Fl),e(Fl,gT),e(le,TT),e(le,Yo),y(ba,Yo,null),e(Yo,kT),e(Yo,va),e(va,bT),e(va,jl),e(jl,vT),e(va,yT),e(le,wT),e(le,Zo),y(ya,Zo,null),e(Zo,$T),e(Zo,Ml),e(Ml,xT),e(le,zT),e(le,Ni),y(wa,Ni,null),u(t,Kp,h),u(t,co,h),e(co,Jo),e(Jo,Cl),y($a,Cl,null),e(co,ET),e(co,Al),e(Al,qT),u(t,Vp,h),u(t,Xe,h),y(xa,Xe,null),e(Xe,FT),e(Xe,po),e(po,jT),e(po,Pl),e(Pl,MT),e(po,CT),e(po,za),e(za,AT),e(po,PT),e(Xe,OT),e(Xe,Ea),e(Ea,LT),e(Ea,Ii),e(Ii,NT),e(Ea,IT),e(Xe,DT),e(Xe,Jt),y(qa,Jt,null),e(Jt,ST),e(Jt,Ol),e(Ol,GT),e(Jt,BT),e(Jt,Fa),e(Fa,Di),e(Di,UT),e(Di,Ll),e(Ll,WT),e(Fa,RT),e(Fa,Si),e(Si,HT),e(Si,Nl),e(Nl,KT),e(Xe,VT),e(Xe,Xo),y(ja,Xo,null),e(Xo,YT),e(Xo,Il),e(Il,ZT),u(t,Yp,h),u(t,ho,h),e(ho,Qo),e(Qo,Dl),y(Ma,Dl,null),e(ho,JT),e(ho,Sl),e(Sl,XT),u(t,Zp,h),u(t,Ee,h),y(Ca,Ee,null),e(Ee,QT),e(Ee,Gl),e(Gl,ek),e(Ee,tk),e(Ee,Aa),e(Aa,ok),e(Aa,Pa),e(Pa,nk),e(Aa,sk),e(Ee,ak),e(Ee,Oa),e(Oa,rk),e(Oa,Gi),e(Gi,ik),e(Oa,dk),e(Ee,lk),e(Ee,La),e(La,ck),e(La,Na),e(Na,pk),e(La,hk),e(Ee,uk),e(Ee,xt),y(Ia,xt,null),e(xt,mk),e(xt,uo),e(uo,fk),e(uo,Bi),e(Bi,_k),e(uo,gk),e(uo,Bl),e(Bl,Tk),e(uo,kk),e(xt,bk),y(en,xt,null),e(xt,vk),y(tn,xt,null),u(t,Jp,h),u(t,mo,h),e(mo,on),e(on,Ul),y(Da,Ul,null),e(mo,yk),e(mo,Wl),e(Wl,wk),u(t,Xp,h),u(t,qe,h),y(Sa,qe,null),e(qe,$k),e(qe,Ga),e(Ga,xk),e(Ga,Rl),e(Rl,zk),e(Ga,Ek),e(qe,qk),e(qe,Ba),e(Ba,Fk),e(Ba,Ua),e(Ua,jk),e(Ba,Mk),e(qe,Ck),e(qe,Wa),e(Wa,Ak),e(Wa,Ui),e(Ui,Pk),e(Wa,Ok),e(qe,Lk),e(qe,Ra),e(Ra,Nk),e(Ra,Ha),e(Ha,Ik),e(Ra,Dk),e(qe,Sk),e(qe,zt),y(Ka,zt,null),e(zt,Gk),e(zt,fo),e(fo,Bk),e(fo,Wi),e(Wi,Uk),e(fo,Wk),e(fo,Hl),e(Hl,Rk),e(fo,Hk),e(zt,Kk),y(nn,zt,null),e(zt,Vk),y(sn,zt,null),u(t,Qp,h),u(t,_o,h),e(_o,an),e(an,Kl),y(Va,Kl,null),e(_o,Yk),e(_o,Vl),e(Vl,Zk),u(t,eh,h),u(t,Fe,h),y(Ya,Fe,null),e(Fe,Jk),e(Fe,Yl),e(Yl,Xk),e(Fe,Qk),e(Fe,Za),e(Za,eb),e(Za,Ja),e(Ja,tb),e(Za,ob),e(Fe,nb),e(Fe,Xa),e(Xa,sb),e(Xa,Ri),e(Ri,ab),e(Xa,rb),e(Fe,ib),e(Fe,Qa),e(Qa,db),e(Qa,er),e(er,lb),e(Qa,cb),e(Fe,pb),e(Fe,Et),y(tr,Et,null),e(Et,hb),e(Et,go),e(go,ub),e(go,Hi),e(Hi,mb),e(go,fb),e(go,Zl),e(Zl,_b),e(go,gb),e(Et,Tb),y(rn,Et,null),e(Et,kb),y(dn,Et,null),u(t,th,h),u(t,To,h),e(To,ln),e(ln,Jl),y(or,Jl,null),e(To,bb),e(To,Xl),e(Xl,vb),u(t,oh,h),u(t,ce,h),y(nr,ce,null),e(ce,yb),e(ce,Ql),e(Ql,wb),e(ce,$b),e(ce,sr),e(sr,xb),e(sr,ar),e(ar,zb),e(sr,Eb),e(ce,qb),e(ce,rr),e(rr,Fb),e(rr,Ki),e(Ki,jb),e(rr,Mb),e(ce,Cb),e(ce,ir),e(ir,Ab),e(ir,dr),e(dr,Pb),e(ir,Ob),e(ce,Lb),y(cn,ce,null),e(ce,Nb),e(ce,qt),y(lr,qt,null),e(qt,Ib),e(qt,ko),e(ko,Db),e(ko,Vi),e(Vi,Sb),e(ko,Gb),e(ko,ec),e(ec,Bb),e(ko,Ub),e(qt,Wb),y(pn,qt,null),e(qt,Rb),y(hn,qt,null),u(t,nh,h),u(t,bo,h),e(bo,un),e(un,tc),y(cr,tc,null),e(bo,Hb),e(bo,oc),e(oc,Kb),u(t,sh,h),u(t,pe,h),y(pr,pe,null),e(pe,Vb),e(pe,hr),e(hr,Yb),e(hr,nc),e(nc,Zb),e(hr,Jb),e(pe,Xb),e(pe,ur),e(ur,Qb),e(ur,mr),e(mr,ev),e(ur,tv),e(pe,ov),e(pe,fr),e(fr,nv),e(fr,Yi),e(Yi,sv),e(fr,av),e(pe,rv),e(pe,_r),e(_r,iv),e(_r,gr),e(gr,dv),e(_r,lv),e(pe,cv),y(mn,pe,null),e(pe,pv),e(pe,Ft),y(Tr,Ft,null),e(Ft,hv),e(Ft,vo),e(vo,uv),e(vo,Zi),e(Zi,mv),e(vo,fv),e(vo,sc),e(sc,_v),e(vo,gv),e(Ft,Tv),y(fn,Ft,null),e(Ft,kv),y(_n,Ft,null),u(t,ah,h),u(t,yo,h),e(yo,gn),e(gn,ac),y(kr,ac,null),e(yo,bv),e(yo,rc),e(rc,vv),u(t,rh,h),u(t,he,h),y(br,he,null),e(he,yv),e(he,ic),e(ic,wv),e(he,$v),e(he,vr),e(vr,xv),e(vr,yr),e(yr,zv),e(vr,Ev),e(he,qv),e(he,wr),e(wr,Fv),e(wr,Ji),e(Ji,jv),e(wr,Mv),e(he,Cv),e(he,$r),e($r,Av),e($r,xr),e(xr,Pv),e($r,Ov),e(he,Lv),y(Tn,he,null),e(he,Nv),e(he,jt),y(zr,jt,null),e(jt,Iv),e(jt,wo),e(wo,Dv),e(wo,Xi),e(Xi,Sv),e(wo,Gv),e(wo,dc),e(dc,Bv),e(wo,Uv),e(jt,Wv),y(kn,jt,null),e(jt,Rv),y(bn,jt,null),u(t,ih,h),u(t,$o,h),e($o,vn),e(vn,lc),y(Er,lc,null),e($o,Hv),e($o,cc),e(cc,Kv),u(t,dh,h),u(t,ht,h),y(qr,ht,null),e(ht,Vv),e(ht,Mt),y(Fr,Mt,null),e(Mt,Yv),e(Mt,xo),e(xo,Zv),e(xo,pc),e(pc,Jv),e(xo,Xv),e(xo,hc),e(hc,Qv),e(xo,ey),e(Mt,ty),y(yn,Mt,null),e(Mt,oy),y(wn,Mt,null),e(ht,ny),e(ht,$n),y(jr,$n,null),e($n,sy),y(xn,$n,null),e(ht,ay),e(ht,zn),y(Mr,zn,null),e(zn,ry),y(En,zn,null),u(t,lh,h),u(t,zo,h),e(zo,qn),e(qn,uc),y(Cr,uc,null),e(zo,iy),e(zo,mc),e(mc,dy),u(t,ch,h),u(t,ut,h),y(Ar,ut,null),e(ut,ly),e(ut,Ct),y(Pr,Ct,null),e(Ct,cy),e(Ct,Eo),e(Eo,py),e(Eo,fc),e(fc,hy),e(Eo,uy),e(Eo,_c),e(_c,my),e(Eo,fy),e(Ct,_y),y(Fn,Ct,null),e(Ct,gy),y(jn,Ct,null),e(ut,Ty),e(ut,Mn),y(Or,Mn,null),e(Mn,ky),y(Cn,Mn,null),e(ut,by),e(ut,An),y(Lr,An,null),e(An,vy),y(Pn,An,null),u(t,ph,h),u(t,qo,h),e(qo,On),e(On,gc),y(Nr,gc,null),e(qo,yy),e(qo,Tc),e(Tc,wy),u(t,hh,h),u(t,Fo,h),y(Ir,Fo,null),e(Fo,$y),e(Fo,Xt),y(Dr,Xt,null),e(Xt,xy),e(Xt,jo),e(jo,zy),e(jo,Qi),e(Qi,Ey),e(jo,qy),e(jo,kc),e(kc,Fy),e(jo,jy),e(Xt,My),y(Ln,Xt,null),uh=!0},p(t,[h]){const Sr={};h&2&&(Sr.$$scope={dirty:h,ctx:t}),en.$set(Sr);const bc={};h&2&&(bc.$$scope={dirty:h,ctx:t}),tn.$set(bc);const vc={};h&2&&(vc.$$scope={dirty:h,ctx:t}),nn.$set(vc);const yc={};h&2&&(yc.$$scope={dirty:h,ctx:t}),sn.$set(yc);const Gr={};h&2&&(Gr.$$scope={dirty:h,ctx:t}),rn.$set(Gr);const wc={};h&2&&(wc.$$scope={dirty:h,ctx:t}),dn.$set(wc);const $c={};h&2&&($c.$$scope={dirty:h,ctx:t}),cn.$set($c);const Br={};h&2&&(Br.$$scope={dirty:h,ctx:t}),pn.$set(Br);const xc={};h&2&&(xc.$$scope={dirty:h,ctx:t}),hn.$set(xc);const zc={};h&2&&(zc.$$scope={dirty:h,ctx:t}),mn.$set(zc);const Ec={};h&2&&(Ec.$$scope={dirty:h,ctx:t}),fn.$set(Ec);const Ur={};h&2&&(Ur.$$scope={dirty:h,ctx:t}),_n.$set(Ur);const qc={};h&2&&(qc.$$scope={dirty:h,ctx:t}),Tn.$set(qc);const Fc={};h&2&&(Fc.$$scope={dirty:h,ctx:t}),kn.$set(Fc);const jc={};h&2&&(jc.$$scope={dirty:h,ctx:t}),bn.$set(jc);const Mc={};h&2&&(Mc.$$scope={dirty:h,ctx:t}),yn.$set(Mc);const Cc={};h&2&&(Cc.$$scope={dirty:h,ctx:t}),wn.$set(Cc);const mt={};h&2&&(mt.$$scope={dirty:h,ctx:t}),xn.$set(mt);const Ac={};h&2&&(Ac.$$scope={dirty:h,ctx:t}),En.$set(Ac);const Mo={};h&2&&(Mo.$$scope={dirty:h,ctx:t}),Fn.$set(Mo);const Pc={};h&2&&(Pc.$$scope={dirty:h,ctx:t}),jn.$set(Pc);const Oc={};h&2&&(Oc.$$scope={dirty:h,ctx:t}),Cn.$set(Oc);const Lc={};h&2&&(Lc.$$scope={dirty:h,ctx:t}),Pn.$set(Lc);const Nc={};h&2&&(Nc.$$scope={dirty:h,ctx:t}),Ln.$set(Nc)},i(t){uh||(w(d.$$.fragment,t),w(ie.$$.fragment,t),w(rs.$$.fragment,t),w(is.$$.fragment,t),w(ls.$$.fragment,t),w(ps.$$.fragment,t),w(fs.$$.fragment,t),w(Ts.$$.fragment,t),w(ks.$$.fragment,t),w(bs.$$.fragment,t),w(vs.$$.fragment,t),w(ws.$$.fragment,t),w($s.$$.fragment,t),w(Fs.$$.fragment,t),w(Cs.$$.fragment,t),w(Os.$$.fragment,t),w(Vs.$$.fragment,t),w(Js.$$.fragment,t),w(oa.$$.fragment,t),w(ca.$$.fragment,t),w(pa.$$.fragment,t),w(ua.$$.fragment,t),w(ma.$$.fragment,t),w(Ta.$$.fragment,t),w(ba.$$.fragment,t),w(ya.$$.fragment,t),w(wa.$$.fragment,t),w($a.$$.fragment,t),w(xa.$$.fragment,t),w(qa.$$.fragment,t),w(ja.$$.fragment,t),w(Ma.$$.fragment,t),w(Ca.$$.fragment,t),w(Ia.$$.fragment,t),w(en.$$.fragment,t),w(tn.$$.fragment,t),w(Da.$$.fragment,t),w(Sa.$$.fragment,t),w(Ka.$$.fragment,t),w(nn.$$.fragment,t),w(sn.$$.fragment,t),w(Va.$$.fragment,t),w(Ya.$$.fragment,t),w(tr.$$.fragment,t),w(rn.$$.fragment,t),w(dn.$$.fragment,t),w(or.$$.fragment,t),w(nr.$$.fragment,t),w(cn.$$.fragment,t),w(lr.$$.fragment,t),w(pn.$$.fragment,t),w(hn.$$.fragment,t),w(cr.$$.fragment,t),w(pr.$$.fragment,t),w(mn.$$.fragment,t),w(Tr.$$.fragment,t),w(fn.$$.fragment,t),w(_n.$$.fragment,t),w(kr.$$.fragment,t),w(br.$$.fragment,t),w(Tn.$$.fragment,t),w(zr.$$.fragment,t),w(kn.$$.fragment,t),w(bn.$$.fragment,t),w(Er.$$.fragment,t),w(qr.$$.fragment,t),w(Fr.$$.fragment,t),w(yn.$$.fragment,t),w(wn.$$.fragment,t),w(jr.$$.fragment,t),w(xn.$$.fragment,t),w(Mr.$$.fragment,t),w(En.$$.fragment,t),w(Cr.$$.fragment,t),w(Ar.$$.fragment,t),w(Pr.$$.fragment,t),w(Fn.$$.fragment,t),w(jn.$$.fragment,t),w(Or.$$.fragment,t),w(Cn.$$.fragment,t),w(Lr.$$.fragment,t),w(Pn.$$.fragment,t),w(Nr.$$.fragment,t),w(Ir.$$.fragment,t),w(Dr.$$.fragment,t),w(Ln.$$.fragment,t),uh=!0)},o(t){$(d.$$.fragment,t),$(ie.$$.fragment,t),$(rs.$$.fragment,t),$(is.$$.fragment,t),$(ls.$$.fragment,t),$(ps.$$.fragment,t),$(fs.$$.fragment,t),$(Ts.$$.fragment,t),$(ks.$$.fragment,t),$(bs.$$.fragment,t),$(vs.$$.fragment,t),$(ws.$$.fragment,t),$($s.$$.fragment,t),$(Fs.$$.fragment,t),$(Cs.$$.fragment,t),$(Os.$$.fragment,t),$(Vs.$$.fragment,t),$(Js.$$.fragment,t),$(oa.$$.fragment,t),$(ca.$$.fragment,t),$(pa.$$.fragment,t),$(ua.$$.fragment,t),$(ma.$$.fragment,t),$(Ta.$$.fragment,t),$(ba.$$.fragment,t),$(ya.$$.fragment,t),$(wa.$$.fragment,t),$($a.$$.fragment,t),$(xa.$$.fragment,t),$(qa.$$.fragment,t),$(ja.$$.fragment,t),$(Ma.$$.fragment,t),$(Ca.$$.fragment,t),$(Ia.$$.fragment,t),$(en.$$.fragment,t),$(tn.$$.fragment,t),$(Da.$$.fragment,t),$(Sa.$$.fragment,t),$(Ka.$$.fragment,t),$(nn.$$.fragment,t),$(sn.$$.fragment,t),$(Va.$$.fragment,t),$(Ya.$$.fragment,t),$(tr.$$.fragment,t),$(rn.$$.fragment,t),$(dn.$$.fragment,t),$(or.$$.fragment,t),$(nr.$$.fragment,t),$(cn.$$.fragment,t),$(lr.$$.fragment,t),$(pn.$$.fragment,t),$(hn.$$.fragment,t),$(cr.$$.fragment,t),$(pr.$$.fragment,t),$(mn.$$.fragment,t),$(Tr.$$.fragment,t),$(fn.$$.fragment,t),$(_n.$$.fragment,t),$(kr.$$.fragment,t),$(br.$$.fragment,t),$(Tn.$$.fragment,t),$(zr.$$.fragment,t),$(kn.$$.fragment,t),$(bn.$$.fragment,t),$(Er.$$.fragment,t),$(qr.$$.fragment,t),$(Fr.$$.fragment,t),$(yn.$$.fragment,t),$(wn.$$.fragment,t),$(jr.$$.fragment,t),$(xn.$$.fragment,t),$(Mr.$$.fragment,t),$(En.$$.fragment,t),$(Cr.$$.fragment,t),$(Ar.$$.fragment,t),$(Pr.$$.fragment,t),$(Fn.$$.fragment,t),$(jn.$$.fragment,t),$(Or.$$.fragment,t),$(Cn.$$.fragment,t),$(Lr.$$.fragment,t),$(Pn.$$.fragment,t),$(Nr.$$.fragment,t),$(Ir.$$.fragment,t),$(Dr.$$.fragment,t),$(Ln.$$.fragment,t),uh=!1},d(t){o(m),t&&o(k),t&&o(g),x(d),t&&o(je),t&&o(I),t&&o(Y),t&&o(X),x(ie),t&&o(Me),t&&o(S),t&&o(P),t&&o(_e),t&&o(Ce),t&&o(ge),t&&o(Ae),t&&o(A),t&&o(Z),t&&o(G),t&&o(pt),t&&o(oe),t&&o(Bc),t&&o(nt),t&&o(Uc),t&&o(Zr),t&&o(Wc),t&&o(Gt),t&&o(Rc),t&&o(Lo),t&&o(Hc),t&&o(Bt),t&&o(Kc),t&&o(ei),t&&o(Vc),t&&o(oo),x(rs),t&&o(Yc),t&&o(vt),t&&o(Zc),t&&o(Io),t&&o(Jc),t&&o(oi),t&&o(Xc),t&&o(be),t&&o(Qc),t&&o(si),t&&o(ep),x(is,t),t&&o(tp),t&&o(Do),t&&o(op),t&&o(ai),t&&o(np),t&&o(ri),t&&o(sp),x(ls,t),t&&o(ap),t&&o(ae),t&&o(rp),t&&o(Ut),t&&o(ip),t&&o(ve),t&&o(dp),x(ps,t),t&&o(lp),t&&o(ii),t&&o(cp),t&&o(di),t&&o(pp),t&&o(Wt),t&&o(hp),t&&o(So),t&&o(up),t&&o(li),t&&o(mp),t&&o(no),x(fs),t&&o(fp),t&&o(yt),t&&o(_p),x(Ts,t),t&&o(gp),t&&o(st),t&&o(Tp),t&&o(hi),t&&o(kp),x(ks,t),t&&o(bp),t&&o(ui),t&&o(vp),x(bs,t),t&&o(yp),t&&o(mi),t&&o(wp),t&&o(so),x(vs),t&&o($p),t&&o(wt),t&&o(xp),t&&o(ao),x(ws),t&&o(zp),t&&o(fi),t&&o(Ep),x($s,t),t&&o(qp),t&&o(Wo),t&&o(Fp),x(Fs,t),t&&o(jp),t&&o(_i),t&&o(Mp),x(Cs,t),t&&o(Cp),t&&o(gi),t&&o(Ap),x(Os,t),t&&o(Pp),t&&o(re),t&&o(Op),x(Vs,t),t&&o(Lp),t&&o(wi),t&&o(Np),x(Js,t),t&&o(Ip),t&&o(Kt),t&&o(Dp),x(oa,t),t&&o(Sp),t&&o(Ho),t&&o(Gp),t&&o(ia),t&&o(Bp),t&&o(Fi),t&&o(Up),t&&o(ro),x(ca),t&&o(Wp),t&&o(Dt),x(pa),t&&o(Rp),t&&o(lo),x(ua),t&&o(Hp),t&&o(le),x(ma),x(Ta),x(ba),x(ya),x(wa),t&&o(Kp),t&&o(co),x($a),t&&o(Vp),t&&o(Xe),x(xa),x(qa),x(ja),t&&o(Yp),t&&o(ho),x(Ma),t&&o(Zp),t&&o(Ee),x(Ca),x(Ia),x(en),x(tn),t&&o(Jp),t&&o(mo),x(Da),t&&o(Xp),t&&o(qe),x(Sa),x(Ka),x(nn),x(sn),t&&o(Qp),t&&o(_o),x(Va),t&&o(eh),t&&o(Fe),x(Ya),x(tr),x(rn),x(dn),t&&o(th),t&&o(To),x(or),t&&o(oh),t&&o(ce),x(nr),x(cn),x(lr),x(pn),x(hn),t&&o(nh),t&&o(bo),x(cr),t&&o(sh),t&&o(pe),x(pr),x(mn),x(Tr),x(fn),x(_n),t&&o(ah),t&&o(yo),x(kr),t&&o(rh),t&&o(he),x(br),x(Tn),x(zr),x(kn),x(bn),t&&o(ih),t&&o($o),x(Er),t&&o(dh),t&&o(ht),x(qr),x(Fr),x(yn),x(wn),x(jr),x(xn),x(Mr),x(En),t&&o(lh),t&&o(zo),x(Cr),t&&o(ch),t&&o(ut),x(Ar),x(Pr),x(Fn),x(jn),x(Or),x(Cn),x(Lr),x(Pn),t&&o(ph),t&&o(qo),x(Nr),t&&o(hh),t&&o(Fo),x(Ir),x(Dr),x(Ln)}}}const O$={local:"t5",sections:[{local:"overview",title:"Overview"},{local:"training",title:"Training"},{local:"inference",title:"Inference"},{local:"performance",title:"Performance"},{local:"resources",title:"Resources"},{local:"transformers.T5Config",title:"T5Config"},{local:"transformers.T5Tokenizer",title:"T5Tokenizer"},{local:"transformers.T5TokenizerFast",title:"T5TokenizerFast"},{local:"transformers.T5Model",title:"T5Model"},{local:"transformers.T5ForConditionalGeneration",title:"T5ForConditionalGeneration"},{local:"transformers.T5EncoderModel",title:"T5EncoderModel"},{local:"transformers.TFT5Model",title:"TFT5Model"},{local:"transformers.TFT5ForConditionalGeneration",title:"TFT5ForConditionalGeneration"},{local:"transformers.TFT5EncoderModel",title:"TFT5EncoderModel"},{local:"transformers.FlaxT5Model",title:"FlaxT5Model"},{local:"transformers.FlaxT5ForConditionalGeneration",title:"FlaxT5ForConditionalGeneration"},{local:"transformers.FlaxT5EncoderModel",title:"FlaxT5EncoderModel"}],title:"T5"};function L$(q){return l$(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class W$ extends a${constructor(m){super();r$(this,m,L$,P$,i$,{})}}export{W$ as default,O$ as metadata};
